;linebuf:
;+#08..#1f - 
;+#20,#23,#26,#29 -   linev
;+#40..#ff -  (8*)

jpbaseh=linebuf+#20
jpbasev=linebuf+#23
jpbaseuph=linebuf+#26
jpbaseupv=linebuf+#29

attrbase=linebuf+#08
pixbase=linebuf+#40

clip=1

;======= LINE filled =====

attrlineini
	ld h,jpbaseh/256
	ld de,tattrlineini
	ld c,8
attrlineini0
	ld l,jpbaseh&255
	ld b,4
attrlineini1
	ld (hl),#c3 ;jp
	inc l
	ld a,(de)
	ld (hl),a
	inc de
	inc l
	ld a,(de)
	ld (hl),a
	inc de
	inc l
	djnz attrlineini1
	inc h
	dec c
	jr nz,attrlineini0
	ret
;jpbaseh=linebuf+#00
;jpbasev=linebuf+#03
;jpbaseuph=linebuf+#06
;jpbaseupv=linebuf+#09

tattrlineini
	dw HORNH0,HORNV0,HORNUPH0,HORNUPV0
	dw HORNH1,HORNV1,HORNUPH1,HORNUPV1
	dw HORNH2,HORNV2,HORNUPH2,HORNUPV2
	dw HORNH3,HORNV3,HORNUPH3,HORNUPV3
	dw HORNH4,HORNV4,HORNUPH4,HORNUPV4
	dw HORNH5,HORNV5,HORNUPH5,HORNUPV5
	dw HORNH6,HORNV6,HORNUPH6,HORNUPV6
	dw HORNH7,HORNV7,HORNUPH7,HORNUPV7


	
attrline_swapcol
	if 1==0
	ld a,h
	cp d
	jr c,attrline ;
	ld a,lx
	ld lx,hx
	ld hx,a
	endif
	
; 

; :     (..      1  )
;!!!   y-!!!
;!       '`  .,
;          <  >
; :        

;hx= , lx= 
attrline

;   hx=lx
	ld a,hx
	xor lx
	add a,a
	ret z ;     bit7

	ld ly,-1 ; "  "

;   x
	ld a,l
	
	if 1==1 ; ,      de
	cp e
	;ret z
	jr nc,attrlinenxswap
	 ex de,hl
	 ld a,lx
	 ld lx,hx
	 ld hx,a
	 ld a,l ; 
attrlinenxswap
	endif
	 
	if 1==1
;test:  /     x
	;inc a
	and 7
	jr nz,$+3
	inc l
	ld a,e
	;inc a
	and 7
	jr nz,$+3
	inc e
	ld a,l
	endif

	;a=xright
	sub e ;a=dx
	ld c,a ;dx>=0
;  (  )
	ld a,h ;yright
	sub d ;yleft
	jr c,attrlineup
;

	ld b,lx
	ld lx,hx
	ld hx,b
	
;  
	ld b,a ;dy>=0
	cp c ;dx
	jr c,attrlineh ;dy<dx -  
attrlinev
;,  
;  
	call attrlinefindaddr
;lx=%00000nnn,  nnn=newcolor
	call hlattr
	ld d,b ;dy
;d= 
;c=dx
;b=dy
;    (    e)
	ld a,e
	and 7
 	add a,linebuf/256
	ld (attrlinevjp),a
;   
	ld a,l
	cpl
	and 7
	inc a
	ld e,a ;e=8..1    
;  
	xor a
	sub b ;dy
	rra ;xm:=256-(dy div 2) 
	exa
attrlinevjp=$+2
	jp jpbasev

attrlineh
;,  
;  
	call attrlinefindaddr
;lx=%00000nnn,  nnn=newcolor
	call hlattr
	ld d,c ;dx
;d= 
;c=dx
;b=dy
;    (    e)
	ld a,e
	and 7
 	add a,linebuf/256
	ld (attrlinehjp),a
;   
	ld a,l
	cpl
	and 7
	inc a
	ld e,a ;e=8..1    
;  
	xor a
	sub c ;dx
	rra ;mym:=256-(dx div 2) 
attrlinehjp=$+2
	jp jpbaseh

attrlineup
;
;    (..      1  )
; - . !
	;dec h
	;dec d
;  
	neg
	ld b,a ;dy>=0
	cp c ;dx
	jr c,attrlineuph ;dy<dx -  
attrlineupv
;,  
;  
	call attrlinefindaddr
;lx=%00000nnn,  nnn=newcolor
	call hlattr
	ld d,b ;dy
;d= 
;c=dx
;b=dy
;    (    e)
	ld a,e
	and 7
 	add a,linebuf/256
	ld (attrlineupvjp),a
;   
	ld a,l
	and 7
	inc a
	ld e,a ;e=8..1    
;  
	xor a
	sub b ;dy
	rra ;xm:=256-(dy div 2) 
	exa
attrlineupvjp=$+2
	jp jpbaseupv

attrlineuph
;,  
;  
	call attrlinefindaddr
;lx=%00000nnn,  nnn=newcolor
	call hlattr
	ld d,c ;dx
;d= 
;c=dx
;b=dy
;    (    e)
	ld a,e
	and 7
 	add a,linebuf/256
	ld (attrlineuphjp),a
;   
	ld a,l
	and 7
	inc a
	ld e,a ;e=8..1    
;  
	xor a
	sub c ;dx
	rra ;mym:=256-(dx div 2) 
attrlineuphjp=$+2
	jp jpbaseuph

; 	
;   



;####################### C L I P ###########################

	macro CLIP
	if clip
;y=#80..#ff: linebuf
;y=#00..#7f: ROM
	;ld a,l
	;rra
;y=#40..#ff: linebuf
;y=#00..#3f: ROM
	ld a,l
	;add a,-100 ;-1..-255
	;ld l,a
	;jr nc,$+4
	add a,-(pixbase&255)
	sbc a,a ;C(#ff)=, NC(#00)= 
	;rra
	xor h
	if linebuf==#6000
	and %01000000 ;      #6000
	else
	and %11000000 ;      #c000+
	endif
	xor h
	ld h,a
	endif
	endm

attrlinefindaddr
;  
	ld a,d ;yleft
curyshift=$+1
	add a,255&(pixbase-ybaseskip)
	ld l,a
	ld a,e ;xleft
	rra
	rra
	rra
	and #1f
	add a,linebuf/256
	ld h,a
	CLIP
	ret

	if 1==0
;a=x
	and 7
	jp pe,linexeven ;    
;a=%001/%010/%100/%111
	dec a
	jr z,linex1
	cp 4
	jr z,linex4
	jp nc,linex7
linex2

linexeven
;a=%000/%011/%101/%110
	jr z,linex0
	cp 5
	jr z,linex5
	jp nc,linex6
linex3
	endif




; :
HORNV0Q
	dec d
	ret z
	exa
HORNV0u
HORNV0  
	;ld a,(hl)
	;xor #00 ;pixel
	;ld (hl),a
	inc l ;next y
	dec e
	call z,linechrdown
	exa
	ADD A,c ;xm:=xm+dx
	JR NC,HORNV0Q ;this pixel
	SUB b ;xm:=xm-dy {dy<>0!!!}
;next pixel
HORNV1Q
	dec d
	ret z
	exa
HORNV1  
	ld a,(hl)
	xor #80 ;pixel
	ld (hl),a
	inc l ;next y
	dec e
	call z,linechrdown
	exa
	ADD A,c ;xm:=xm+dx
	JR NC,HORNV1Q ;this pixel
	SUB b ;xm:=xm-dy {dy<>0!!!}
;next pixel
HORNV2Q
	dec d
	ret z
	exa
HORNV2
	ld a,(hl)
	xor #c0 ;pixel
	ld (hl),a
	inc l ;next y
	dec e
	call z,linechrdown
	exa
	ADD A,c ;xm:=xm+dx
	JR NC,HORNV2Q ;this pixel
	SUB b ;xm:=xm-dy {dy<>0!!!}
;next pixel
HORNV3Q
	dec d
	ret z
	exa
HORNV3  
	ld a,(hl)
	xor #e0 ;pixel
	ld (hl),a
	inc l ;next y
	dec e
	call z,linechrdown
	exa
	ADD A,c ;xm:=xm+dx
	JR NC,HORNV3Q ;this pixel
	SUB b ;xm:=xm-dy {dy<>0!!!}
;next pixel
HORNV4Q
	dec d
	ret z
	exa
HORNV4  
	ld a,(hl)
	xor #f0 ;pixel
	ld (hl),a
	inc l ;next y
	dec e
	call z,linechrdown
	exa
	ADD A,c ;xm:=xm+dx
	JR NC,HORNV4Q ;this pixel
	SUB b ;xm:=xm-dy {dy<>0!!!}
;next pixel
HORNV5Q
	dec d
	ret z
	exa
HORNV5  
	ld a,(hl)
	xor #f8 ;pixel
	ld (hl),a
	inc l ;next y
	dec e
	call z,linechrdown
	exa
	ADD A,c ;xm:=xm+dx
	JR NC,HORNV5Q ;this pixel
	SUB b ;xm:=xm-dy {dy<>0!!!}
;next pixel
HORNV6Q
	dec d
	ret z
	exa
HORNV6 
	ld a,(hl)
	xor #fc ;pixel
	ld (hl),a
	inc l ;next y
	dec e
	call z,linechrdown
	exa
	ADD A,c ;xm:=xm+dx
	JR NC,HORNV6Q ;this pixel
	SUB b ;xm:=xm-dy {dy<>0!!!}
;next pixel
HORNV7Q
	dec d
	ret z
	exa
HORNV7  
	ld a,(hl)
	xor #fe ;pixel
	ld (hl),a
	inc l ;next y
	dec e
	call z,linechrdown
	exa
	ADD A,c ;xm:=xm+dx
	JR NC,HORNV7Q ;this pixel
	SUB b ;xm:=xm-dy {dy<>0!!!}
;next pixel
	exa
	call linechrright ;   (8..1 ), inc h,  
	dec d
	ret z
	jp HORNV0u


; :
HORNH0
	ADD A,b ;mym:=mym+dy
	JR NC,HORNH0Q
	SUB c ;mym:=mym-dx
	exa
	;ld a,(hl)
	;xor #00 ;pixel
	;ld (hl),a
	inc l ;next y
	dec e
	call z,linechrdown
	exa
HORNH0Q
;next pixel
	dec d
	ret z
HORNH1
	ADD A,b ;mym:=mym+dy
	JR NC,HORNH1Q
	SUB c ;mym:=mym-dx
	exa
	ld a,(hl)
	xor #80 ;pixel
	ld (hl),a
	inc l ;next y
	dec e
	call z,linechrdown
	exa
HORNH1Q
;next pixel
	dec d
	ret z
HORNH2
	ADD A,b ;mym:=mym+dy
	JR NC,HORNH2Q
	SUB c ;mym:=mym-dx
	exa
	ld a,(hl)
	xor #c0 ;pixel
	ld (hl),a
	inc l ;next y
	dec e
	call z,linechrdown
	exa
HORNH2Q
;next pixel
	dec d
	ret z
HORNH3
	ADD A,b ;mym:=mym+dy
	JR NC,HORNH3Q
	SUB c ;mym:=mym-dx
	exa
	ld a,(hl)
	xor #e0 ;pixel
	ld (hl),a
	inc l ;next y
	dec e
	call z,linechrdown
	exa
HORNH3Q
;next pixel
	dec d
	ret z
HORNH4
	ADD A,b ;mym:=mym+dy
	JR NC,HORNH4Q
	SUB c ;mym:=mym-dx
	exa
	ld a,(hl)
	xor #f0 ;pixel
	ld (hl),a
	inc l ;next y
	dec e
	call z,linechrdown
	exa
HORNH4Q
;next pixel
	dec d
	ret z
HORNH5
	ADD A,b ;mym:=mym+dy
	JR NC,HORNH5Q
	SUB c ;mym:=mym-dx
	exa
	ld a,(hl)
	xor #f8 ;pixel
	ld (hl),a
	inc l ;next y
	dec e
	call z,linechrdown
	exa
HORNH5Q
;next pixel
	dec d
	ret z
HORNH6
	ADD A,b ;mym:=mym+dy
	JR NC,HORNH6Q
	SUB c ;mym:=mym-dx
	exa
	ld a,(hl)
	xor #fc ;pixel
	ld (hl),a
	inc l ;next y
	dec e
	call z,linechrdown
	exa
HORNH6Q
;next pixel
	dec d
	ret z
HORNH7
	ADD A,b ;mym:=mym+dy
	JR NC,HORNH7Q
	SUB c ;mym:=mym-dx
	exa
	ld a,(hl)
	xor #fe ;pixel
	ld (hl),a
	inc l ;next y
	dec e
	call z,linechrdown
	exa
HORNH7Q
;next pixel
	exa
	call linechrright ;   (8..1 ), inc h,  
	dec d
	ret z
	exa
	jp HORNH0


; :
HORNUPV0Q
	dec d
	jp z,pix0
	exa
HORNUPV0u
	;ld a,(hl)
	;xor #00 ;pixel
	;ld (hl),a
HORNUPV0  
	dec l ;next y
	dec e
	call z,linechrup
	exa
	ADD A,c ;xm:=xm+dx
	JR NC,HORNUPV0Q ;this pixel
	SUB b ;xm:=xm-dy {dy<>0!!!}
;next pixel
HORNUPV1Q
	dec d
	jp z,pix1
	exa
	ld a,(hl)
	xor #80 ;pixel
	ld (hl),a
HORNUPV1  
	dec l ;next y
	dec e
	call z,linechrup
	exa
	ADD A,c ;xm:=xm+dx
	JR NC,HORNUPV1Q ;this pixel
	SUB b ;xm:=xm-dy {dy<>0!!!}
;next pixel
HORNUPV2Q
	dec d
	jp z,pix2
	exa
	ld a,(hl)
	xor #c0 ;pixel
	ld (hl),a
HORNUPV2
	dec l ;next y
	dec e
	call z,linechrup
	exa
	ADD A,c ;xm:=xm+dx
	JR NC,HORNUPV2Q ;this pixel
	SUB b ;xm:=xm-dy {dy<>0!!!}
;next pixel
HORNUPV3Q
	dec d
	jp z,pix3
	exa
	ld a,(hl)
	xor #e0 ;pixel
	ld (hl),a
HORNUPV3  
	dec l ;next y
	dec e
	call z,linechrup
	exa
	ADD A,c ;xm:=xm+dx
	JR NC,HORNUPV3Q ;this pixel
	SUB b ;xm:=xm-dy {dy<>0!!!}
;next pixel
HORNUPV4Q
	dec d
	jp z,pix4
	exa
	ld a,(hl)
	xor #f0 ;pixel
	ld (hl),a
HORNUPV4  
	dec l ;next y
	dec e
	call z,linechrup
	exa
	ADD A,c ;xm:=xm+dx
	JR NC,HORNUPV4Q ;this pixel
	SUB b ;xm:=xm-dy {dy<>0!!!}
;next pixel
HORNUPV5Q
	dec d
	jp z,pix5
	exa
	ld a,(hl)
	xor #f8 ;pixel
	ld (hl),a
HORNUPV5  
	dec l ;next y
	dec e
	call z,linechrup
	exa
	ADD A,c ;xm:=xm+dx
	JR NC,HORNUPV5Q ;this pixel
	SUB b ;xm:=xm-dy {dy<>0!!!}
;next pixel
HORNUPV6Q
	dec d
	jp z,pix6
	exa
	ld a,(hl)
	xor #fc ;pixel
	ld (hl),a
HORNUPV6 
	dec l ;next y
	dec e
	call z,linechrup
	exa
	ADD A,c ;xm:=xm+dx
	JR NC,HORNUPV6Q ;this pixel
	SUB b ;xm:=xm-dy {dy<>0!!!}
;next pixel
HORNUPV7Q
	dec d
	jp z,pix7
	exa
	ld a,(hl)
	xor #fe ;pixel
	ld (hl),a
HORNUPV7  
	dec l ;next y
	dec e
	call z,linechrup
	exa
	ADD A,c ;xm:=xm+dx
	JR NC,HORNUPV7Q ;this pixel
	SUB b ;xm:=xm-dy {dy<>0!!!}
;next pixel
	exa
	call linechrupright ;   (8..1 ), inc h,  
	dec d
	jp z,pix0
	jp HORNUPV0u
	

pix0
	;ld a,(hl)
	;xor #00
	;ld (hl),a
	ret
pix1
	ld a,(hl)
	xor #80
	ld (hl),a
	ret
pix2
	ld a,(hl)
	xor #c0
	ld (hl),a
	ret
pix3
	ld a,(hl)
	xor #e0
	ld (hl),a
	ret
pix4
	ld a,(hl)
	xor #f0
	ld (hl),a
	ret
pix5
	ld a,(hl)
	xor #f8
	ld (hl),a
	ret
pix6
	ld a,(hl)
	xor #fc
	ld (hl),a
	ret
pix7
	ld a,(hl)
	xor #fe
	ld (hl),a
	ret
	
HORNUPH0
	;exa
	;ld a,(hl)
	;xor #00 ;pixel
	;ld (hl),a
	;exa
	jp HORNUPH0u
HORNUPH1
	exa
	ld a,(hl)
	xor #80 ;pixel
	ld (hl),a
	exa
	jp HORNUPH1u
HORNUPH2
	exa
	ld a,(hl)
	xor #c0 ;pixel
	ld (hl),a
	exa
	jp HORNUPH2u
HORNUPH3
	exa
	ld a,(hl)
	xor #e0 ;pixel
	ld (hl),a
	exa
	jp HORNUPH3u
HORNUPH4
	exa
	ld a,(hl)
	xor #f0 ;pixel
	ld (hl),a
	exa
	jp HORNUPH4u
HORNUPH5
	exa
	ld a,(hl)
	xor #f8 ;pixel
	ld (hl),a
	exa
	jp HORNUPH5u
HORNUPH6
	exa
	ld a,(hl)
	xor #fc ;pixel
	ld (hl),a
	exa
	jp HORNUPH6u
HORNUPH7
	exa
	ld a,(hl)
	xor #fe ;pixel
	ld (hl),a
	exa
	jp HORNUPH7u
	
	
; :
HORNUPH0u
	ADD A,b ;mym:=mym+dy
	JR NC,HORNUPH0Q
	SUB c ;mym:=mym-dx
	exa
	;ld a,(hl)
	;xor #00 ;pixel
	;ld (hl),a
	dec l ;next y
	dec e
	call z,linechrup
	exa
HORNUPH0Q
;next pixel
	dec d
	jp z,pix1
HORNUPH1u
	ADD A,b ;mym:=mym+dy
	JR NC,HORNUPH1Q
	SUB c ;mym:=mym-dx
	exa
	ld a,(hl)
	xor #80 ;pixel
	ld (hl),a
	dec l ;next y
	dec e
	call z,linechrup
	exa
HORNUPH1Q
;next pixel
	dec d
	jp z,pix2
HORNUPH2u
	ADD A,b ;mym:=mym+dy
	JR NC,HORNUPH2Q
	SUB c ;mym:=mym-dx
	exa
	ld a,(hl)
	xor #c0 ;pixel
	ld (hl),a
	dec l ;next y
	dec e
	call z,linechrup
	exa
HORNUPH2Q
;next pixel
	dec d
	jp z,pix3
HORNUPH3u
	ADD A,b ;mym:=mym+dy
	JR NC,HORNUPH3Q
	SUB c ;mym:=mym-dx
	exa
	ld a,(hl)
	xor #e0 ;pixel
	ld (hl),a
	dec l ;next y
	dec e
	call z,linechrup
	exa
HORNUPH3Q
;next pixel
	dec d
	jp z,pix4
HORNUPH4u
	ADD A,b ;mym:=mym+dy
	JR NC,HORNUPH4Q
	SUB c ;mym:=mym-dx
	exa
	ld a,(hl)
	xor #f0 ;pixel
	ld (hl),a
	dec l ;next y
	dec e
	call z,linechrup
	exa
HORNUPH4Q
;next pixel
	dec d
	jp z,pix5
HORNUPH5u
	ADD A,b ;mym:=mym+dy
	JR NC,HORNUPH5Q
	SUB c ;mym:=mym-dx
	exa
	ld a,(hl)
	xor #f8 ;pixel
	ld (hl),a
	dec l ;next y
	dec e
	call z,linechrup
	exa
HORNUPH5Q
;next pixel
	dec d
	jp z,pix6
HORNUPH6u
	ADD A,b ;mym:=mym+dy
	JR NC,HORNUPH6Q
	SUB c ;mym:=mym-dx
	exa
	ld a,(hl)
	xor #fc ;pixel
	ld (hl),a
	dec l ;next y
	dec e
	call z,linechrup
	exa
HORNUPH6Q
;next pixel
	dec d
	jp z,pix7
HORNUPH7u
	ADD A,b ;mym:=mym+dy
	JR NC,HORNUPH7Q
	SUB c ;mym:=mym-dx
	exa
	ld a,(hl)
	xor #fe ;pixel
	ld (hl),a
	dec l ;next y
	dec e
	call z,linechrup
	exa
HORNUPH7Q
;next pixel
	exa
	call linechrupright ;   (8..1 ), inc h,  
	dec d
	jp z,pix0
	exa
	jp HORNUPH0u
;      

	
; (   )    ,     (   )    ,  ,   ,  .
linechrright
;   (8..1 ), inc h,  	
	push bc
	push hl
	ld a,ly
	or a
	jr z,linechrrightinvz ;  ; !!!
; 
; ???,   
	bit 0,(hl)
	jr z,linechrrightinvz ;  
	push hl
;todo  ?
	ld a,l
	and #f8
	ld l,a
	ld b,8
linechrrightinv0
	ld a,(hl)
	cpl
	ld (hl),a
	inc l ;next y
	djnz linechrrightinv0
	pop hl
	;jr linechrrightinvq ; !
linechrrightinvz
	ld b,e ;e=8..1    
linechrrightinv1
	ld a,(hl)
	cpl
	ld (hl),a
	inc l ;next y
	djnz linechrrightinv1
linechrrightinvq
	pop hl
;   
	inc h ;next x
	 CLIP ;test
	call hlattr
	pop bc
;e=8..1    
;d=   
	ret
	
; (   )    ,     (   )    ,  ,   ,  .
linechrupright
;   (8..1 ), inc h,  	
	push bc
	push hl
	ld a,ly
	or a
	jr z,linechruprightinvz ; 
; 
; ???,   
	 ;inc hl ;test: previous y
	bit 0,(hl)
	 ;dec hl ;test
	jr z,linechruprightinvz ;  
	push hl
;todo  ?
	ld a,l
	and #f8
	ld l,a
	ld b,8
linechruprightinv0
	ld a,(hl)
	cpl
	ld (hl),a
	inc l ;next y
	djnz linechruprightinv0
	pop hl
	;jr linechruprightinvq ; !
linechruprightinvz	
	ld b,e ;e=8..1    
	;dec b
	;jr z,linechruprightinvq
linechruprightinv1
	;dec l ;next y
	ld a,(hl)
	cpl
	ld (hl),a
	dec l ;next y
	djnz linechruprightinv1
linechruprightinvq
	pop hl
;   
	inc h ;next x
	 CLIP ;test
	call hlattr
	pop bc
;e=8..1    
;d=   
	ret
	
linechrup
;  
linechrdown
;  
	CLIP
	call hlattr
	ld e,8 ;e=8..1    
	ret


	if 1==0
linestart_hlattr
	push bc
	ld c,l
	srl l
	srl l
	srl l
;hl= 
;    
	call linestart_attr
	ld l,c
	pop bc
	ret
	endif

hlattr
	push bc
	ld c,l
	srl l
	srl l
	srl l
;hl= 
;    
	call _attr
	ld l,c
	pop bc
	ret

	if 1==0
linestart_attr
	ld a,(hl)
	or a
	jr z,attrempty_check
	ld ly,a ;  (!=0)
	xor hx ;newleftcolor
	and %00000111 ;  
	jr z,attrrswap
	ld a,(hl)
	 xor lx
	 and 6;#86
	 jr z,attrrclose
	ld a,(hl)
	 xor hx
	 and 6;#86
	 jr z,attrrswap
	endif

	
_attr
;lx=%rrr,  rrr=newrightcolor
;hx=%lll,  lll=newleftcolor
;    
;    %??lllrrr, invalidattr (=0)  bit7=0
;[ newrightcolor==oldrightcolor ( , ,      ),    ]
;  ,    
;  ,    
;    (    )
;  BGCOL  +#80
	ld a,(hl)
	or a
	jr z,attrempty;_check

;test:       BGCOL,     (   )
	ld a,hx
	xor BGCOL
	and %111
	jr nz,attrnleftborder
	ld a,(hl)
	rra
	rra
	rra
	xor hx ;newleftcolor
	and %111
	ret z ;jr z,attrlequal
attrnleftborder

	ld a,(hl)
	xor hx ;newleftcolor
	and %00000111 ;  
	jr z,attrrswap
	;cp lx ;newrightcolor
	;jr z,attrrequal
	ld a,(hl)
	 xor lx
	 and 6;#86
	 jr z,attrrclose
	ld a,(hl)
	 xor hx
	 and 6;#86
	 jr z,attrrswap
;attrnequal
;test:    (   )
	;ret
;  -   

attrnold
; (  ) ,    
;test:    (   )
	;ret
; ,      (?)
;      ,   (    )

	;jp attrcl

	if 1==0
;test:   ,     ( ,     - )
	ld a,lx ;newrightcolor = %rrr
	if BGCOL
	xor BGCOL
	endif
	and %111
	 jr z,attrcl ;   - 
attrROM
	ld a,(hl)
	and %00111000 ;  
	or lx ;newrightcolor = %rrr
	or %10000000
	ld (hl),a ;%10lllrrr
	if linebuf==#6000
	res 6,h ;ROM
	else
	ld a,h
	and #3f ;ROM
	ld h,a
	endif
	ret
	endif

;test:   [   ?]   (..     )      ,    ,  ,      !!!
	;jp attrcl
	;ld a,ly
	;inc a
	;jr nz,attrcl ;   
	ld a,(hl)
	and %00111000 ;  
	if BGCOL
	cp BGCOL*8
	endif
	 jr nz,attrcl ;   - 
	ld a,hx ;newleftcolor = %lll
	if BGCOL
	xor BGCOL
	endif
	and %111
	 jr z,attrcl ;   - 
	ld ly,1 ;  (!=0)
	;ld a,hx ;newleftcolor = %lll
	;and %111
	;rlca
	;rlca
	;rlca ;%lll000
	ld a,(hl)
	and %00111000 ;  
	or lx ;newrightcolor = %rrr
	or %10000000
	ld (hl),a ;%10lllrrr
	if linebuf==#6000
	res 6,h ;ROM
	else
	ld a,h
	and #3f ;ROM
	ld h,a
	endif
	ret

	if 1==0
attrempty_check
;test:  newleftcolor  ,  
;            ?
;    
	ld a,ly
	inc a
	jr nz,attrempty ;   
	ld a,hx ;newleftcolor = %lll
	and %111
	if BGCOL
	cp BGCOL*8
	endif
	jp nz,$
	jp attrempty
	endif

attrcl
;
	push hl
	ld a,l ; 
	add a,a
	add a,a
	add a,a
	ld l,a ; 
	xor a
	ld b,8
attrcl0
	ld (hl),a
	inc l ;next y
	djnz attrcl0
	pop hl
attrempty
; 
	ld ly,0 ;  (==0)
	jp attrchggo
attrchg
	ld ly,1 ;  (!=0)
attrchggo
	;dec h
	;ld a,(hl) ;%?????rrr  
	;inc h
	;xor hx ;newleftcolor = %lll
	ld a,hx ;newleftcolor = %lll
	and %111
	rlca
	rlca
	rlca ;%lll000
	or lx ;newrightcolor = %rrr
	or %10000000
	ld (hl),a ;%10lllrrr
;attrok
	ret
attrrclose
	;ld a,(hl)
	;rrca
	;rrca
	;rrca
	;and %00000111 ;  
	; xor hx
	; and #86
	;ret z ;    -   
	;jp attrnold
attrrequal
	ld a,(hl)
	rrca
	rrca
	rrca
	;and %00000111 ;  
	 xor hx
	 and 7;6;#86
	ret z ;    -   
	jp attrnold
attrrswap
	ld a,(hl)
	rrca
	rrca
	rrca
	;and %00000111 ;  
	 xor lx
	 and 7;6;#86
	jr z,attrchg ;newrightcolor==oldleftcolor:   
	jp attrnold


