;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ ROTATE VERTICES ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^


MULSIZE
        LD A,C
       IF optzero
       OR A
       LD H,A,L,A
       RET Z
       ENDIF 
        RLA 
        SBC A,A
        LD B,A
cursize=$+1
        LD A,127
		add a,a

;+-7 * 7 => +-7.8
;BC   A      HL
;MUL
        LD HL,1;0 ;1    (  H)
       DUP 7
        RLCA 
        jr nc,$+3
        ADD HL,BC
        ADD HL,HL
       EDUP 
        RLCA 
        RET NC
        ADD HL,BC
        RET 

;+-7 / 7 => +-7.8
;+L   D0     BC
DIV
;keep DE!
        LD A,L
        RLA 
        SBC A,A
        LD H,A
        jr nz,DIVNEG
DIVPOS
        ADD HL,HL
       DUP 8
        ADD HL,HL ;CY=0
        SBC HL,DE
        jr nc,$+3
        ADD HL,DE
        RLA 
       EDUP 
        CPL 
        LD B,A
       DUP 8
        ADD HL,HL ;CY=0
        SBC HL,DE
        jr nc,$+3
        ADD HL,DE
        RLA 
       EDUP 
        CPL 
        LD C,A
       INC BC ;good rounding
       SRL B
       RR C
        RET 
DIVNEG
        ADD HL,HL
       DUP 8
        ADD HL,HL
        ADD HL,DE ;HL<0, DE>0
        jr nc,$+5
        OR A
        SBC HL,DE
        RLA 
       EDUP 
        LD B,A
       DUP 8
        ADD HL,HL
        ADD HL,DE
        jr nc,$+5
        OR A
        SBC HL,DE
        RLA 
       EDUP 
        LD C,A
       INC BC ;good rounding
       SCF 
       RR B
       RR C
        RET 



		
		
ROTATE_VERTICES
curvert=$+1
       IF rotatebase
        LD HL,BASE_VERTICES
        LD IX,baserot
        LD B,3
; 
       ELSE ;~rotatebase
        LD ix,diamondvert;CUBE_VERTICES
        ;LD IX,VERTROT
        LD B,DIANVERT
; 
       ENDIF ;~rotatebase
ROTV0 ;
        PUSH BC
       IF rotatebase
        LD C,(HL)
        INC HL
        LD D,(HL)
        INC HL
        LD E,(HL)
        INC HL
        PUSH HL
        CALL ROTATE_VERTEX
        POP HL
        LD (IX),C ;x
        LD (IX+3),E ;y
		LD (IX+6),d ;z
        INC LX
       ELSE ;~rotatebase
        LD C,(ix)
        INC ix
        LD D,(ix)
        INC ix
        LD E,(ix)
        INC ix
        ;PUSH HL
        CALL ROTATE_VERTEX
	;ROTATE_VERTEX=5447:
;3*MULSIZE = 978
;3*ROTANGLE=3*1458
	;ROTANGLE:
;4*MULSIGNDE=4*300
        ;POP HL
	;sra c
	;sra e
	;sra d ;     ()
        LD (IX),e
        LD (IX+1),d
	;light=z?
	ld a,c ;z
		 add a,(ix+1)
		 ;sub ybase
		 add a,(ix)
		 ;sub xbase
		sra a
		add a,lbase
		 cpl
		ld (ix+2),a
		 and #0f ; ?
		 jr nz,$+5
		 inc (ix+2) ; ,   ,   intersect  

	ld a,d;c ;z
	sra a
	sra a
	;xor a
curzbase=$+1
	add a,zbase
	ld d,a
	ld e,0
	;dup 1
	;srl d
	;rr e
	;edup
	ld a,(ix) ;x
	call divz ;~1000 (430)
curxbase=$+1
	add a,xbase
	ld (ix),a
	ld a,(ix+1) ;y
	call divz ;~1000 (430)
curybase=$+1
	add a,ybase
	ld (ix+1),a

		ld de,2+1+(3*MAXEDGES)
		add ix,de

       ENDIF ;~rotatebase
        POP BC
        DJNZ ROTV0

		IF rotatebase
; 
	   LD ix,diamondvert;CUBE_VERTICES
        ;LD IX,VERTROT
        LD B,DIANVERT
ROTV1 ;
       ;PUSH BC
        LD C,(ix)
        INC ix
        LD D,(ix)
        INC ix
        LD E,(ix)
        INC ix

       ;PUSH HL
        LD HL,baserot

        MACRO AS axis,reg
    if reg==0
        LD A,(HL)
    else
        ADD A,(HL)
    endif
	if reg==0
        BIT 7,c
	endif	
	if reg==1
        BIT 7,d
	endif	
	if reg==2
        BIT 7,e
	endif	
        jr z,$+4
        SUB (HL)
        SUB (HL)
        INC L
        ENDM 

;    ,      +-  
        AS Xox,0;C
        AS Xoy,1;D
        AS Xoz,2;E
	sra a ;     ()
        LD (IX),A
        INC ix
        AS Yox,0;C
        AS Yoy,1;D
        AS Yoz,2;E
	sra a ;     ()
        LD (IX),A
        INC ix
		AS Zox,0;C
		AS Zoy,1;D
		AS Zoz,2;E
	sra a ;     ()

	;light=z?

	ld c,a ;z
		 add a,(ix-1)
		 ;sub ybase
		 add a,(ix-2)
		 ;sub xbase
		sra a
		add a,lbase
		 cpl
		ld (ix),a
		 and #0f ; ?
		 jr nz,$+5
		 inc (ix) ; ,   ,   intersect  

	ld a,c ;z
	sra a
	sra a
	;xor a
curzbase=$+1
	add a,zbase
	ld d,a
	ld e,0
	;dup 1
	;srl d
	;rr e
	;edup
	ld a,(ix-2) ;x
	call divz
curxbase=$+1
	add a,xbase
	ld (ix-2),a
	ld a,(ix-1) ;y
	call divz
curybase=$+1
	add a,ybase
	ld (ix-1),a

		;inc ix
		ld de,1+(3*MAXEDGES)
		add ix,de
	
       ;POP HL

       ;POP BC
        ;DJNZ ROTV1
	dec b
	jp nz,ROTV1
       ENDIF ;rotatebase
        RET 


divz
	if fastperspective==0

	;ld l,a
;+-7 / 7 => +-7.8
;+L   D0     BC 
	;push bc
	;call DIV
	;dup 6;5 ;   5,  !
	;sla c
	;rl b
	;edup
	;ld a,b
	;pop bc
	;ret
;+-7 / 7 => +-7.8
;+A   D0     BC
;DIVFAST
;    %nnnnnnYY YYYYYYnn
;keep DE!
	sra a
	ld h,a
	ld a,0
	rra
	ld l,a
	jp m,DIVFASTNEG
        ;LD A,L
        ;RLA 
        ;SBC A,A
        ;LD H,A
        ;jr nz,DIVFASTNEG
DIVFASTPOS
       ;DUP 7;6
       ; ADD HL,HL ;CY=0
       ;EDUP 
       DUP 8
        SBC HL,DE
        jr nc,$+3
        ADD HL,DE
        RLA 
        ADD HL,HL ;CY=0
       EDUP 
	   org $-1
	   cpl
        RET 
DIVFASTNEG
       ;DUP 7;6
       ; ADD HL,HL ;CY=0
       ;EDUP 
       DUP 8
        ADD HL,DE
        jr nc,$+5
        OR A
        SBC HL,DE
        RLA 
        ADD HL,HL
       EDUP 
	   org $-1
        RET 


	else ;faster perspective

	or a
	ret z
	jp m,divzneg
	ld l,a
	ld h,tlog/256
	;ret
	ld a,(hl)
	ld l,d ;z corrected
	sub (hl)
	ld l,a
	;ld h,2+(tlog/256)
	inc h
	ld a,(hl)
	inc h
	ld h,(hl)
	ld l,a
	dup 6;5 ;   5,  !
	add hl,hl
	edup
	ld a,h
	ret
divzneg
	neg
	ld l,a
	ld h,tlog/256
	;ret
	ld a,(hl)
	ld l,d ;z corrected
	sub (hl)
	ld l,a
	;ld h,2+(tlog/256)
	inc h
	ld a,(hl)
	inc h
	ld h,(hl)
	ld l,a
	dup 6;5 ;   5,  !
	add hl,hl
	edup
	xor a
	sub h
	ret

	endif ;faster perspective

ROTATE_VERTEX
        CALL MULSIZE ;n*0C
        PUSH HL
        LD C,D
        CALL MULSIZE ;n*0C
        LD D,H
        LD C,E
        CALL MULSIZE ;n*0C
        LD E,H
        POP BC
        LD C,B

		;sla c
		;sla d
		;sla e
		
;C,D,E = x,y,z
       ex de,hl
alpha=$+1
        LD DE,tsin
        LD B,L
        CALL ROTANGLE ;C,B>A,B
        ex af,af'
        LD L,B
beta=$+1
        LD E,255&(tsin+162)
        LD C,H,B,L
        CALL ROTANGLE ;C,B>A,B
        LD H,A,L,B
gamma=$+1
        LD E,255&(tsin+27)
        ex af,af'
        LD C,A
        LD B,H
        CALL ROTANGLE ;C,B>A,B
        LD C,A,H,B
       ex de,hl
        RET 

ROTANGLE
;C,B>A,B
;A = C*cos - B*sin
;B = B*cos + C*sin
       PUSH HL
        LD A,B
        LD L,A
        RLA 
        SBC A,A
        LD H,A
        LD A,C
        RLA 
        SBC A,A
        LD B,A
       PUSH BC ;C
       ;LD A,(DE) ;sin
        PUSH HL ;B
        CALL MULSIGNDE ;[B]C*A ;C*sin
        POP BC ;B
       PUSH HL ;C*sin
       ;LD A,(DE) ;sin
        PUSH BC ;B
        CALL MULSIGNDE ;[B]C*A ;B*sin
        POP BC ;B
        LD A,H,HY,A ;B*sin

        LD A,#40
        SUB E
        LD E,A ;cos
       ;LD A,(DE) ;cos
        CALL MULSIGNDE ;[B]C*A ;B*cos
       POP AF ;C*sin
       POP BC ;C
        ADD A,H
       PUSH AF
       ;LD A,(DE) ;cos
        CALL MULSIGNDE ;[B]C*A ;C*cos
        LD A,H
        SUB HY ;B*sin
       POP BC
       POP HL
        RET 

MULSIGNDE
       IF optzero
        LD A,B
        OR C
        LD H,A,L,A
        RET Z
       ENDIF ;optzero
        LD A,(DE)
MULSIGN
; checkvisibility
;+0.7 * +0.7 = +0.15
        ADD A,A
        jr nc,_MULPLUS
        LD L,A
        XOR A
        SUB C
        LD C,A
        SBC A,B
        SUB C
        LD B,A
        XOR A
        SUB L
_MULPLUS
;+0.7 * 0.7 = +0.15
;BC * A = HL
;badmul=$+1
        LD HL,1;0 ;1    (  H)
       DUP 7
        ADD A,A
        jr nc,$+3
        ADD HL,BC
        ADD HL,HL
       EDUP 
        RET 

       IF rotatebase;optzero
BASE_VERTICES
        DB sz,0,0
        DB 0,sz,0
        DB 0,0,sz
       ENDIF ;optzero

;_k=3-optzero
        ;MACRO DG
        ;DB \0*_k+1,\1*_k+1,\2*_k+1,\3*_k+1
        ;DB 'ttexture-(\4*8)
        ;DB \5
        ;ENDM 

;list of faces, each face = 4 vertices
;ttex nr
;attr
;clockwise
CUBE1
        ;DG 0,4,7,3,1,7
        ;DG 4,0,1,5,3,7
        ;DG 0,3,2,1,2,7
        ;DG 2,3,7,6,3,7
        ;DG 7,4,5,6,2,7
        ;DG 1,2,6,5,1,7
        ;DB -1
CUBE2
        ;DG 0,4,7,3,0,7
        ;DG 0,1,5,4,2,7
        ;DG 0,3,2,1,1,7
        ;DG 3,7,6,2,2,7
        ;DG 7,4,5,6,1,7
        ;DG 1,2,6,5,0,7
        ;DB -1

PLANE
PLANE1
        ;DG 0,1,5,4,3,4
        ;DG 4,5,1,0,3,4
        ;DB -1
PLANE2
        ;DG 0,1,5,4,0,#43
        ;DG 4,5,1,0,1,5
        ;DB -1

CUBE_VERTICES
;x,y,z
        DB sz,sz,sz
        DB sz,sz,-sz
        DB sz,-sz,-sz
        DB sz,-sz,sz

        DB -sz,sz,sz
        DB -sz,sz,-sz
        DB -sz,-sz,-sz
        DB -sz,-sz,sz

       IFN 0
PLANE_VERTICES
        DB 0,sz,sz
        DB 0,sz,-sz
        DB 0,-sz,-sz
        DB 0,-sz,sz

        DB sz,sz,0
        DB sz,-sz,0
        DB -sz,-sz,0
        DB -sz,sz,0
       ENDIF 
 

