unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Image1: TImage;
    Memo1: TMemo;
    CheckBox1: TCheckBox;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const
  HGT=384;

var
  NU1,NU2:byte;
  Form1: TForm1;
  bm: tbitmap;
  fin,fout: file of byte;
  tfin:text;
  scr1,scr2,outdata:array[0..32767]of byte;
  bigscr:array[0..31,0..HGT-1]of byte;
  bigattr:array[0..31,0..(HGT div 8)-1]of byte;
  curbyte:array[0..31]of byte;
  counter:array[0..31]of byte;
  used:array[0..255]of byte;
  poi:integer;

implementation

{$R *.dfm}

procedure wr(b:byte);
begin
  outdata[poi]:=b;
  Inc(poi);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
 iBytesRead:integer;
 x,y,dy,endy,yscr,addr:integer;
 b:byte;
 i,j:integer;
 ink,paper:TColor;
 written,howmany:integer;
 oldattr,newattr,oldink,oldpaper,newink,newpaper:byte;
 str:string;
 ch:char;
 down:boolean;
begin
  bm:=TBitMap.Create;
  bm.Width:=256;//Image1.Width;
  bm.Height:=HGT;//Image1.Height;
  bm.PixelFormat:=pf24bit;

  down:=CheckBox1.Checked;

//IMPORT FROM SCR
{
  AssignFile(fin,'skyscroll_end_top.scr');
  Reset(fin);
  BlockRead(fin, scr1, 6912);
  CloseFile(fin);

  AssignFile(fin,'skyscroll_end_bottom.scr');
  Reset(fin);
  BlockRead(fin, scr2, 6912);
  CloseFile(fin);

  for x:=0 to 31 do begin
    for y:=0 to HGT-1 do begin
      yscr:=y mod 192;
      addr:=x + (yscr div 64)*2048 + ((yscr mod 64)div 8)*32 + (yscr mod 8)*256;
      if y<192
      then bigscr[x,y]:=scr1[addr]
      else bigscr[x,y]:=scr2[addr];
      //if (bigscr[x,y]=NU1) or (bigscr[x,y]=NU2) then Memo1.Lines.Add('achtung');
    end;
    for y:=0 to (HGT div 8)-1 do begin
      yscr:=y mod 24;
      addr:=x + yscr*32 + 6144;
      if y<24
      then bigattr[x,y]:=scr1[addr]
      else bigattr[x,y]:=scr2[addr];
    end;
  end;
{}

//import from zxp
if(down)
then begin
 AssignFile(tfin,'skyscroll_night.zxp');
  NU1:=$c9; //$33;//$b6;
  NU2:=$9c;//$9c;
end
else begin
 AssignFile(tfin,'skyscroll_bez1.zxp');
  NU1:=$69; //$c9; //$33;//$b6;
  NU2:=$9d; //$33;//$d3;
end;
  Reset(tfin);
  readln(tfin,str);
  readln(tfin,str);
  for y:=0 to HGT-1 do begin
    for x:=0 to 31 do begin
      b:=0;
      for i:=0 to 7 do begin
        b:=b*2;
        read(tfin,ch);
        if ch='1' then inc(b);
      end;
      bigscr[x,y]:=b;
    end;
    readln(tfin,str);
  end;

  readln(tfin,str);
  for y:=0 to (HGT div 8)-1 do begin
    for x:=0 to 31 do begin
      b:=0;
      for i:=0 to 1 do begin
        b:=b*16;
        read(tfin,ch);
        if ch in ['0'..'9']
        then inc(b,ord(ch)-ord('0'))
        else inc(b,ord(ch)-ord('A')+10);
      end;
      bigattr[x,y]:=b;
      if x<>31 then read(tfin,ch);
    end;
    readln(tfin,str);
  end;

  CloseFile(tfin);


// 
  for x:=0 to 31 do begin
  oldattr:=0;
    for y:=0 to (HGT div 8)-1 do begin
      newattr:=bigattr[x,y];
      newink:=newattr and 7;
      newpaper:=(newattr shr 3)and 7;
      oldink:=oldattr and 7;
      oldpaper:=(oldattr shr 3)and 7;
      if (newink=oldpaper) or (newpaper=oldink)
      then begin
        newattr:=(newattr and 64) + (newink shl 3) + newpaper; // ink  paper
        for j:=0 to 7 do begin
          bigscr[x,y*8+j]:=255 xor bigscr[x,y*8+j]; // 
        end;
        bigattr[x,y]:=newattr;
      end;
      oldattr:=newattr;
    end;
  end;
{}

// NU1,NU2
  for i:=0 to 255 do used[i]:=0;
  for x:=0 to 31 do begin
    for y:=0 to HGT-1 do begin
      used[bigscr[x,y]]:=1;
    end;
  end;
  NU1:=0;
  NU2:=0;
  for i:=0 to 255 do begin
   if used[i]=0
   then begin
    NU1:=i;
    used[i]:=1;
    break;
   end;
  end;
  for i:=0 to 255 do begin
   if used[i]=0
   then begin
    NU2:=i;
    used[i]:=1;
    break;
   end;
  end;
  Memo1.Lines.Add('NU1='+IntToStr(NU1));
  Memo1.Lines.Add('NU2='+IntToStr(NU2));

//  NU1, NU2
  for x:=0 to 31 do begin
    for y:=0 to HGT-1 do begin
      if (bigscr[x,y]=NU1) then Memo1.Lines.Add('achtung NU1');
      if (bigscr[x,y]=NU2) then Memo1.Lines.Add('achtung NU2');
    end;
  end;


//  
  for x:=0 to 31 do begin
    for y:=0 to HGT-1 do begin
      b:=bigscr[x,y];
      for i:=0 to 7 do begin
        if b>=128
        then begin bm.Canvas.Pixels[x*8+i,y]:=$fffff; b:=b-128; end
        else bm.Canvas.Pixels[x*8+i,y]:=$000000;
        b:=b*2;
      end;
    end;
  end;
  //Image1.Picture.Assign(bm);
//with attr
    for x:=0 to 31 do begin
    for y:=0 to (HGT div 8)-1 do begin
     b:=bigattr[x,y];
     ink:=(b and 1)*$ff0000 + ((b shr 1) and 1)*$0000ff + ((b shr 2) and 1)*$00ff00;
     paper:=((b shr 3) and 1)*$ff0000 + ((b shr 4) and 1)*$0000ff + ((b shr 5) and 1)*$00ff00;
     for j:=0 to 7 do begin
      b:=bigscr[x,y*8+j];
      for i:=0 to 7 do begin
        if b>=128
        then begin bm.Canvas.Pixels[x*8+i,y*8+j]:=ink; b:=b-128; end
        else bm.Canvas.Pixels[x*8+i,y*8+j]:=paper;
        b:=b*2;
      end;
     end;
    end;
  end;
  //Image1.Picture.Assign(bm);

  //

  poi:=0;

  for x:=0 to 31 do counter[x]:=0;

if(down)
then begin
  y:=0;
  dy:=1;
  endy:=HGT;
end
else begin
  y:=HGT-1;
  dy:=-1;
  endy:=-1;
end;
  //repeat
  //for y:=HGT-1 downto 0 do begin
  while y<>endy do begin
    written:=0;
    for x:=0 to 31 do begin
      //  = 0, 
        //   0  255,  ,  
          // 1,   0  255 .
          // >1,   NU1  NU2,   -1,   = -1 (..  2,    1,  1 )
        //   
      // --
      if counter[x] = 0
      then begin
        b:=bigscr[x,y];
        if (b=0) or (b=255)
        then begin
          howmany:=0;
          i:=y;
          //for i:=y downto 0{to HGT-1} do begin
          while(i>=0)and(i<HGT) do begin
            if bigscr[x,i]<>b then break;
            Inc(howmany);
            i:=i+dy;
          end;
          //howmany:=1;
          if howmany=1
          then begin
            wr(b);
            Inc(written);
          end
          else begin
            if b=0 then wr(NU1) else wr(NU2);
            Inc(written);
            wr(howmany-1);
            Inc(written);
            counter[x]:=howmany-1;
          end;
        end
        else begin
          wr(b);
          Inc(written);
        end;
      end
      else //counter<>0
        Dec(counter[x]);
    end;
    y:=y+dy;
  end;
  //until(written=0);

if(down)
then AssignFile(fout,'skyscrdown.dat')
else AssignFile(fout,'skyscr.dat');
  Rewrite(fout);
  BlockWrite(fout, outdata, poi);
  CloseFile(fout);

  //
  for x:=0 to 31 do counter[x]:=0;

  poi:=0;
if(down)
then begin
  y:=0;
  dy:=1;
  endy:=HGT;
end
else begin
  y:=HGT-1;
  dy:=-1;
  endy:=-1;
end;
//  for y:=HGT-1 downto 0 do begin
  while y<>endy do begin
    for x:=0 to 31 do begin
      if counter[x] = 0
      then begin
        b:=outdata[poi];
        inc(poi);
        if (b=NU1) or (b=NU2)
        then begin
          if b=NU1 then curbyte[x]:=0 else curbyte[x]:=255;
          counter[x]:=outdata[poi];
          inc(poi);
          bigscr[x,y]:=curbyte[x];
        end
        else begin // 
          bigscr[x,y]:=b;
        end;
      end
      else begin
        bigscr[x,y]:=curbyte[x];
        Dec(counter[x]);
      end;
    end;
    y:=y+dy;
  end;

  //  
  for x:=0 to 31 do begin
    for y:=0 to HGT-1 do begin
      b:=bigscr[x,y];
      for i:=0 to 7 do begin
        if b>=128
        then begin bm.Canvas.Pixels[x*8+i,y]:=$fffff; b:=b-128; end
        else bm.Canvas.Pixels[x*8+i,y]:=$000000;
        b:=b*2;
      end;
    end;
  end;
  //Image1.Picture.Assign(bm);
//with attr
    for x:=0 to 31 do begin
if(down)
then begin
  y:=0;
  dy:=1;
  endy:=HGT;
end
else begin
  y:=HGT-1;
  dy:=-1;
  endy:=-1;
end;
//    for y:=0 to (HGT div 8)-1 do begin
  while y<>endy do begin
     b:=bigattr[x,y];
     ink:=(b and 1)*$ff0000 + ((b shr 1) and 1)*$0000ff + ((b shr 2) and 1)*$00ff00;
     paper:=((b shr 3) and 1)*$ff0000 + ((b shr 4) and 1)*$0000ff + ((b shr 5) and 1)*$00ff00;
     for j:=0 to 7 do begin
      b:=bigscr[x,y*8+j];
      for i:=0 to 7 do begin
        if b>=128
        then begin bm.Canvas.Pixels[x*8+i,y*8+j]:=ink; b:=b-128; end
        else bm.Canvas.Pixels[x*8+i,y*8+j]:=paper;
        b:=b*2;
      end;
     end;
    y:=y+dy;
    end; //y
  end; //x
  Image1.Picture.Assign(bm);

  poi:=0;
//  for y:=(HGT div 8)-1 downto 0 do begin
  for y:=0 to (HGT div 8)-1 do begin
    for x:=0 to 31 do begin
      wr(bigattr[x,y]);
    end
  end;

if(down)
then AssignFile(fout,'skyattrdown.dat')
else AssignFile(fout,'skyattr.dat');

  Rewrite(fout);
  BlockWrite(fout, outdata, poi);
  CloseFile(fout);

end;

end.

