	device pentagon1024

	if 1==1
IMVEC=#8000;#be00
IMSTACK=#8140;#bf40
ON_INT=#8181;#bfbf
STACK=ON_INT
	else
STACK=#dfdf;#5fe0;#be00
IMSTACK=#df40
IMVEC=#de00;#3bff
;IMVEC=#fe00;#be00
;IMER=#fdfd;#bfbf
	endif

linebuf=#e000;#6000 ;       #100  
linebufsz=#2000
linebufhgt=#c0
linebufwid=#20
eorbufwid=#20
;eorbufbrim=(linebufwid-eorbufwid)/2
linewid=#20 ;max

linebrim=#10 ;    X

evenx=1 ; x  , 0..255  -128..+382

lineattrbottom=0 ;NU

lineattrfill=1
carlinefast=1 ; drawscene (car)  7000 t
npop=1 ; eorfil     21318 t (22040 t  attr24=1)
attr24=1 ;    #24 (  #6400)

szvert=8;7 (7  512     12  ,   )

precise=1 ;    

timer=23728

basetime=(192*5);0
	
	org #a200

begin
	;ld (#5d10),a
	;ld (iy+1),#cc
	;ld sp,STACK

	jp prebegin
	
;=====================================
	if 1==0
	ds ON_INT-$
	;if IMVEC!=#3bff
wasimer
	disp ON_INT
	ld (imstack),sp
	ld sp,IMSTACK
	push af
	push bc
	push de
	push hl
	
	ld hl,(imstack)
	ld de,imjp
	ldi
	ldi
	ld (imstack),hl

	ld hl,(timer)
	inc hl
	ld (timer),hl
	;push de
	;push ix,iy
	;ld a,(curpg)
	;push af
	;ld a,pgmuz
	;call OUTA
	;;call muz+5
	;pop af
	;call OUTA
	;pop iy,ix
	;pop de
	pop hl
	pop de
	pop bc
	pop af
imstack=$+1
	ld sp,0
	ei
imjp=$+1
	jp 0
	;endif
timer
	dw 0
	ent
szimer=$-wasimer
	endif


	;ds #a000-$ ; 
maingo

mainloop
	; sin(a), cos(a),  
	ld a,(angle)
	ld h,a
	ld l,0
activeangle=$+1
	ld de,screenstartangle*256
	 or a
	sbc hl,de
	dup 3
	sra h
	rr l
	edup
	add hl,de
	ld (activeangle),hl
	ld a,h

curmcamx=$+1
	ld hl,-camx
curmcamy=$+1
	ld de,-camy
	if precise
	add hl,hl
	sla e
	rl d
	endif
	call sincos ;14000 t
	;  (),   
	ld hl,scene
	push hl
	call rotate_objects ;21000 t  10 , 28000 t  14 , 32000 t 
	;   ,     ,       
	pop hl ;ld hl,scene
	push hl
	call rotate_vertices ;23000 t  10 , 33000 t  14 , 40404 t  (16000 t   )
	if carlinefast
	ld de,drawobj
	endif
	pop hl ;ld hl,scene
	call drawscene ; 100000 t (62000 t   ) (80000 t  )
	;   drawn (          ,    ,       )
	xor a
	call cleardrawn
	
	;draw car
	if 1==1
carangle=$+1
	ld a,10
	ld a,(activeangle+1)
angle=$+1
	add a,startangle
	;add a,a
	add a,#80+10
	ld hl,0
	ld d,h,e,l
	call sincos_small ;3677 t
	ld hl,carscene
	push hl
	call rotate_objects ;1885 t
	pop hl ;ld hl,carscene
	push hl
	call rotate_vertices ;3683 t
	if carlinefast
	ld de,drawcarobj
	endif
	pop hl ;ld hl,carscene
	call drawscene ;20000 t

	else

	ld hl,linebuf+#1000+#8+12 ;center attr
	ld (hl),tinkcar/256
	ld hl,linebuf+#1000+#40+#60 ;center pix
	ld a,(hl)
	xor #80
	ld (hl),a
	inc l
	ld a,(hl)
	xor #80
	ld (hl),a

	endif
	
	call eorfill ;229471 t (155000 t  )
;      32   :
;430 t -   
;5256 t -   (  53/220 = 24% = 1264 t,  3992 t)
;1457 t - 
;  7143 t
	
	;move
	ld hl,(timer)
oldtimer=$+1
	ld de,0
	ld (oldtimer),hl
	or a
	sbc hl,de
	jp z,mainloop
	ld b,l
timeraction0
	push bc
	call moveall
	pop bc
	djnz timeraction0
	ld hl,(timer)
;endtimer=$+1
	ld de,basetime+(4*192)
	or a
	sbc hl,de
	jp c,mainloop
quit
	ld b,96+24+8;48
	halt
	djnz $-1
	
	xor a
	out (#fe),a
	ld hl,#5800
	ld de,#5801
	ld bc,#2ff
	ld (hl),l
	ldir
	
	ld iy,23610
	ld hl,10072
	exx
	im 1
	ret
	;jp $


moveall
	;ret

	;ld hl,angle
	;inc (hl)
	;ld (hl),-#50

cursteps=$+1
	ld a,1
	dec a
	jr nz,movetraj

curtrajendx=$+1
	ld hl,-camx
	ld (curmcamx),hl
curtrajendy=$+1
	ld hl,-camy
	ld (curmcamy),hl
curtrajenda=$+1
	ld a,startangle
	ld (curangle+1),a

curtrajaddr=$+1
	ld hl,trajectory
	;db steps
	ld a,(hl)
	inc hl
	or a
	jr nz,movenend
	 ret ;don't change
	 ;pop af ;moveall
	 ;jp quit
	 ;ld hl,trajectory
	 ;ld a,(hl)
	 ;inc hl
movenend
	;ld (cursteps),a
	push af

	;dw -(x-_trajx)*16/steps
	call movegetshift16
	ld (curtrajdxlow),a
	ld (curtrajdx),de
	;dw -(y-_trajy)*16/steps
	call movegetshift16
	ld (curtrajdylow),a
	ld (curtrajdy),de
	;dw (a-_traja)*256/steps
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	ld (curtrajda),de
	;      
	;dw -x
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	ld (curtrajendx),de
	;dw -y
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	ld (curtrajendy),de
	;db a
	ld a,(hl)
	inc hl
	ld (curtrajenda),a
	ld (curtrajaddr),hl

	pop af
movetraj
	ld (cursteps),a

	ld hl,(curmcamx)
	ld de,(curmcamy)

	if 1==0
	ld a,239
	in a,(254)
	rra
	rra
	jr nc,$+3
	dec de
	rra
	jr nc,$+3
	inc de
	rra
	jr nc,$+3
	inc hl
	rra
	jr nc,$+3
	dec hl
	endif


curtrajxlow=$+1
	ld a,#80
curtrajdxlow=$+1
	ld c,0
	add a,c
	ld (curtrajxlow),a
curtrajdx=$+1
	ld bc,0
	adc hl,bc
	ld (curmcamx),hl

	ex de,hl

curtrajylow=$+1
	ld a,#80
curtrajdylow=$+1
	ld c,0
	add a,c
	ld (curtrajylow),a
curtrajdy=$+1
	ld bc,0
	adc hl,bc
	ld (curmcamy),hl

curangle=$+1
	ld hl,startangle*256
curtrajda=$+1
	ld de,0
	add hl,de
	ld (curangle),hl
	ld a,h
	ld (angle),a

	;ret

movegetshift16
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	xor a
	dup 4
	sra d
	rr e
	rra
	edup
	ret


	if lineattrfill
	if npop
	include "eorfillattrfillnpop.asm"
	else
	include "eorfillattrfill.asm"
	endif
	else
	include "eorfillattr.asm"
	endif

	if lineattrfill
	include "vectorcarlineattrfill.asm"
	;  if  dup - sjasmplus  
	else
	include "vectorcarline.asm"
	endif

	include "vectorcarlogic.asm"
		

NOCOMMON
	db 0 ;not drawn ;>=#8000

cleardrawn
_deleter=cleardrawn
	ds 160;256
cleardrawnend

	macro VERTBEGIN
	if szvert==8
	ALIGN 8
	endif
	endm

	macro LASTEDGE
	dw #0100
	endm

	macro CARLASTEDGE
	if carlinefast
	dw #ff00
	else
	dw #0100
	endif
	endm

;INK 1 = black
;INK 2 = white
	macro INK par
	db tinktop/256+par-1
	endm

	macro CARINK par
	if carlinefast==0
	INK par
	endif
	endm

;   ,        (    )

;  -,   ,   (    ,   !)

;drawn (,   ),x,y,xscr,yscr
	macro VERT x,y
	db 0
	if szvert==8
	nop
	endif
	if x<_x
	db (-((_x-x)*_k/10))&255
	else
	db ((x-_x)*_k/10)&255
	endif
	if y<_y
	db (-((_y-y)*_k/10))&255
	else
	db ((y-_y)*_k/10)&255
	endif
	dw 0 ;db 0 ;xscr
	dw 0 ;db 0 ;yscr
	endm

;    (TODO    drawn)
	macro VERTD x,y
_org=$
	org _deleter
	ld (_org),a
_deleter=$
	if _deleter>(cleardrawnend-1) ;  ret
	DISPLAY "ERROR in cleardrawn!!!"
	endif
	org _org
	VERT x,y
	endm
	
;obj2,v1_double,v1,v2_double,v2
; obj2<>0,       (      )
; ,    (  ,   ,   )
	macro EDGE v1,v2,v1_double,v2_double,obj2,vert2
	;if v1_double&#8000 ;sjasmplus       
	;if v2_double&#8000
	;DISPLAY "common edge"
	dw obj2 ;   ,   
	;else
	;dw NOCOMMON
	;endif
	;else
	;dw NOCOMMON
	;endif

	if v1_double&#8000
	dw vert2+((-v1_double)*szvert)
	else
	dw _+(v1_double*szvert)
	endif
	dw _+(v1*szvert)

	if v2_double&#8000
	dw vert2+((-v2_double)*szvert)
	else
	dw _+(v2_double*szvert)
	endif
	dw _+(v2*szvert)

	endm

	macro CAREDGE v1,v2,v1_double,v2_double,obj2,vert2
	if carlinefast
	;db 0
	dw _+(v1*szvert)+szvert-4-256
	dw _+(v2*szvert)+szvert-4
	else
	EDGE v1,v2,v1_double,v2_double,obj2,vert2
	endif
	endm
	
;visible,addrverts,x,y,xscr,yscr,addredges
	macro OBJ addredges,addrverts,x,y
	db 0 ;visible
	dw addrverts
	if precise
	;DISPLAY (x)*2
	dw (x)*2
	dw (y)*2
	else
	dw x
	dw y
	endif
	dw 0 ;xscr
	dw 0 ;yscr
	dw addredges
	endm

	include "data.asm"

	display $," before ALIGN 256"
	ALIGN 256
;can't be under #8000 (check by jp p)
tinktop
	ds 512 ;ink0, ink7 (uses only +#20..#27)

	if lineattrbottom
tinkbottom
	ds 512 ;ink0bottom, ink7bottom
	endif
tinkcar
	ds 256,#07

activeend

prebegin
	dec h
	jr nz,linked
	ld hl,basetime
	ld (timer),hl
linked
	ld hl,wastsin
	ld de,tsin
	ld bc,#400
	ldir

	call mktline
	
	ld hl,tink
mktink0
	ld (hl),l
	ld a,l
	cp #07 ;white on black (car)
	jr nz,$+4
	ld (hl),#27 ;white on green
	inc l
	jr nz,mktink0
	;jp p,mktink0
mktink0fill
	;ld (hl),#24 ;paper=ink
	;inc l
	;jr nz,mktink0fill
	;inc h
	ld h,tinktop/256
mktink1
	ld (hl),#20
	inc l
	jr nz,mktink1
	;jp p,mktink1
mktink1fill
	;ld (hl),#24 ;paper=ink
	;inc l
	;jr nz,mktink1fill
	inc h
mktink2
	ld (hl),#27
	inc l
	jr nz,mktink2
	;jp p,mktink2
mktink2fill
	;ld (hl),#24 ;paper=ink
	;inc l
	;jr nz,mktink2fill

	;ds tinkcar+256-$
;	ld h,tinkcar/256
;mktinkcar
;	ld (hl),#07
;	inc l
;	jr nz,mktinkcar

	if 1==1
	
	ld (clstack),sp
	ld hl,(linebuf+(256*eorbufwid))&#ffff
	ld b,eorbufwid
cl0
	ld sp,hl
	ld de,0
	dup (linebufhgt+32)/2
	push de ;clear buffer
	edup
	ld de,257*tinkcode
	if attr24
	dup 24/2
	push de
	edup
	ld de,257*(tink/256)
	dup #20/8/2
	push de
	edup
	else ;~attr24
	dup (#20/8+24)/2
	push de
	edup
	endif
	dec h
	dec b
	jp nz,cl0
clstack=$+1
	ld sp,0
	
	else ;slow clear
	
	ld hl,linebuf
	ld de,linebuf+1
	ld bc,linebufsz-1
	ld (hl),l;0
	ldir
	
	ld h,linebuf/256
	ld c,#20
clatr0
	ld l,#04;#08 ;attr addr
	if attr24
	ld b,#20/8
clatr1top
	ld (hl),tink/256
	inc l
	djnz clatr1top
	ld b,24
	else ~attr24
	ld b,#20/8+24
	endif
clatr1
	ld (hl),tinkcode
	inc l
	djnz clatr1
	inc h
	dec c
	jr nz,clatr0

	endif
	
	;ei
	;halt
	ld hl,(timer)
	ld (oldtimer),hl
	;ld bc,3*64*4
	;add hl,bc
	;ld (endtimer),hl

	;ld bc,#5000
	;ld a,#64 ;= +200
	;call mulabc

	ld de,basetime
waitstart0
	halt
	ld hl,(timer)
	or a
	sbc hl,de
	jp c,waitstart0
	ld a,4
	out (#fe),a
	ld hl,#5800
	ld de,#5801
	ld bc,#2ff
	ld (hl),#24
	ldir

	jp maingo

mktline
	ld hl,tlineright
	ld de,linerightgo

	if evenx
	ld a,#5c
	ld b,+(linebrim*4)+(linewid*4)
mktlineright0
	call ldfind_ldeh2
	inc l
	djnz mktlineright0
;	ld b,linewid*4
;mktlineright1
;	ld (hl),e
;	inc h
;	ld (hl),d
;	dec h
;	call find_ldeh2
;	inc l
;	djnz mktlineright1
mktlineright2
	ld (hl),e
	inc h
	ld (hl),d
	dec h
	inc l
	jr nz,mktlineright2

	else ;~evenx
mktlineright
	ld (hl),e
	inc h
	ld (hl),d
	dec h
	call findldeh
	;dup 7
	;inc de
	;edup
	;ld a,(de)
	;cp #5c ;ld e,h
	;jr z,$+2+2+1+2
	; ld b,11
	; inc de
	; djnz $-1
	inc l
	jr nz,mktlineright
	endif ;~evenx

	ld hl,tlineleft+255
	ld de,lineleftgo

	if evenx
	ld a,#5c
	ld b,+(linebrim*4)+(linewid*4)
mktlineleft0
	call ldfind_ldeh2
	dec l
	djnz mktlineleft0
;	ld b,linewid*4
;mktlineleft1
;	ld (hl),e
;	inc h
;	ld (hl),d
;	dec h
;	call find_ldeh2
;	dec l
;	djnz mktlineleft1
mktlineleft2
	ld (hl),e
	inc h
	ld (hl),d
	dec h
	ld a,l
	dec l
	or a
	jr nz,mktlineleft2

	else ;~evenx
mktlineleft
	ld (hl),e
	inc h
	ld (hl),d
	dec h
	call find_ldeh
	;dup 7
	;inc de
	;edup
	;ld a,(de)
	;cp #5c ;ld e,h
	;jr z,$+2+2+1+2
	; ld b,11
	; inc de
	; djnz $-1
	ld a,l
	dec l
	or a
	jr nz,mktlineleft
	endif ;~evenx
	ret

	if evenx
ldfind_ldeh2
	ld (hl),e
	inc h
	ld (hl),d
	dec h
find_ldeh2
	inc de
	ex de,hl
	ld c,a
	cpir
	cpir
	ex de,hl
	dec de
	ret
	else
find_ldeh
	inc de
	ld a,(de)
	cp #5c ;ld e,h
	jr nz,find_ldeh
	ret
	endif

	;ALIGN 256
wastsin
	INCBIN "cos.$c!"
;tlog=tsin+256
	if evenx
	INCBIN "tlog_expdiv2" ;#100 log, #200 exp(L,H)
	else
	INCBIN "tlog" ;#100 log, #200 exp(L,H)
	endif

end

	org #6400
	if attr24
tinkcode=#24
tink;=#6400
	ds 256 ;don't change (todo  l=carattr  #27)
	else
tink
tinkcode=tink/256
	ds 256 ;don't change (todo  l=carattr  #27)
	endif

tmulsin
	ds 256 ;l*sin
	ds 256 ;l*cos
tlineleft;=tmulsin+#200
	ds 512 ;L,H
tlineright;=tlineleft+#200
	ds 512 ;L,H
tsin
	ds 256
tlog
	ds 256+512
lowend
;something rarely used can be moved here
;end

	org _deleter
	ret

	display "begin=",begin
	display "end=",end
	display "activeend=",activeend
	display "EOR-fill size ",/d,eorfillend-eorfill," bytes"
	display "Free after end=",/d,linebuf-#100-end
	display "Size ",/d,end-begin," bytes"
	display "Next part=",lowend,", size ",/d,#8000-lowend," bytes"
	
	savebin "purecode.c",begin,end-begin
	
	LABELSLIST "..\us\user.l"
