

mulabcsina
sina=$+1
	ld a,0
mulabc
;HL = BC * A
;+-15.0 = +-15.0 * +-.7
	;bit 7,a
	;jr nz,mulabcnega
	or a
	jp m,mulabcnega
	bit 7,b
	jr z,mulabcmain
mulabcnegbc
;a>=0, bc<0
	ld l,a
	xor a
	sub c
	ld c,a
	sbc a,b
	sub c
	ld b,a
	ld a,l
	call mulabcmain
	xor a
	sub l
	ld l,a
	sbc a,h
	sub l
	ld h,a
	ret
mulabcnega
;a<0
	bit 7,b
	jr nz,muladenegabc
;a<0, bc>=0
	neg
	call mulabcmain
	xor a
	sub l
	ld l,a
	sbc a,h
	sub l
	ld h,a
	ret
muladenegabc
;a<0, bc<0
	ld l,a
	xor a
	sub c
	ld c,a
	sbc a,b
	sub c
	ld b,a
	xor a
	sub l
mulabcmain
;a>=0, bc>=0
	ld hl,0
	dup 7
	rra
	jr nc,$+3
	add hl,bc
	rr h
	rr l
	edup
	;srl h
	;rr l ; , ..   *+-.7,   +-.8
	ret




;    16
;   8
;xscr = xrot+xscrobj = (xvertex*cos(a)+yvertex*sin(a))+xscrobj
;yscr = yrot+yscrobj = (yvertex*cos(a)-xvertex*sin(a))+yscrobj
;  l*sin(a), l*cos(a) (   )

sincosbeg
	ld (mcamx),hl
	ld (mcamy),de
	ld h,tsin/256 ; 
	ld l,a
	ld a,(hl) ;cos(a)
	ld (cosa),a
	ld a,#40
	sub l
	ld l,a
	ld a,(hl) ;sin(a)
	ld (sina),a
	add a,a
	ld c,a
	sbc a,a
	ld b,a ;-256..+254
	ld de,tmulsin
	ld hl,0
	ret

sincosinv
	xor a
	sub c
	ld c,a
	sbc a,b
	sub c
	ld b,a
	ld e,-1
	ld hl,0
	ret

sincos
	call sincosbeg
	call sincosppinc
;sincos_sin0
	;ld a,h
	;ld (de),a ;l*sin
	;add hl,bc
	;inc e
	;jp p,sincos_sin0
	call sincosinv
	call sincosppdec
;sincos_sin1
	;add hl,bc
	;ld a,h
	;ld (de),a ;l*sin
	;dec e
	;jp m,sincos_sin1

	ld a,(cosa)
	add a,a
	ld c,a
	sbc a,a
	ld b,a ;-256..+254
	ld de,tmulsin+256
	ld hl,0
	call sincosppinc
;sincos_cos0
	;ld a,h
	;ld (de),a ;l*cos
	;add hl,bc
	;inc e
	;jp p,sincos_cos0
	call sincosinv
;sincos_cos1
	;add hl,bc
	;ld a,h
	;ld (de),a ;l*cos
	;dec e
	;jp m,sincos_cos1
	;ret

sincosppdec
	call sincosppdecpp4
	dec e
sincosppdecpp4
	call sincosppdecpp2
	dec e
sincosppdecpp2
	call sincosppdecpp
	dec e
sincosppdecpp
	dup 16;32;128
	add hl,bc
	ld a,h
	ld (de),a ;l*sin  l*cos
	dec e
	edup
	org $-1
	ret
	
sincosppinc
	call sincosppincpp4
	add hl,bc
	inc e
sincosppincpp4
	call sincosppincpp2
	add hl,bc
	inc e
sincosppincpp2
	call sincosppincpp
	add hl,bc
	inc e
sincosppincpp
	dup 16;32;128
	ld a,h
	ld (de),a ;l*sin  l*cos
	add hl,bc
	inc e
	edup
	org $-2
	ret

;   
sincos_small
	call sincosbeg
	call sincosppincpp
	call sincosinv
	call sincosppdecpp

	ld a,(cosa)
	add a,a
	ld c,a
	sbc a,a
	ld b,a ;-256..+254
	ld de,tmulsin+256
	ld hl,0
	call sincosppincpp
	call sincosinv
	jp sincosppdecpp


	


;###################### rotate objects ###############################

; ,  xscr,yscr   
;     (x-camx)= -#200..+#200, (y-camy)= -#200..+#200
;(   #100..+#100 -      )
;visible=#80: 
rotate_objects
checkvisibility0
	;ld a,(hl)
	;cp #80
	;ret z
	 xor a
	 or (hl)
	 ret m
	ld (checkvisibilityaddr),hl
	ld (hl),0 ;  
	inc hl ;skip visible
	inc hl
	inc hl ;skip addrverts
	ld e,(hl)
	inc hl
	ld d,(hl) ;de=x
	inc hl
	ex de,hl
mcamx=$+1
	ld bc,-camx ;-camx
	add hl,bc
	ld a,h
	if precise
	 add a,2
	 cp 4
	else
	 inc a
	 cp 2
	endif
	jr nc,checkvisibilityskipx
	ld (rotatex),hl
	ex de,hl
	ld e,(hl)
	inc hl
	ld d,(hl) ;de=y
	ex de,hl
mcamy=$+1
	ld bc,-camy ;-camy
	add hl,bc
	ld a,h
	if precise
	 add a,2
	 cp 4
	else
	 inc a
	 cp 2
	endif
	jr nc,checkvisibilityskipy
	;ld (rotatey),hl
	ld b,h
	ld c,l
;xscr = rotatex*cos(a) + rotatey*sin(a)
;yscr = rotatey*cos(a) - rotatex*sin(a)

;rotatey=$+1
	;ld bc,0
	push bc ;rotatey
	call mulabcsina
	push hl ;rotatey*sin(a)
cosa=$+1
	ld a,0
rotatex=$+1
	ld bc,0
	call mulabc
	;hl=rotatex*cos(a)
	pop bc ;rotatey*sin(a)
	add hl,bc ;hl=xscr = rotatex*cos(a) + rotatey*sin(a)
	if precise
	sra h
	rr l
	endif
	
	;  
	; "      "
	;x,y = -#140..+#140
;(   #100..+#100 -      )
	 ld a,h
	 inc a
	 cp 2
	 jr nc,checkvisibility_extracheck_xfail

	ex de,hl
	inc hl
	ld (hl),e
	inc hl
	ld (hl),d
	ex de,hl

	ld bc,(rotatex)
	call mulabcsina
	;hl=rotatex*sin(a)
	pop bc ;rotatey
	push hl ;rotatey*sin(a)
	ld a,(cosa)
	;ld bc,(rotatey)
	call mulabc
	;hl=rotatey*cos(a)
	pop bc ;rotatey*sin(a)
	or a
	sbc hl,bc ;hl=yscr = rotatey*cos(a) - rotatex*sin(a)
	 ld bc,-#20
	 add hl,bc ;fix  16bit yscr  
	if precise
	sra h
	rr l
	endif

	;  
	; "      "
	;x,y = -#140..+#140
;(   #100..+#100 -      )
	 ld a,h
	 inc a
	 cp 2
	 jr nc,checkvisibility_extracheck_yfail

	ex de,hl
	inc hl
	ld (hl),e
	inc hl
	ld (hl),d
	inc hl

	ld a,1 ;visible
checkvisibilityaddr=$+1
	ld (0),a
	inc hl
	inc hl
	jp checkvisibility0
checkvisibilityskipx
	;skip y,xscr,yscr,addredges
	ld hl,8
	add hl,de
	jp checkvisibility0
checkvisibility_extracheck_xfail
	pop bc ;rotatey
checkvisibilityskipy
	;skip 1,xscr,yscr,addredges
	ld hl,1+6
	add hl,de
	jp checkvisibility0
checkvisibility_extracheck_yfail
	ld hl,1+4
	add hl,de
	jp checkvisibility0


;%%%%%%%%%%%%%%%%%%%%%%% rotate vertices %%%%%%%%%%%%%%%%%%%%%%%%%%%	
	
rotate_vertices
;   ,      
rotatevert0
	ld a,(hl) ;visible
	 ;cp #80
	 ;ret z
	or a
	jr z,rotatevertskip
	 ret m
	
	;ld bc,visible_road_e
	;or a
	;sbc hl,bc
	;add hl,bc
	;jr z,$

	ld (rotatevert_visibleaddr),hl
	inc hl ;skip visible
	ld e,(hl)
	inc hl
	ld d,(hl)
	;de=addrverts
	;skip 1, x,y
	ld bc,1+ 2+2
	add hl,bc
	;parse xscr,yscr
	ld a,(hl)
	ld (rotate_addxLSB),a ; +#80(xcenter)-#80
	inc hl
	ld a,(hl)
	ld (rotate_addxHSB),a ; +#80(xcenter)-#80
	inc hl
	ld a,(hl)
	ld (rotate_addyLSB),a ; +#60(ycenter)-#80
	inc hl
	ld a,(hl)
	ld (rotate_addyHSB),a ; +#60(ycenter)-#80
	inc hl
	push hl

;    8:
;de=    
;drawn,x,y,xrot,yrot
;#80=end
	ld h,tmulsin/256
	  ld hx,-1
	jp rotatevert1go
rotatevert1
	;xor a
	;ld (de),a ;  drawn (    cleardrawn)
	if szvert==8
	inc e
	inc e
	else
	inc de
	endif
	ld a,(de) ;x
	if szvert==8
	inc e
	else
	inc de
	endif
	ld c,a
	ld a,(de) ;y
	if szvert==8
	inc e
	else
	inc de
	endif
	ld l,a ;y
	ld a,(hl) ;y*sin(a)
	inc h
	ld b,(hl) ;y*cos(a)
	ld l,c ;x
	add a,(hl) ;x*cos(a)
	dec h
	 add a,#80 ;unsigned
rotate_addxLSB=$+1
	 add a,0
	ld (de),a ;xscr = y*sin(a)+x*cos(a)
	if szvert==8
	inc e
	else
	inc de
	endif
	 ld a,0
rotate_addxHSB=$+1
	 adc a,0
	 ld (de),a ;xscrHSB
	if szvert==8
	inc e
	else
	inc de
	endif
	ld a,b ;y*cos(a)
	sub (hl) ;x*sin(a)
	 add a,#80 ;unsigned
rotate_addyLSB=$+1
	 add a,0
	ld (de),a ;yscr = y*cos(a)-x*sin(a)
	if szvert==8
	inc e
	else
	inc de
	endif
	 ld a,0
rotate_addyHSB=$+1
	 adc a,0
	ld (de),a ;yscrHSB
	  and hx
	  ld hx,a ;,      y  
	 inc de ; ,         
rotatevert1go
	ld a,(de) ;drawn
	;cp #80 ;   or a,          
	;jp nz,rotatevert1
	 or a
	 jp p,rotatevert1
rotatevert_visibleaddr=$+1
	  ld hl,0
	  ld a,hx ;bit7:      y   (0=)
	  cpl
	  rlca
	  and 1
	  ld (hl),a ;visible

	pop hl
	;skip addredges
	inc hl
	inc hl
	jp rotatevert0
rotatevertskip
	;skip visible,addrverts, x,y,xscr,yscr, addredges
	ld bc,1+2+ 2+2+2+2 +2
	add hl,bc
	jp rotatevert0



;==================== draw scene ==========================

;     x= -#80..+#180, y= -#80..+#140 (  +#180)
;visible=#80: 
drawscene
	if carlinefast
	ld (drawobjcall),de
	endif
	;ld ly,2
drawscene0bc
drawscene0
	;ld a,ly
	;dec a
	;jr nz,drawsceneskip

	;ld a,(hl) ;visible
	;cp #80
	;ret z
	;or a
	 xor a
	 or (hl)
	;jr z,drawsceneskip
	jr nz,drawscenenskip ;
drawsceneskip
	;skip visible,addrverts, x,y,xscr,yscr, addredges
	ld bc,1+2+ 2+2+2+2 +2
	add hl,bc
	jp drawscene0
drawscenenskip
	 ret m
	ld bc,1+2+4+4
	add hl,bc ;skip visible,addrverts,x,y
	ld a,(hl)
	inc hl
	push hl
	ld h,(hl)
	ld l,a
	;hl=objaddr
drawobjcall=$+1
	call drawobj
	pop hl
	inc hl
	
	;dec ly
	;ret z
	
	jp drawscene0


drawobj
	;ld bc,obj_road_f
	;or a
	;sbc hl,bc
	;add hl,bc
	;jr nz,$+3
	;nop

;hl=obj
	ld a,(hl) ;INK
	ld lx,a
	if lineattrbottom
	add a,0+(tinkbottom-tinktop)/256
	ld hx,a
	endif
	inc hl
drawobj0
;  :
;obj2,v1_double,v1,v2_double,v2
;obj2<#8000: 
; obj2<>0,       (      )
; ,    (  ,   ,   )
	ld e,(hl)
	inc hl
	ld d,(hl)
	;de=obj2 (  visible_XXX  scene)
	ld a,d
	;cp #80
	;ret z
	or a
	 ;jr z,drawobj_nocommon ;  ,  (NOCOMMON)==0
	ret p
;    
; ,    (  ,   ,   )
	ld a,(de)
	or a
	jr nz,drawobj_skipobj2 ;  -  
drawobj_nocommon	
	inc hl
;  -,   ,   (    ,   !)
	ld e,(hl)
	inc hl
	ld d,(hl)
	;de=v1_double
	inc hl
	ld a,(de)
	or a ;drawn
	jr nz,drawobj_v1_double
	ld e,(hl)
	inc hl
	ld d,(hl)
	;de=v1
	ld a,1
	ld (de),a ;drawn
	jp drawobj_v1_ok
drawobj_v1_double
	inc hl
drawobj_v1_ok
	inc hl
;  -,   ,   (    ,   !)
	ld c,(hl)
	inc hl
	ld b,(hl)
	;bc=v2_double
	inc hl
	ld a,(bc)
	or a ;drawn
	jr nz,drawobj_v2_double
	ld c,(hl)
	inc hl
	ld b,(hl)
	;bc=v2
	ld a,1
	ld (bc),a ;drawn
	jp drawobj_v2_ok
drawobj_v2_double
	inc hl
drawobj_v2_ok
	inc hl
	push hl
;de,bc =   
	if szvert==8
	set 2,e
	set 2,c
	else
	inc de
	inc bc
	;de,bc   x,y,xscr,yscr
	inc de
	inc bc
	inc de
	inc bc
	;de,bc   xscr,yscr
	endif

	ld a,(bc)
	ld l,a
	if szvert==8
	inc c
	else
	inc bc
	endif
	ld a,(bc)
	ld h,a
	if szvert==8
	inc c
	else
	inc bc
	endif
	push hl ;xscr2
	ld a,(bc)
	ld l,a
	if szvert==8
	inc c
	else
	inc bc
	endif
	ld a,(bc)
	ld h,a
	push hl ;yscr2
	ex de,hl
	ld c,(hl)
	if szvert==8
	inc l
	else
	inc hl
	endif
	ld b,(hl) ;xscr1
	if szvert==8
	inc l
	else
	inc hl
	endif
	ld a,(hl)
	if szvert==8
	inc l
	else
	inc hl
	endif
	ld h,(hl)
	ld l,a ;yscr1
	pop de ;yscr2
	push bc ;xscr1
	exx
	pop hl ;xscr1
	pop de ;xscr2

;hl=x1
;de=x2
;hl'=y1
;de'=y2
; ,     x1HSB,x2HSB  0
	xor a
	cp h ;x1HSB
	jr z,$+3
	cp d ;x2HSB
	call z,line16xz
	pop hl
	jp drawobj0
drawobj_skipobj2
	;skip 1,v1_double,v1,v2_double,v2
	ld bc,1+2+2+2+2
	add hl,bc
	jp drawobj0



	if carlinefast
drawcarobj
;hl=obj
	;inc hl
	ld lx,tinkcar/256
drawcarobj0
;  :
;v1-256 (-256=end),v2
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc d
	ret z
	;de=v1
	inc hl
	ld c,(hl)
	inc hl
	ld b,(hl)
	;bc=v2
	inc hl
	push hl
;de,bc =   
;de,bc   xscr,yscr
	ex de,hl
	ld a,(bc)
	if szvert==8
	inc c
	inc c
	else
	inc bc
	inc bc
	endif
	add a,128
	rra ;-128..+383 => -64..+191 (0..255 => 0..128)
	ld e,a
	ld a,(bc)
	if szvert==8
	inc c
	else
	inc bc
	endif
	add a,64
	ld d,a
	ld c,(hl)
	if szvert==8
	inc l
	inc l
	else
	inc hl
	inc hl
	endif
	ld a,(hl)
	add a,64
	ld h,a ;y1
	ld a,c
	add a,128
	rra ;-128..+383 => -64..+191 (0..255 => 0..128)
	ld l,a
;hl,de=
;y  : 0..63  y=-64..-1, 64..255  y=0..191
;x  : 0..255  x = -128..+383
	call linefast
	pop hl
	jp drawcarobj0
	
	endif
	