

mulabc
;HL = BC * A
;+-15.0 = +-15.0 * +-.7
	bit 7,a
	jr nz,mulabcnega
	bit 7,b
	jr z,mulabcmain
mulabcnegbc
;a>=0, bc<0
	ld l,a
	xor a
	sub c
	ld c,a
	sbc a,b
	sub c
	ld b,a
	ld a,l
	call mulabcmain
	xor a
	sub l
	ld l,a
	sbc a,h
	sub l
	ld h,a
	ret
mulabcnega
;a<0
	bit 7,b
	jr nz,muladenegabc
;a<0, bc>=0
	neg
	call mulabcmain
	xor a
	sub l
	ld l,a
	sbc a,h
	sub l
	ld h,a
	ret
muladenegabc
;a<0, bc<0
	ld l,a
	xor a
	sub c
	ld c,a
	sbc a,b
	sub c
	ld b,a
	xor a
	sub l
mulabcmain
;a>=0, bc>=0
	ld hl,0
	dup 7
	rra
	jr nc,$+3
	add hl,bc
	rr h
	rr l
	edup
	;srl h
	;rr l ; , ..   *+-.7,   +-.8
	ret




;    16
;   8
;xscr = xrot+xscrobj = (xvertex*cos(a)+yvertex*sin(a))+xscrobj
;yscr = yrot+yscrobj = (yvertex*cos(a)-xvertex*sin(a))+yscrobj
;  l*sin(a), l*cos(a) (   )


sincos
angle=$+1
	ld a,0
	ld h,tsin/256 ; 
	ld l,a
	ld a,(hl) ;cos(a)
	ld (cosa),a
	ld a,#40
	sub l
	ld l,a
	ld a,(hl) ;sin(a)
	ld (sina),a
	add a,a
	ld c,a
	sbc a,a
	ld b,a ;-256..+254

	ld de,tmulsin
	ld hl,0
	call sincosppinc
;sincos_sin0
	;ld a,h
	;ld (de),a ;l*sin
	;add hl,bc
	;inc e
	;jp p,sincos_sin0
	xor a
	sub c
	ld c,a
	sbc a,b
	sub c
	ld b,a
	ld e,-1
	ld hl,0
	call sincosppdec
;sincos_sin1
	;add hl,bc
	;ld a,h
	;ld (de),a ;l*sin
	;dec e
	;jp m,sincos_sin1

	ld a,(cosa)
	add a,a
	ld c,a
	sbc a,a
	ld b,a ;-256..+254
	ld de,tmulsin+256
	ld hl,0
	call sincosppinc
;sincos_cos0
	;add hl,bc
	;ld a,h
	;ld (de),a ;l*cos
	;inc e
	;jp p,sincos_cos0
	xor a
	sub c
	ld c,a
	sbc a,b
	sub c
	ld b,a
	ld e,-1
	ld hl,0
;sincos_cos1
	;add hl,bc
	;ld a,h
	;ld (de),a ;l*cos
	;dec e
	;jp m,sincos_cos1
	;ret

sincosppdec
	call sincosppdecpp
	call sincosppdecpp
	call sincosppdecpp
sincosppdecpp
	dup 32;128
	add hl,bc
	ld a,h
	ld (de),a ;l*sin  l*cos
	dec e
	edup
	ret
	
sincosppinc
	call sincosppincpp
	call sincosppincpp
	call sincosppincpp
sincosppincpp
	dup 32;128
	add hl,bc
	ld a,h
	ld (de),a ;l*sin  l*cos
	inc e
	edup
	ret
	


;###################### rotate objects ###############################

; ,  xscr,yscr   
;     (x-camx)= -#200..+#200, (y-camy)= -#200..+#200
;visible=#80: 
rotate_checkvisibility
	ld hl,scene
checkvisibility0
	;ld a,(hl)
	;cp #80
	;ret z
	 xor a
	 or (hl)
	 ret m
	ld (checkvisibilityaddr),hl
	ld (hl),0 ;  
	inc hl ;skip visible
	inc hl
	inc hl ;skip addrverts
	ld e,(hl)
	inc hl
	ld d,(hl) ;de=x
	inc hl
	ex de,hl
mcamx=$+1
	ld bc,-camx ;-camx
	add hl,bc
	ld a,h
	add a,2
	cp 4
	jr nc,checkvisibilityskipx
	ld (rotatex),hl
	ex de,hl
	ld e,(hl)
	inc hl
	ld d,(hl) ;de=y
	ex de,hl
mcamy=$+1
	ld bc,-camy ;-camy
	add hl,bc
	ld a,h
	add a,2
	cp 4
	jr nc,checkvisibilityskipy
	;ld (rotatey),hl
	ld b,h
	ld c,l
;xscr = rotatex*cos(a) + rotatey*sin(a)
;yscr = rotatey*cos(a) - rotatex*sin(a)

sina=$+1
	ld a,0
;rotatey=$+1
	;ld bc,0
	push bc ;rotatey
	call mulabc
	push hl ;rotatey*sin(a)
cosa=$+1
	ld a,0
rotatex=$+1
	ld bc,0
	call mulabc
	;hl=rotatex*cos(a)
	pop bc ;rotatey*sin(a)
	add hl,bc ;hl=xscr = rotatex*cos(a) + rotatey*sin(a)

	;  
	; "      "
	;x,y = -#140..+#140
	 ld a,h
	 inc a
	 cp 2
	 jr nc,checkvisibility_extracheck_xfail

	ex de,hl
	inc hl
	ld (hl),e
	inc hl
	ld (hl),d
	ex de,hl

	ld a,(sina)
	ld bc,(rotatex)
	call mulabc
	;hl=rotatex*sin(a)
	pop bc ;rotatey
	push hl ;rotatey*sin(a)
	ld a,(cosa)
	;ld bc,(rotatey)
	call mulabc
	;hl=rotatey*cos(a)
	pop bc ;rotatey*sin(a)
	or a
	sbc hl,bc ;hl=yscr = rotatey*cos(a) - rotatex*sin(a)
	 ld bc,-#20
	 add hl,bc ;fix  16bit yscr  

	;  
	; "      "
	;x,y = -#140..+#140
	 ld a,h
	 inc a
	 cp 2
	 jr nc,checkvisibility_extracheck_yfail

	ex de,hl
	inc hl
	ld (hl),e
	inc hl
	ld (hl),d
	inc hl

	ld a,1 ;visible
checkvisibilityaddr=$+1
	ld (0),a
	inc hl
	inc hl
	jp checkvisibility0
checkvisibilityskipx
	;skip y,xscr,yscr,addredges
	ld hl,8
	add hl,de
	jp checkvisibility0
checkvisibility_extracheck_xfail
	pop bc ;rotatey
checkvisibilityskipy
	;skip 1,xscr,yscr,addredges
	ld hl,1+6
	add hl,de
	jp checkvisibility0
checkvisibility_extracheck_yfail
	ld hl,1+4
	add hl,de
	jp checkvisibility0


;%%%%%%%%%%%%%%%%%%%%%%% rotate vertices %%%%%%%%%%%%%%%%%%%%%%%%%%%	
	
rotate_initdrawn
;   ,      
	ld hl,scene
rotatevert0
	ld a,(hl) ;visible
	cp #80
	ret z
	or a
	jr z,rotatevertskip
	  ld (rotatevert_visibleaddr),hl
	inc hl ;skip visible
	ld e,(hl)
	inc hl
	ld d,(hl)
	;de=addrverts
	;skip 1, x,y
	ld bc,1+ 2+2
	add hl,bc
	;parse xscr,yscr
	ld a,(hl)
	ld (rotate_addxLSB),a ; +#80(xcenter)-#80
	inc hl
	ld a,(hl)
	ld (rotate_addxHSB),a ; +#80(xcenter)-#80
	inc hl
	ld a,(hl)
	ld (rotate_addyLSB),a ; +#60(ycenter)-#80
	inc hl
	ld a,(hl)
	ld (rotate_addyHSB),a ; +#60(ycenter)-#80
	inc hl
	push hl

;    8:
;de=    
;drawn,x,y,xrot,yrot
;#80=end
	ld h,tmulsin/256
	  ld hx,-1
	jp rotatevert1go
rotatevert1
	xor a
	ld (de),a ;  drawn
	inc de
	ld a,(de) ;x
	inc de
	ld c,a
	ld a,(de) ;y
	inc de
	ld l,a ;y
	ld a,(hl) ;y*sin(a)
	inc h
	ld b,(hl) ;y*cos(a)
	ld l,c ;x
	add a,(hl) ;x*cos(a)
	dec h
	 add a,#80 ;unsigned
rotate_addxLSB=$+1
	 add a,0
	ld (de),a ;xscr = y*sin(a)+x*cos(a)
	inc de
	 ld a,0
rotate_addxHSB=$+1
	 adc a,0
	 ld (de),a ;xscrHSB
	 inc de
	ld a,b ;y*cos(a)
	sub (hl) ;x*sin(a)
	 add a,#80 ;unsigned
rotate_addyLSB=$+1
	 add a,0
	ld (de),a ;yscr = y*cos(a)-x*sin(a)
	inc de
	 ld a,0
rotate_addyHSB=$+1
	 adc a,0
	ld (de),a ;yscrHSB
	  and hx
	  ld hx,a ;,      y  
	 inc de ; ,         
rotatevert1go
	ld a,(de) ;drawn
	cp #80 ;   or a,          
	jp nz,rotatevert1
rotatevert_visibleaddr=$+1
	  ld hl,0
	  ld a,hx ;bit7:      y   (0=)
	  cpl
	  rlca
	  and 1
	  ld (hl),a ;visible

	pop hl
	;skip addredges
	inc hl
	inc hl
	jp rotatevert0
rotatevertskip
	;skip visible,addrverts, x,y,xscr,yscr, addredges
	ld bc,1+2+ 2+2+2+2 +2
	add hl,bc
	jp rotatevert0



;==================== draw scene ==========================

;     x= -#80..+#180, y= -#80..+#140 (  +#180)
;visible=#80: 
drawscene
	ld hl,scene
drawscene0bc
drawscene0
	;ld a,(hl) ;visible
	;cp #80
	;ret z
	;or a
	 xor a
	 or (hl)
	;jr z,drawsceneskip
	jr nz,drawscenenskip ;
drawsceneskip
	;skip visible,addrverts, x,y,xscr,yscr, addredges
	ld bc,1+2+ 2+2+2+2 +2
	add hl,bc
	jp drawscene0
drawscenenskip
	 ret m
	ld bc,1+2+4+4
	add hl,bc ;skip visible,addrverts,x,y
	ld a,(hl)
	inc hl
	push hl
	ld h,(hl)
	ld l,a
	;hl=objaddr
	call drawobj
	pop hl
	inc hl
	jp drawscene0


drawobj
;hl=obj
	ld a,(hl) ;INK
	ld lx,a
	if lineattrbottom
	add a,0+(tinkbottom-tinktop)/256
	ld hx,a
	endif
	inc hl
drawobj0
;  :
;obj2,v1_double,v1,v2_double,v2
;obj2<#8000: 
; obj2<>0,       (      )
; ,    (  ,   ,   )
	ld e,(hl)
	inc hl
	ld d,(hl)
	;de=obj2 (  visible_XXX  scene)
	ld a,d
	;cp #80
	;ret z
	or a
	 ;jr z,drawobj_nocommon ;  ,  (NOCOMMON)==0
	ret p
;    
; ,    (  ,   ,   )
	ld a,(de)
	or a
	jr nz,drawobj_skipobj2 ;  -  
drawobj_nocommon	
	inc hl
;  -,   ,   (    ,   !)
	ld e,(hl)
	inc hl
	ld d,(hl)
	;de=v1_double
	inc hl
	ld a,(de)
	or a ;drawn
	jr nz,drawobj_v1_double
	ld e,(hl)
	inc hl
	ld d,(hl)
	;de=v1
	ld a,1
	ld (de),a ;drawn
	jp drawobj_v1_ok
drawobj_v1_double
	inc hl
drawobj_v1_ok
	inc hl
;  -,   ,   (    ,   !)
	ld c,(hl)
	inc hl
	ld b,(hl)
	;de=v2_double
	inc hl
	ld a,(bc)
	or a ;drawn
	jr nz,drawobj_v2_double
	ld c,(hl)
	inc hl
	ld b,(hl)
	;bc=v2
	ld a,1
	ld (bc),a ;drawn
	jp drawobj_v2_ok
drawobj_v2_double
	inc hl
drawobj_v2_ok
	inc hl
	push hl
;de,bc =   
	inc de
	inc bc
	;de,bc   x,y,xscr,yscr
	inc de
	inc bc
	inc de
	inc bc
	;de,bc   xscr,yscr

	ld a,(bc)
	ld l,a
	inc bc
	ld a,(bc)
	ld h,a
	inc bc
	push hl ;xscr2
	ld a,(bc)
	ld l,a
	inc bc
	ld a,(bc)
	ld h,a
	push hl ;yscr2
	ex de,hl
	ld c,(hl)
	inc hl
	ld b,(hl) ;xscr1
	inc hl
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a ;yscr1
	pop de ;yscr2
	push bc ;xscr1
	exx
	pop hl ;xscr1
	pop de ;xscr2

;hl=x1
;de=x2
;hl'=y1
;de'=y2
; ,     x1HSB,x2HSB  0
	xor a
	cp h ;x1HSB
	jr z,$+3
	cp d ;x2HSB
	call z,line16xz
	pop hl
	jp drawobj0
drawobj_skipobj2
	;skip 1,v1_double,v1,v2_double,v2
	ld bc,1+2+2+2+2
	add hl,bc
	jp drawobj0


