	if 1==0

;######### add lines  ######

;    :
;  
;  ( ) -  , 
;  
;   : , (  )
;  

;  TEdge = record
;    p1,p2: integer; //^TPoly;   visible
;    v1,v2: integer; //^TVertex (counted once from poly),   xscr,yscr,l
;    intersect: array[0..MAXLIGHT-1] of TIntersect; // 2  //   ,  intersect[MAXLIGHT]  
;  end;

addlines
	ld hl,diamondedge
	ld hy,DIANEDGE
addlines0
;hl=pointer to edge
	ld (addlines_edgeaddr),hl
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl ;de=p1 (^TPoly)
	ld a,(de)
	or a ;visible
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl ;de=p2 (^TPoly)
	jr nz,addlines_visible
	ld a,(de)
	or a
	jr z,addlines_invisible ;both polygons invisible: skip
addlines_visible	
	push hl ;pointer to v1
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl ;bc=v1 (^TVertex)
	ld a,(bc) ;x1 = v1.xscr
	ld e,a ;x1
	inc bc
	ld a,(bc) ;y1 = v1.yscr
	ld d,a ;y1
	inc bc
	;ld a,(bc) ;l1 = v1.l
	;ex af,af'
	ld (addlines_v1),bc

	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl ;bc=v2 (^TVertex)

	;push hl ;pointer to intersect[j]

	ld a,(bc) ;x2 = v2.xscr
	ld l,a ;x2
	inc bc
	ld a,(bc) ;y2 = v2.yscr
	ld h,a ;y2
	inc bc
	;ld a,(bc) ;l2 = v2.l
	;ld (addlines_v2),bc

	ld a,e
	cp l
	jr nc,$+2+3+1 ;e > l:  v1 
addlines_v1=$+1
	 ld bc,0
	 ex de,hl
	;hl=  (  bc), de=
	push bc ;   (  l)
	
	;   = f(abs(d-h)/(e-l))
	ld a,d
	sub h
	jr nc,$+2+2
	 neg
	ld c,l
	ld h,tlog/256
	ld l,a ;abs(d-h)
	ld b,(hl) ;log(abs(d-h)) = 0..#7f
	ld a,e
	sub c
	ld l,a
	 ld a,#ff
	 jr z,addlines_divzero
	ld a,b
	sub (hl) ;log(abs(d-h)/(e-l)) = (0..#7f)-(0..#7f) = -#7f..#7f
	add a,#80
addlines_divzero
	;a=  = 1..#ff (#ff =   ,    )
	
	pop hl ;   (  l)
	;inc hl ;skip l,  hl    (, )
	;dec hl ;inc  dec 
	dec hl
	dec hl ;  3  ,   add hl,3
	;,      
	; ,  (hl)<a
	ld bc,3
addlines0find
	add hl,bc
	cp (hl)
	jr c,addlines0find

	;
	; 
addlines_edgeaddr=$+1
	ld de,0
addlines0shift
	ld c,a
	ld a,(hl)
	ld (hl),c ; 
	inc hl
	ld c,(hl)
	ld (hl),e
	inc hl
	ld b,(hl)
	ld (hl),d
	inc hl
	ld d,b
	ld e,c
	or a ;cp invalidslope
	jp nz,addlines0shift ;  
	ld (hl),a ; (  ?     ?)
	
	;pop hl ;pointer to intersect[j]
	pop hl ;pointer to v1
	;jp addlines_ok
addlines_invisible
	ld de,2*2+(MAXLIGHT*2) ;skip v1,v2,intersect
	add hl,de
addlines_ok
	dec hy
	jp nz,addlines0
	ret




;============ sort vertices ===

; :
;x
;y
;z
;xscr
;yscr
;[l] -     
;1 ( , ) -   
;...
;MAX ( , )

;    :
;xscr ()
;

;       vert, ..         

	;if 1==0
sortvertices
	ld hl,tsort
	ld (hl),#ff ;
	ld (tsortend),hl
	ld hl,diamondvert+3 ;xscr
	ld hy,DIANVERT
SORTVERT0
	ld a,(hl) ;xscr
	push hl ;  xscr
	;   ,  
	; ,  (hl)>a
	ld hl,tsort-3
	ld bc,3
SORTVERT0FIND
	add hl,bc
	cp (hl)
	jr nc,SORTVERT0FIND
	ld b,h
	ld c,l
;bc= 
tsortend=$+1
	ld hl,0
	ld d,h
	ld e,l
	inc de
	inc de
	inc de
	ld (tsortend),de
	;ld a,DIANVERT
	;sub hy
	;ld c,a
	;add a,a
	;add a,c
	;ld c,a
	;ld b,0
	;inc bc
;bc= 
;hl=  (     )
;de=   (     )
	push hl
	or a
	sbc hl,bc
	ld b,h
	ld c,l
	inc bc ;min=1
	pop hl
	lddr
;hl =   - 1
	inc hl
	pop de ;  xscr
	ld (hl),a
	inc hl
	ld (hl),e
	inc hl
	ld (hl),d
	ld hl,szvert
	add hl,de
	dec hy
	jr nz,SORTVERT0
	ret
	;endif


;%%%%%%%%%%%%%%% draw colour vertices %%%%%%%%%%%%%%%%%%%	
;      xscr
;        

drawcolourvertices
	ld hl,tsort
	ld hy,DIANVERT
drawcolourvertices0

	if 1==0
	ld hl,diamondvert+3 ;xscr
	ld de,szvert
	ld ly,DIANVERT
drawcolourverticesfind0
	cp (hl)
	jr nz
	add hl,de
	dec ly
	jr nz,drawcolourverticesfind0
	endif

;hl=    tsort (   xscr)
	inc hl ;skip xscr
	ld a,(hl)
	inc hl
	push hl ;  HSB 
	ld h,(hl)
	ld l,a
;hl=    vert (  xscr)
	inc hl ;skip xscr
	inc hl ;skip yscr
	inc hl ;skip l
;hl    ( , )
;     (     , ..  )
;,    
drawcolourverticesedge0
	ld a,(hl)
	or a ;cp invalidslope
	jr z,drawcolourverticesedgeq
	ld (hl),0 ;invalidslope
	inc hl
	ld a,(hl)
	inc hl
	push hl ;  HSB 
	ld h,(hl)
	ld l,a
;hl=   (  p1)
	call drawedge

	pop hl ;  HSB 
	inc hl ;skip HSB,     
	jp drawcolourverticesedge0
drawcolourverticesedgeq
	
	pop hl ;  HSB 
	inc hl ;skip HSB,      
	dec hy
	jp nz,drawcolourvertices0
	ret


	endif ;NU

;&&&&&&&&&&&&&&&&&&& checkedgevisibility &&&&&&&&&&&&&&&&&&&&&&&&&&
;  ,   ,    drawedge 
;  
checkedgevisibility
	ld hl,diamondedge+(2*2) ;skip p1,p2
	ld hy,DIANEDGE
checkedgevisibility0
	push hl ;hl   v1
;hl   v1
	call getxy
;de=y1x1
;hl=y2x2
	 xor a
	 ld c,a ;invisible
	 sbc hl,de
	 add hl,de
	 jr z,checkedgevisibility_invisible ; !!!
	 ld a,d
	 cp h
	 ld a,#01 ;y1=y2:  ,  
	 jr z,checkedgevisibility_divzero
	ld a,e
	cp l
	 ld a,#ff ;x1=x2:  ,  
	 jr z,checkedgevisibility_divzero
	jr nc,$+2+1 ;e > l:  de(v1) 
	 ex de,hl
	;hl= , de=
	;   = f(abs(d-h)/(e-l))
	ld a,d
	sub h
	jr nc,$+2+2
	 neg
	ld c,l
	ld h,tlog/256
	ld l,a ;abs(d-h)
	ld b,(hl) ;log(abs(d-h)) = 0..#7f
	ld a,e
	sub c
	ld l,a
	 ;ld a,#ff
	 ;jr z,checkedgevisibility_divzero
	ld a,b
	sub (hl) ;log(abs(d-h)/(e-l)) = (0..#7f)-(0..#7f) = -#7f..#7f
	add a,#80
checkedgevisibility_divzero
	;a=  = 1..#ff (#ff =   ,    )
	ld c,1 ;visible
checkedgevisibility_invisible
	pop hl ;hl   v1
	inc hl
	inc hl
	inc hl
	inc hl
	ld (hl),c ;1=visible, 0=invisible
	inc hl
	ld (hl),a ;
	ld de,szedge-(2+2+1) ;v1,v2,visible
	add hl,de
	dec hy
	jp nz,checkedgevisibility0
	ret

	
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ draw edge ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;  intersect :
;+0: invisible(0)/visible(1)/drawn(2)
drawedge
;hl=   (  p1)
	push hl
	ld de,4*2 ;skip p1,p2,v1,v2
	add hl,de
	ld a,(hl)
	cp 1 ;visible, not drawn
	ld (hl),2 ;drawn
	pop hl
	ret nz ;,     
	
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	ld a,(de) ;p1.visible
	or a
	dec de
	ld a,(de) ;p1.l
	ld c,a ;p1.l
	jr nz,drawedge_p1visible
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
;hl   v1
	ld a,(de) ;p2.visible
	or a
	dec de
	ld a,(de) ;p2.l
	ld b,a ;p2.l

	if bw ;test:     
	push af
	ld a,c
	rra
	sbc a,a
	and 7
	ld c,a
	ld a,b
	rra
	sbc a,a
	and 7
	ld b,a
	pop af
	endif
	
	ret z ;jr z,drawedgeok ;   -   (   -    )
drawedge_p1invisiblep2visible
	; 2  (b), 1=BGCOL
;hl   v1
	call getxy
;de=y1x1
;hl=y2x2
	ld hx,b
	ld lx,BGCOL+#80
	jp attrline_swapcol ; ly
	;call attrline_swapcol ; ly
	;jp drawedgeok
drawedge_p1visible
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	ld a,(de) ;p2.visible
	or a
	dec de
	ld a,(de) ;p2.l
	ld b,a ;p2.l

	if bw ;test:     
	push af
	ld a,c
	rra
	sbc a,a
	and 7
	ld c,a
	ld a,b
	rra
	sbc a,a
	and 7
	ld b,a
	pop af
	endif

	jr nz,drawedge_visible
drawedge_p1visiblep2invisible
	; 1  (c), 2=BGCOL
;hl   v1
	call getxy
;de=y1x1
;hl=y2x2
	ld hx,BGCOL+#80
	ld lx,c
	jp attrline_swapcol ; ly
	;call attrline_swapcol ; ly
	;jp drawedgeok
drawedge_visible
	;    (b,c)
;hl   v1
	call getxy
;de=y1x1
;hl=y2x2
	ld hx,b
	ld lx,c
	jp attrline_swapcol ; ly
	;call attrline_swapcol ; ly
;drawedgeok
	;ret
	
	
getxy
;hl   v1
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
;de=v1 (  xscr)
	ex de,hl
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	ex de,hl
;de=y1x1
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
;hl=v2 (  xscr)
	ld a,(hl)
	inc hl
	;inc hl
	;ld (hl),2 ;drawn
	;dec hl
	ld h,(hl)
	ld l,a
;hl=y2x2
	ret

	
	
	if 1==1
;   ,         
;     ,    
;   ,  ,                
;      ,   

;  intersect :
;+0: invisible(0)/visible(1)/drawn(2)
;+1: 

drawcolouredges
	ld hl,diaedgebase ;  visible
	ld hy,DIANEDGE
drawcolouredges0
	push hl
	call drawedgerecursive ;           
	pop hl
	ld de,szedge
	add hl,de
	dec hy
	jp nz,drawcolouredges0
	ret



;          
; ,    ?
;[      -    ?]
;      (  ,   )
;[     ,    ( ),        ?]
;   =  ,   
;   =  ,   
;   ,       (),   ,   
;    (..   ),       (),   ,   
drawleftedges
;hl= (  visible)
;de= 1,     (  visible)
	ld a,(hl) ;.visible
	or a
	ret z ;invisible
;    
	 dup 3
	inc hl
	ld c,(hl)
	inc hl
	ld b,(hl)
;bc=e1,e2,e3 (  visible)
	ld a,c
	cp e
	jr nz,$+2+2+2 ;drawleftedges_noskip
	ld a,b
	cp d
	jr z,$+2+1 ;drawleftedges_skip (    -  )
;drawleftedges_noskip
;bc=e1,e2,e3 (  visible)
	push bc
;drawleftedges_skip
	 edup

;TODO   !!!
	ex de,hl
;hl= 1 (  visible)
;  xyleft,
	inc hl
	ld a,(hl) ;1
	ld hx,a ;ld (drawleftedges_slope1),a
	dec hl
	dec hl
	ld d,(hl)
	dec hl
	ld e,(hl)
;de=e1.v1 
	ex de,hl
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	ex de,hl ;de=e1.yx1
	dec hl
	ld a,(hl)
	dec hl
	ld l,(hl)
	ld h,a
;hl=e1.v2
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a ;hl=e1.yx2
	;ld a,l
	cp e
	jr c,$+2+1 ;l < e: hl=yxleft
	 ex de,hl ; hl=yxleft, de=yxright
	;ld (drawleftedges_xyleft1),hl
	;ld (drawleftedges_xyright1),de
;TODO
	
	ld b,h
	ld c,l
	;bc=xyleft1
	;de=xyright1
	;hx=slope1
	
	pop hl ;hl=2 (  visible)
	push bc
	push de
	push ix
	call drawleftedges_checkanddraw
	pop ix
	pop de
	pop bc
	pop hl ;hl=3 (  visible)
	;call drawleftedges_checkanddraw
	;ret

drawleftedges_checkanddraw
;bc=xyleft1
;de=xyright1
;hx=slope1
;hl=2 (  visible)
;,  hl  1
;[     ,    ( ),        ?]
;   =  ,   
;   =  ,   
;   ,       (),   ,   
;    (..   ),       (),   ,   
	ld (drawleftedges_xyleft1),bc ;TODO push bc-pop hl
	ld (drawleftedges_xyright1),de ;TODO push de-pop bc
;hl=2 (  visible)
	ld (drawleftedges_checkanddraw_edgeaddr),hl
; xyleft,
	inc hl
	ld a,(hl) ;1
	ld lx,a ;(drawleftedges_slope2),a
	dec hl
	dec hl
	ld d,(hl)
	dec hl
	ld e,(hl)
;de=e?.v1 
	ex de,hl
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	ex de,hl ;de=e?.yx1
	dec hl
	ld a,(hl)
	dec hl
	ld l,(hl)
	ld h,a
;hl=e?.v2
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a ;hl=e?.yx2
	;ld a,l
	cp e
	jr c,$+2+1 ;l < e: hl=yxleft
	 ex de,hl ; hl=yxleft, de=yxright
	;ld (drawleftedges_xyleft2),hl
	ld (drawleftedges_xyright2),de ;TODO push-pop
	;hl= 
drawleftedges_xyleft1=$+1
	ld de,0 ; 
	or a
	sbc hl,de
	jr z,drawleftedges_checkanddraw_commonleft ;   ,  
;   :
;)   =  ( ) -  ,
	ex de,hl ;hl= 
drawleftedges_xyright2=$+1
	ld de,0 ;  ;TODO push-pop
	or a
	sbc hl,de
	jr z,drawleftedges_checkanddraw_commonq
;)   ,
drawleftedges_xyright1=$+1
	ld hl,0 ; 
	or a
	sbc hl,de
	;jr z,drawleftedges_checkanddraw_commonright
;)   =  ( ) - , 
	ret nz
drawleftedges_checkanddraw_commonright
;  
;     (),   ,   
	ld a,lx ;  = #01 () .. #ff ()
	cp hx ;slope1 ; 
	ret nc ;  >=   :  , 
	jp drawleftedges_checkanddraw_commonq
drawleftedges_checkanddraw_commonleft
;  
;     (),   ,   
	ld a,hx ;slope1 ;  = #01 () .. #ff ()
	cp lx ; 
	ret nc ;  >=  :  , 
drawleftedges_checkanddraw_commonq
; 
drawleftedges_checkanddraw_edgeaddr=$+1
	ld hl,0
;,      
	ld a,(hl)
	cp 1 ;visible, not drawn
	ret nz
;hl   visible
	;jp drawedgerecursive ;     

;            
; ,         ?
;1.  p1 (  )      -   
;2.  p2 (  )      -   
;3.  
drawedgerecursive
;hl=  (  visible)
;TODO   !!!     ,   ,     


;TODO

	ld d,h
	ld e,l
	ld bc,-(4*2) ;p1,p2,v1,v2
	add hl,bc
;hl   p1
;de=  (  visible)
	push hl ;edge (  p1)
;hl   p1
	ld a,(hl)
	inc hl
	push hl
	ld h,(hl)
	ld l,a ;hl=p1
	push de ;edge (  visible)
	call drawleftedges
	pop de ;edge (  visible)
	pop hl
	inc hl
	ld a,(hl)
	inc hl
	;push hl
	ld h,(hl)
	ld l,a ;hl=p2
	call drawleftedges
	;pop hl
	;inc hl
	pop hl ;edge (  p1)
;hl=   (  p1)
	jp drawedge
	
	endif
