;Mars

	if 1==1
IMVEC=#8000;#be00
IMSTACK=#8140;#bf40
ON_INT=#8181;#bfbf
STACK=ON_INT
	else
IMSTACK=#ff40;#bf40
IMVEC=#3bff;#be00
ON_INT=#ff80;#bfbf
STACK=ON_INT
	endif

GRASS=1

basetime=192
endtime=(5*192)

timer=23728

;%11LLLLL0 10CCCCC0 (+inc) to light+hue LC1=%11ccLLL1, hue %11RGCld0
;%11RGCld0 11RGCld0=twohues12,twohues34 to attr and attrcode=%1aaa1111
;%11ccLLL1 1aaaLLL1 (left,right) twochunks to gfx


;tex1=#c000 ;todo  
;tex2=#c040     ;(128     256)
;tchgfx=#c180
tattr=#c0c0
chmap=#6044;#6044 ;128x32 (   32, ..  16 ) +   
chmapto=chmap;#6044 ;64x32
chmapattr=chmap-#42;#6002 ;64x32 (     #6041) +   
;chmapfree=#60c4;   ; #60e4 ;30x32 (   ,    32 )
chmhgt=32
chmwid=64
attrtop=#5900;#5880

bright=64

layers=16;24

	device pentagon1024

	org #6100
begin
	xor a
	out (#fe),a
	;ld (#5d10),a
	;ld (iy+1),#cc
	;ld sp,STACK

	ld hl,wasnextpart
	ld d,#c0
storenextpart0
	ld e,0
	ld bc,128
	ldir
	inc d
	bit 7,h
	jr z,storenextpart0


	ld hl,module
	call pt3player.INIT

	;ld hl,wasimer
	;ld de,ON_INT
	;ld bc,szimer
	;ldir
	if IMVEC==#3bff
           ;LD hl,#c9fb
           ;LD (#fff4),hl
	   ld a,#c3
	   ld (#fff4),a
           ld hl,ON_INT
           ld (#fff5),hl
	   ld a,#18
	   ld (#ffff),a
	ld a,IMVEC/256
	else
           ;ld hl,ON_INT
           ;ld (IMVEC+255),hl
	ld hl,IMVEC
	ld a,h
	ld d,ON_INT/256
	ld (hl),d
	inc l
	jr nz,$-2
	inc h
	ld (hl),d
	endif
	ld i,a
	im 2
	;ei 

;init
	call mktcol ;l=color,h=light to light+hue LC1=%11ccLLL1, hue %11RGCld0
	call mktatr ;twohues12,twohues34=%11RGCld0 11RGCld0 to attr and attrcode=%1aaa1111
	call mktch ;twochunks %11ccLLL1 (left,B) 1aaaLLL1 (right,C) to gfx

	ld de,basetime-3;96
waitmain0
	ld hl,(timer)
	or a
	sbc hl,de
	jr c,waitmain0

	ld hl,#5800
	ld de,#5801
	ld (hl),l;#3e+bright;7
	ld bc,767
	ldir ;,     
	
	ld hl,#4000
	ld de,#4001
	ld a,6
prefill_0
	ld (hl),#11
	ld bc,#200
	ldir
	ld (hl),#22
	ld b,2;bc,#200
	ldir
	dec a
	jr nz,prefill_0

	halt
	ld hl,#5800
	ld de,#5801
	ld (hl),#3e+bright;7
	ld bc,767
	ldir

	jp maingo

;=================== INIT PART ========================

;l=color,h=light to light+hue LC1=%11ccLLL1, hue %11RGCld0
;%11LLLLL0 10CCCCC0 (+inc)
;CCCCC=
;00lll - W
;01lll - R
;10lll - C
;11lll - G
;LLLLL*lll=
;   0 => 000 + d => 0%
;   1 => 001 + d => 50% 
;   2 => 010 + d => 87.5%
;   3 => 010 C1C2=> 12.5%
;   4 => 011 C1C2=> 25%
;   5 => 100 C1C2=> 50%
;   6 => 101 C1C2=> 75%
;   7 => 101 + l => 12.5%
;   8 => 110 + l => 50% 
;   9 => 111 + l => 100%
;cc=
;00 - W
;01 - R
;10 - C/G
;11 - C1-C2 (don't mind the hue)
;l means lighter 1/3 range of light is used
;d means dark 1/3 range of light is used
;if hues are different (except for exactly one "incompatible" hue with double upper or double dark range), then 0-W
;if lighter and dark range are both marked, then 0-W
;if lighter range is marked, then C2-W
;if dark range is marked, then 0-C1
;if no ranges are marked, then C1-C2 (with C1-C2 marked in cc too)
mktcol
	ld d,%11000000 ;tcolor/256
mktcol0:
	ld e,%10000000 ;tcolor
mktcol1:

;lll=f(e)
	ld a,e
	rra
	and %111
	ld b,a
	jr z,mktcolz ;a=0 => light=0

;LLLLL=f(d)
	ld a,d
	rra
	and %11111
	ld c,a

	if GRASS
	cp %11111
	jr z,mktcolzmax ;white is always white
	endif

;count light=LLLLL*lll
	xor a
	add a,c
	djnz $-1
mktcolz
	rra
	rra
	rra
	rra
mktcolzmax
	and %1111
	sub 2
	jr nc,$+3
	xor a
	cp 9
	jr c,$+3
	ld a,9
;a=light=0..9

;count C1C2,l,d
;count l
	ld bc,%11000010
	cp 7
	jr c,$+2+2+1+1
	set 2,c ;set l
	dec a
	dec b ;res C1C2

;count d
	cp 3
	jr c,$+2+2+1+1
	res 1,c ;res d
	dec a
	inc b ;set C1C2
;a=LLL=0..7
;b=C1C2 (0 for dark, 1 for mid, 0 for light)
;c=%11000ld0

;count LLL (light used)
	add a,a
	or b
	or %11000000
	ld b,a ;%1100LLLc (c=C1C2)

;count b=%11ccLLL1 (C1C2 used for counting cc)
	ld a,e
	and %00110000 ;cc (00=W, 01=R, 10=C, 11=G(temporary))
	jr z,mktcolw ;W, so don't mind C1C2 flag
	cp %00110000 ;G?
	jr nz,$+4
	ld a,%00100000 ;C/G
	bit 0,b
	jr z,$+4
	ld a,%00110000 ;C1-C2
mktcolw
	inc a ;%00cc0001
	or b
	;ld b,a ;%11ccLLL1

	;ld a,b ;%11ccLLL1
	ld (de),a
	inc e

;c=%11000ld0
;count c=%11RGCld0
	ld a,e
	and %00110000 ;cc (00=W, 01=R, 10=C, 11=G(temporary))
	jr z,mktcolRGC ;W,z
	cp %00100000 ;C
	jr nz,mktcolnC
	set 3,c ;C
	jr mktcolCq
mktcolnC
	jr c,mktcolR
;G,nz
mktcolRGC
	set 4,c ;G
	jr nz,mktcolCq
	set 3,c ;C
mktcolR
	set 5,c ;R
mktcolCq

	ld a,c ;%11RGCld0
	ld (de),a
	inc e
	bit 6,e ;%10CCCCC0
	jr z,mktcol1
	inc d
	inc d
	jr nz,mktcol0
	ret



;twohues12,twohues34=%11RGCld0 11RGCld0 to attr and attrcode=%1aaa1111
;aaa=
;000 - W (W1|W2==1 or l1|l2==1,d1|d2==1 or (RGC1!=RGC2 and not (l1==l2 and exactly one of hues is "incompatible")))
;001 - R (none of above, R1|R2==1)
;010 - C/G (none of above, G1|G2==1)
;[011 - temporary G for C2-W]
 ;or (for R, C/G, not for W)
;100 - 0-C1 (d1|d2==1,l1|l2==0)
;000 - C2-W (l1|l2==1,d1|d2==0)
;111 - C1-C2 (l1|l2==0,d1|d2==0,RGCld1==RGCld2) (chunk should contain cc=11)
mktatr:
	ld h,tattr/256 ;%11000000
mktatr0:
	ld l,tattr&255 ;%11000000
mktatr1:

;make b=%1gRGCldi (g=G|C,i=incompatible)
	ld b,h
	res 6,b
	ld a,h
	and %00011000 ;GC
	jr z,mktatrbq
	set 6,b ;g
	ld a,h
	cpl
	and %00111000 ;RGC
	jr z,mktatrbq ;W
	bit 5,h ;R
	jr z,mktatrbq ;no R
	inc b ;R+C/G, mark i
mktatrbq

;make c=%1gRGCldi (g=G|C,i=incompatible)
	ld c,l
	res 6,c
	ld a,l
	and %00011000 ;GC
	jr z,mktatrcq
	set 6,c ;g
	ld a,l
	cpl
	and %00111000 ;RGC
	jr z,mktatrcq ;W
	bit 5,l ;R
	jr z,mktatrcq ;no R
	inc c ;R+C/G, mark i
mktatrcq

	ld a,b
	xor c ;compare hues
	ld d,a

;find c=aaa=%000..111

;1.find c=hue
	ld a,b
	or c
	cpl
	and %00000110 ;ld
	jr z,mktatrhuew ;incompatible light ranges (l==d==1), get W
	;ld a,b
	;xor c
	ld a,d ;hues XORed
	and %01100000 ;Rg
	jr z,mktatrhueget1 ;Rg1==Rg2, get hue1
;Rg1!=Rg2
;there can be 0-C1 if both dark and exactly one of hues is "incompatible" (don't mistake for 0-W)
;there can be C2-W if both light and exactly one of hues is "incompatible" (don't mistake for 0-W)
	ld a,b
	or c
	and %00000110 ;ld
	jr z,mktatrhuew ;no light ranges marked
	;ld a,b
	;xor c
	ld a,d ;hues XORed
	and %00000110 ;ld
	jr nz,mktatrhuew ;different light ranges
	bit 0,b ;i
	ld a,c
	jr nz,mktatrhueget ;hue1 is "incompatible", get hue2 (if both incompatible, there will be W)
	rra ;i
	jr nc,mktatrhuew ;hue1 is "compatible", hue2 is "compatible" but they differ, get W
;hue2 is "incompatible", get hue1
mktatrhueget1
	ld a,b ;get hue1
mktatrhueget
	rra ;i
	jr c,mktatrhuew ;incompatible
	cpl
	and %11100
	jr z,mktatrhuew ;W
	bit 4,a ;R (5-1)
	ld c,%001 ;hue=R
	jr z,mktatrhueq
	inc c ;%010 ;hue=C
	bit 2,a ;C (3-1)
	jr z,mktatrhueq
	inc c ;%011 ;hue=G (temporary)
	bit 3,a ;G (4-1)
	jr z,mktatrhueq
mktatrhuew
	ld c,%000 ;hue=W
mktatrhueq

;2.find e=light range
	ld a,h
	or l
	rra
	rra ;d flag
	jr nc,mktatrnd ;d==0
	rra ;l flag
	jr c,mktatrlw ;incompatible light ranges (l==d==1), so hue=W
	ld e,%100 ;dark
	jr mktatrlq
mktatrnd ;d==0
	rra ;l flag
	ld e,%000 ;light
	jr c,mktatrlq ;l==1
	ld e,%111 ;C1-C2
	ld a,d ;hues XORed
	and %11100111 ;skip G,C, leave G/C only
	jr z,mktatrlq ;C1-C2 ok
;incompatible colors in C1-C2
mktatrlw
	ld c,%000 ;hue=W because of incompatible colors
mktatrlq

;3.OR hue|lightrange
;if hue==000 (W) then lightrange=000 (for 0-W)
;if hue==011 (temporary G for C2-W) and lightrange!=000 then hue=010 (C/G)
	ld a,c ;hue
	or a
	jr z,mktatraaaq ;0-W
	cp %011 ;temporary G for C2-W
	jr nz,mktatraaaor
	bit 2,e
	jr z,mktatraaaor ;lightrange==000, so keep temporary G
	dec a ;%010 ;C/G
mktatraaaor
	or e
	ld c,a
mktatraaaq

;find attr
	ld b,c ;aaa
	ld (hl),#07+bright ;000 = 0-W
	djnz $+4
	ld (hl),#37+bright ;001 = Y-W
	djnz $+4
	ld (hl),#2f+bright ;010 = C/G-W
	djnz $+4
	if GRASS
	ld (hl),#37+bright ;011 = (Y-W)
	else
	ld (hl),#27+bright ;011 = G-W
	endif
	dec b
	djnz $+4
	ld (hl),#02+bright ;101 = 0-R
	djnz $+4
	if GRASS
	ld (hl),#04+bright ;110 = (0-G)
	else
	ld (hl),#01+bright ;110 = 0-B
	endif
	djnz mktatrnc1c2
;111 = C1-C2
	bit 5,h ;R
	;ld (hl),#16+bright ;R-Y
	ld (hl),#32+bright ;R-Y
	jr nz,mktatrnc1c2
	bit 4,h ;G
	;ld (hl),#0c+bright ;B-G
	if GRASS
	ld (hl),#34+bright ;(G-Y)
	else
	ld (hl),#21+bright ;B-G
	endif
	jr nz,mktatrnc1c2
	;inc (hl) ;#0d+bright ;B-C
	ld (hl),#29+bright ;B-C
mktatrnc1c2

	inc l

;find attrcode
	ld a,c
	cp %011 ;G
	jr nz,$+3
	dec a ;010 - C/G
	add a,a
	add a,a
	add a,a
	add a,a
	or %10001111
	ld (hl),a ;attrcode

	inc l
	jp nz,mktatr1
	inc h
	inc h
	jp nz,mktatr0
	ret

;attr[attrcode]
;db #07+bright ;000 = 0-W
;db #37+bright ;001 = Y-W
;db #2f+bright ;010 = C/G-W - check big0=G
;db #27+bright ;011 = IMPOSSIBLE (temporary G-W)
;db #07+bright ;100 = 0-W
;db #02+bright ;101 = 0-R
;db #01+bright ;110 = 0-B
;db #02+bright ;111 = C1-C2 - hue from twohues (they are identical)



;twochunks %11ccLLL1 (left,B) 1aaaLLL1 (right,C) to gfx
;                    dark        mid        light
;0-C1 (101 R,110 C/G) *3          max       [max]
;C1-C2 (111)         [0]          *3        [max]
;C2-W (001 R,010 C/G)[0]          0          *3
;0-W (000)            +           +          +
;wrong 0-C1 (100)     0           0         [0]
mktch
	ld d,%11000000
mktch0:
	inc d
	ld e,%10000000
mktch1:
	ld b,d
	ld c,e

;right chunk wrong?
;check aaa=100 (wrong 0-C1)
	ld a,c ;right chunk
	and %01110000 ;aaa
	cp %01000000 ;aaa=100 (wrong 0-C1)
	jr nz,mktchrok
;right chunk wrong!
	ld c,%11000001 ;make it black
mktchlok

;left chunk wrong?
;if aaa!=x11 (C1-C2), don't mind the hue
	ld a,c ;right chunk
	cpl
	and %00110000 ;xaa
	jr z,mktchrok
;compare hue in cc with hue in aaa (x00=W, x01=R, x10=C/G)
	cpl ;ld a,c
	xor b
	and %00110000 ;aa xor cc
	jr z,mktchrok
;left chunk wrong!
;if 0-W, keep the light
	ld a,c
	and %01110000 ;aaa ;zero means 0-W
	jr z,mktchrok
;if C2-W, make it white
;else (0-C1) make it black
	and %01000000 ;a00 ;zero means C2-W
	ld b,%11001111 ;white
	jr z,mktchrok
	ld b,%11000001 ;black
mktchrok

;correct the light according to the table
;                 dark(000..010)  mid   light(101..111)
;C1-C2 (111)      IMPOSSIBLE      *3       IMPOSSIBLE
;0-W (000)            +           +          +
;0-C1 (1xx)           *3          max      IMPOSSIBLE
;C2-W (0xx)         IMPOSSIBLE    0          *3
	ld a,c
	and %01110000 ;aaa
	ld hl,tchwhite
	jr z,mktchok ;0-W
	cp %01110000
	ld hl,tchmid
	jr z,mktchok ;C1-C2
	and %01000000 ;a00 ;zero means C2-W
	ld hl,tchlight
	jr z,mktchok
	ld hl,tchdark ;0-C1
;make sure there isn't a "C1-C2" chunk with 0-C1 table
	;ld a,b
	;cpl
	;and %00110000 ;C1-C2
	;jr nz,mktchok
;"C1-C2" chunk with 0-C1 table
;correct the chunk to maximize the pattern
	;ld b,%11111111
mktchok
	ld a,c ;right chunk
	rra
	and 7
	ld c,a
	ld a,b
	ld b,0
	push hl
	add hl,bc
	ld c,(hl)
	pop hl
	push bc
	rra
	and 7
	ld c,a
	add hl,bc
	pop bc
	ld b,(hl)
;b,c=pattern index for left,right chunk

;get right chunk pattern (b,c)
	ld hl,tchpattern
	ld a,b
	ld b,0
	add hl,bc
	ld b,(hl)
	inc hl
	ld c,(hl)

;get left chunk pattern (h,l)
	push bc
	ld hl,tchpattern
	ld c,a
	ld b,0
	add hl,bc
	ld a,(hl)
	inc hl
	ld l,(hl)
	pop bc
	;ld h,a

	;ld a,h
	xor b
	and #f0
	xor b
	ld (de),a
	inc e
	ld a,l
	xor c
	and #f0
	xor c
	ld (de),a

	inc e
	jp nz,mktch1
	inc d
	jp nz,mktch0
	ret

_=2
tchdark ;for 000..010 and nodark
	if GRASS
	db 3*_,5*_,7*_,8*_,8*_,8*_,8*_,8*_
	else
	db 0*_,4*_,7*_,8*_,8*_,8*_,8*_,8*_
	endif
tchmid ;for 010..101
	;db 1*_,1*_,1*_,2*_,4*_,6*_,6*_,6*_
	db 6*_,6*_,6*_,4*_,2*_,1*_,1*_,1*_
tchlight ;for nolight and 101..111
	if GRASS
	db 0*_,0*_,0*_,0*_,0*_,1*_,3*_,6*_
	else
	db 0*_,0*_,0*_,0*_,0*_,1*_,4*_,8*_
	endif
tchwhite ;for 000..111
	if GRASS
	db 2*_,3*_,4*_,5*_,6*_,6*_,7*_,8*_
	else
	db 0*_,1*_,2*_,3*_,4*_,5*_,6*_,8*_
	endif

tchpattern
;2406
;5173
	dw #0000
	dw #2200
	dw #2244 ;#aa00
	dw #aa44 ;#aa44
	dw #aa55 ;#aa55
	dw #ee55 ;#ee55
	dw #eedd ;#ff55
	dw #ffdd ;#ffdd
	dw #ffff

wasnextpart
	include "megaLZunpack.asm"
wasnextpartdata
	incbin "..\48kvectorcar\purecode.c.mlz"
sznextpart=$-wasnextpart
	
;=====================================
	ds ON_INT-$
	;org #8000
wasimer
	disp ON_INT
	ld (imstack),sp
	ld sp,IMSTACK
	push af
	push bc
	push de
	push hl
	
	ld hl,(imstack)
	ld de,imjp
	ldi
	ldi
	ld (imstack),hl
	
	ld hl,(timer)
	inc hl
	ld (timer),hl
	
	push ix
	ex af,af'
	push af
	;push iy ;not used by the replayer
	call pt3player.PLAY
	;pop iy ;not used by the replayer
	pop af
	ex af,af'
	pop ix

	ld hl,wasdrawmarslinestack
	ld de,drawmarslinestack
	ld bc,szdrawmarslinestack
imerldir=$
	ldir

	pop hl
	pop de
	pop bc
	pop af
imstack=$+1
	ld sp,0
	ei
imjp=$+1
	jp 0
;timer
	;dw 0
	ent
szimer=$-wasimer

	include "pt3play.asm"
module
	incbin "testmusic.pt3"

maingo
	ld hl,(timer)
	ld (oldtimer),hl
	;jp mainloop

mainloop

	if 1==0
	;,   

	ld a,(curz)
	sub #40
	jr nc,$+3
	xor a
	cp #80
	jr c,$+4
	ld a,#7f
	or %10000000
	rrca
	rrca
	rrca
	rrca

	else
	;,   ,      (..  )

	ld a,(cury)
	call getheight
	ld e,a ;   (inv)
	ld a,(cury)
	add a,3
	call getheight
	;a=   (inv)
	sub e
	;cy=1:    	
	jr c,$+4
	ld a,#ff
	;a<0 ( : -1)
	add a,a
	jr c,$+3
	xor a
	;add a,a
	;jr c,$+3
	;xor a

	if 1==1
	ld d,a ;d=  (inv)
	ld a,e ;   (inv)
	srl a
	cpl ;  
	;sub #80
	;jr nc,$+3
	;xor a
	;add a,a
	add a,d ;d= 
	jr c,$+3
	xor a
	;a=    
	endif

	add a,#30
	jr nc,$+3
	sbc a,a
oldlightlevel=$+1
	ld e,0
	ld (oldlightlevel),a	
	add a,e
	rra	
	rrca
	rrca
	rrca
	rrca
	and %00001110
	jr nz,$+4
	add a,2

	endif

curbg=$+1
	ld de,%1111111010111110 ;%11LLLLL0 ;%10CCCCC0 (ccLLL)
	xor e
	and %00001110
	xor e
	ld e,a

	ld (clsp),sp
	ld hl,chmap+(chmwid*2)
	ld b,chmhgt
cl0
	ld sp,hl	
	dup chmwid
	push de
	edup
	inc h
	djnz cl0
clsp=$+1
	ld sp,0

	call drawmars

	;halt
	call prch

	ld hl,(timer)
oldtimer=$+1
	ld de,0
	ld (oldtimer),hl
	or a
	sbc hl,de
	jp z,mainloop
	ld b,l
	call moveall
	djnz $-3
	ld hl,(timer)
	ld de,endtime-28;20
	ld (oldtimer),hl
	or a
	sbc hl,de
	jp c,mainloop
quit
	ld hl,0
	ld (imerldir),hl

	;di
	ld de,wasnextpart
	ld h,#c0
restorenextpart0
	ld l,0
	ld bc,128
	ldir
	inc h
	bit 7,d
	jr z,restorenextpart0
	ld hl,wasnextpartdata
	ld de,#a200
	push de
	;di
	jp wasnextpart;#5b00


moveall
	ld a,64
	add a,0
	ld ($-1),a
	ld hl,cury
	jr nc,$+3
	inc (hl)

	ld a,37
	add a,0
	ld ($-1),a
	ld hl,curxphase
	jr nc,$+3
	 inc (hl)
curxphase=$+1
	ld hl,tsin;tscalesinx
	ld a,(hl)
	;add a,a
	;add a,a
	sra a
	;sra a
	ld (curx),a

	ret
	


prch:
	ld (prchsp),sp

;convert color and light (chmap) to light+hue (chmapto) and twohues (chmapattr)
	ld a,chmap/256

prech0:
	ld h,a
	ld l,chmap&255
	ld sp,hl
	ex de,hl ;chmapto=chmap
	ld b,d
	res 0,b
	and 1
	add a,chmwid+(chmapattr&255)
	ld c,a
;sp=chmap
;de=chmapto
;bc=chmapattr+chmwid+1 or 0 (odd lines)

	dup chmwid/2
	pop hl ;l=color,h=light
	ldi ;light+hue LC1=%11ccLLL1
 ;NB: skip one byte in (bc)!
	ld a,(hl) ;hue
	pop hl ;l=color,h=light
	ldi ;light+hue LC2=%11ccLLL1
	or (hl) ;hue
	ld (bc),a ;twohues %11RGCld0
	edup
;cc=
;00 - W (with 0-1 gives "wrong 0-C1", or else "0-W")
;01 - R
;10 - C/G
;11 - C1-C2 (don't mind the hue)
;l means lighter 1/3 range of light is used
;d means dark 1/3 range of light is used
;if hues are different (except for exactly one "incompatible" hue with double upper or double dark range), then 0-W
;if lighter and dark range are both marked, then 0-W
;if lighter range is marked, then C2-W
;if dark range is marked, then 0-C1
;if no ranges are marked, then C1-C2 (with C1-C2 marked in cc too)

	ld a,d
	inc a
	cp chmhgt+(chmap/256)
	jp nz,prech0

;draw chunks on screen
	ld hl,attrtop;#5880
	ld (prchattr),hl
	ld a,chmapattr/256 ;todo remove

prch0:
;attrs (sp=chmapattr, de=attr, bc=chmapto+chmwid-1)
	ld h,a
	ex af,af'
	ld l,chmapattr&255
	ld sp,hl
	ld b,h
	ld c,chmwid+(chmapto&255)-1
prchattr=$+1
	ld de,0

	dup chmwid/4
	pop hl ;twohues12,twohues34=%11RGCld0
	ldi ;attr
 ;NB: skip HSB chunk in (bc)!
	ld a,(bc)
	and (hl) ;attrcode=%1aaa1111
	ld (bc),a ;correct top LSB chunk
	inc b
	ld a,(bc)
	and (hl) ;attrcode=%1aaa1111
	ld (bc),a ;correct bottom LSB chunk
	dec c
	pop hl ;twohues12,twohues34=%11RGCld0
	ldi ;attr
 ;NB: skip HSB chunk in (bc)!
	ld a,(bc)
	and (hl) ;attrcode=%1aaa1111
	ld (bc),a ;correct bottom LSB chunk
	dec b
	ld a,(bc)
	and (hl) ;attrcode=%1aaa1111
	ld (bc),a ;correct top LSB chunk
	dec c
	edup
	org $-1
	
;de=end of attr line+1
;bc=start of chmapto line
	ld (prchattr),de ;if chmwid=64, it's a next line
	dec de ;de=end of attr line

;bottom chunks
	ld h,b,l,c
	ld (prchtopsp),hl
	inc h
	ld sp,hl
	ld a,d ;%010110xx
	add a,a
	add a,a
	add a,a ;%110xx000
	sub #7f
	ld d,a ;%010xx001
	ld (prchtopde),de
	set 2,d
	ld b,d,c,e
	inc b
	inc bc

	dup chmwid/4
	pop hl ;twochunks
	ld a,(hl)
	ld (de),a
	dec d
	ldd
	ld a,(hl)
	ld (bc),a
	inc b
	ld (bc),a
	pop hl ;twochunks
	ld a,(hl)
	ld (de),a
	inc d
	ldd
	ld a,(hl)
	ld (bc),a
	dec b
	ld (bc),a
	edup

;top chunks
prchtopsp=$+1
	ld sp,0
prchtopde=$+1
	ld de,0
	ld b,d,c,e
	inc b
	inc bc

	dup chmwid/4
	pop hl ;twochunks
	ld a,(hl)
	ld (de),a
	dec d
	ldd
	ld a,(hl)
	ld (bc),a
	inc b
	ld (bc),a
	pop hl ;twochunks
	ld a,(hl)
	ld (de),a
	inc d
	ldd
	ld a,(hl)
	ld (bc),a
	dec b
	ld (bc),a
	edup

	ex af,af'
	add a,2
	cp chmhgt+(chmapattr/256)
	jp nz,prch0
prchsp=$+1
	ld sp,0
	ret


;%%%%%%%%%%%%%%%%%% MARS %%%%%%%%%%%%%%%%%%%%%%
getheight
	add a,4
	ld l,a
	ld h,tsiny/256
	ld a,(curx)
	ld c,a ;c=curx
	ld a,(hl) ;siny
;curz:=119-4*func_sinx(0,curx,siny)) = 150 + 4*(tscalesinx[0,curx+4*siny] + tscalesinx[0,(2*curx+1*siny)])
	ld b,a ;siny
	add a,c ;+curx
	add a,c ;+curx
	ld l,a
	ld h,tscalesinx/256
	ld a,b ;siny
	add a,a
	add a,a ;*4
	add a,c ;+curx
	ld b,(hl) ;=#ef..#11
	ld l,a
	ld a,(hl) ;=#ef..#11
	add a,b ;max=#22
	add a,2*#11
	;a=0..#22
	add a,a
	add a,a
	jr nc,$+3
	sbc a,a
	;a=0..#ff
	ret

drawmars:
;siny:=func_siny(cury+(DIST+LAYERSTEP)) = tsiny[cury+4]
	ld a,(cury)
	call getheight
	cpl
	;add a,119+1-50
	;jr nc,$+3
	;sbc a,a
	ld (curz),a

	ld b,layers
drawmars0
	push bc
	push hl
;disty:=dists[layer]
	ld hl,dists
	ld a,layers
	sub b
	;ld a,b
	;dec a
	ld (layer),a
	add a,a
	ld c,a
	ld b,0
	add hl,bc
	ld d,(hl) ;d=disty
	;ld a,(hl)
	;ld (disty),a
;scale:=(DIST/4)/disty
	inc hl
	ld c,(hl) ;c=iscale
	; basey=curz*scale=curz*scale/1024
	ld hl,0
curz=$+1
	ld a,120;170 ;100..220
	dup 8
	rla
	jr nc,$+3
	add hl,bc
	add hl,hl
	edup
	;h=curz*scale/256
	org $-1 ;h=curz*scale/512
	srl h ;h=curz*scale/1024
	srl h ;h=curz*scale/1024 ( ?)
	ld a,h
	add a,6+(chmap/256)
	ld ly,a ;ly=basey+(chmap/256)

	; bc'=xstep=disty/8
	;ld a,(disty)
	;ld b,a
	ld b,d ;disty
	xor a
	 ld e,a
	srl b
	rra
	srl b
	rra
	srl b
	rra
	ld c,a
	; ix=xcounter=curx-(CHWID div 2)*xstep + 4*siny
;(CHWID div 2)*xstep = 32*xstep = disty*4
cury=$+1
	ld a,#c0;0
;disty=$+1
	add a,d ;disty
	ex de,hl
	;ld a,(disty)
	;ld h,a
	;ld l,0
	add hl,hl
	add hl,hl
	ex de,hl
curx=$+2
	ld hl,220*256
	sbc hl,de
	;push hl
;siny:=tsiny[(cury+disty)mod 256]
	ld e,a
	ld d,tsiny/256
	ld a,(de) ;siny
	ld d,a
	add a,a
	add a,a
	add a,h
	ld hx,a
	ld e,0
	ld lx,e
	;add hl,de
	;add hl,de
	;add hl,de
	;add hl,de
	;push hl
	;pop ix
	; hl'=x2counter=2*(curx-(CHWID div 2)*xstep) + 1*siny
	;pop hl
	add hl,hl
	add hl,de
	; de'=x2step=xstep*2
	ld d,b
	ld e,c
	sla e
	rl d
	exx
	; d=tscalesinx/256+layer
layer=$+1
	ld a,0
	add a,tscalesinx/256
	ld d,a
	ld h,d
	call drawmarsline
	pop hl
	inc h
	pop bc
	dec b
	jp nz,drawmars0
	ret


; 24 
; 18-   : longest=3
;...
; 15-   : longest=4
;...
; 12-   : longest=5 ( 4?)
;...
; 8-   : longest=4
; 7-   : longest=5 ( 4?)
; 6-   : longest=5
 ;    
 ;    :
; 5-   : longest=6
; 4-   : longest=7
;  : longest=10
;  : longest=12
;  : longest=11

	if 1==0
	;  :
	ld a,(de)
	add a,(hl)
	add a,ly
	ld b,a
	dup 5
	ld (bc),a
	inc b
	edup
	org $-1
	inc c
	ld a,e
	add a,0
	ld e,a ; inc e,   ( xstep=1.17 (    0.5 -   ))
	ld a,l
	add a,0
	ld l,a ; inc l,  
	;17..23 b/pix
	;12   64 pix = 15K , 
	;   1/8,   8 .   (2K )
	endif

;%11LLLLL0 10CCCCC0 (+inc) to light+hue LC1=%11ccLLL1, hue %11RGCld0
;CCCCC=
;00lll - W
;01lll - R
;10lll - C
;11lll - G

;a=d=tscalesinx/256+layer

	if 1==1
	;    :
drawmarsline
	;ld a,(layer)
	cp 8+(tscalesinx/256)
	jp c,drawmarslinefront
	;ld a,d
	ld (curtscalesinx),a
	ld c,1+(chmap&255)+((chmwid-1)*2)+2
	ld (drawmarslinesp),sp
	ld sp,drawmarslinestack
	;di
	;ld hy,chmwid
drawmarsline0
	dec c
	dec c
	exx
	add ix,bc ;xcounter
	add hl,de ;x2counter
	ld a,h
	exx
	ld l,a
	ld e,hx
	ld a,(de)
	add a,(hl)
	add a,ly
	   ;cp #80
 	   ;ret nc;jr nc,drawmarslineskip
	ld b,a
	 ld a,(bc)
	 cp %11111110
	 ret nz;jr nz,drawmarslineskip
	ld d,tsinx/256
	ld h,d
	ld a,(de)
	add a,(hl)
	 ;add a,a
	 ;add a,%11000000;+4
	 ld l,a
;a=%11LLLLL0
drawmarsline1
	dup 4
	ld a,(bc)
	cp %11111110
	jr nz,drawmarslineldskip
	ld a,l
	ld (bc),a
	inc b
	edup
	jp drawmarsline1
drawmarslineldskip
curtscalesinx=$+1
	ld d,0
	ld h,d
;drawmarslineskip
	ret
	;dec hy
	;jp nz,drawmarsline0
	;ret
drawmarslineq
drawmarslinesp=$+1
	ld sp,0
	;ei
	ret

	ds 30 ;  
drawmarslinestack
	dup chmwid-1
	dw drawmarsline0
	edup
	dw drawmarslineq

wasdrawmarslinestack
	dup chmwid-1
	dw drawmarsline0
	edup
	dw drawmarslineq
szdrawmarslinestack=$-wasdrawmarslinestack

drawmarslinefront
	ld a,d
	ld (frontcurtscalesinx),a
	ld c,1+(chmap&255)+((chmwid-1)*2)
	ld hy,chmwid/2
	exx
	sla c
	rl b
	sla e
	rl d
drawmarslinefront0
	add ix,bc ;xcounter
	add hl,de ;x2counter
	ld a,h
	exx
	ld l,a
	ld e,hx
	ld a,(de)
	add a,(hl)
	add a,ly
	;cp #80
	;jr nc,drawmarslinefrontskip
	jp m,drawmarslinefrontskip
	ld b,a
	ld d,tsinx/256
	ld h,d
	ld a,(de)
	add a,(hl)
	 ;add a,a
	 ;add a,%11000000;+4
	 ld e,a
	;a=%11LLLLL0
	  ld h,b
	  ld l,c
	  ld a,%11111110
drawmarslinefront1
	dup 10/2
	cp (hl)
	jr nz,drawmarslinefrontldskip
	ld (hl),e
	dec l
	dec l
	ld (hl),e
	inc h
	cp (hl)
	jr nz,drawmarslinefrontldskip
	ld (hl),e
	ld l,c
	ld (hl),e
	inc h
	edup
	jp drawmarslinefront1
drawmarslinefrontldskip
frontcurtscalesinx=$+1
	ld d,0
	ld h,d
drawmarslinefrontskip
	ld a,c
	sub 4
	ld c,a
	dec hy
	exx
	jp nz,drawmarslinefront0
	ret


	else
drawmarsline
	dup 8;chmwid
	ld a,(de)
	add a,(hl)
	add a,ly ;baseh
	exx
	ld b,a
	ld a,(de)
	add a,(hl)
	dup 5
	ld (bc),a
	inc b
	edup
	org $-1
	inc c
	inc c
	ld a,e
	add a,0 ;0..5
	ld e,a
	ld a,l
	add a,0 ;0..9
	ld l,a
	exx
	ld a,e
	add a,0 ;0..5
	ld e,a
	ld a,l
	add a,0 ;0..9
	ld l,a
	edup
	ret
	endif


dists
;dist,scale
	INCBIN "mkmars\dists.dat"

	ALIGN 256
tsin
	INCBIN "cos.$c!"
tsinx
	INCBIN "mkmars\tsinx.dat"
tsiny
	INCBIN "mkmars\tsiny.dat"
;tsinx2
	;INCBIN "mkmars\tsinx2.dat"
tscalesinx
	INCBIN "mkmars\tscalesinx.dat"

activeend

	
end

	display "End=",end
	display "Free after end=",/d,#c000-end
	display "Size ",/d,end-begin," bytes"
	
	savebin "code.c",begin,end-begin
	
	LABELSLIST "..\us\user.l"
