	device pentagon1024

STACK=#be00;#5fe0;#be00
IMVEC=#3bff
;IMVEC=#fe00;#be00
;IMER=#fdfd;#bfbf

;NU1=#c9
;NU2=#33

pusher=#6000
mcer=#c000
mcstack=#c000

bright=1;0
	if bright
brightconst=#4747
	else
brightconst=#0707
	endif
	
	org #6100

begin
	xor a
	;ld a,1
	out (#fe),a
	ld hl,#4000
	ld de,#4001
	ld bc,#17ff
	ld (hl),l
	ldir
	ld hl,#5800
	ld de,#5801
	ld bc,#2ff
	ld (hl),7
	ldir

	;ld (#5d10),a
	;ld (iy+1),#cc
	ld sp,STACK

	if IMVEC==#3bff
       ;LD hl,#c9fb
       ;LD (#fff4),hl
	   ld a,#c3
	   ld (#fff4),a
       ld hl,ON_INT
       ld (#fff5),hl
	   ld a,#18
	   ld (#ffff),a
	else
       ld hl,ON_INT
       ld (IMVEC+255),hl
	endif
	ld a,IMVEC/256
    ld i,a
    im 2
    ;ei 

	
	jp maingo



;=====================================
	ds #8000-$
	org #8000
maingo

	
	ei
	halt
	
	ld hl,(timer)
	push hl
	ld h,0
	ld d,h
	ld bc,3400
	ldir
	pop de
	ld hl,(timer)
	or a
	sbc hl,de
	jr z,mainpent

	if 1==1
	ld hl,(timer)
	push hl
	ld h,0
	ld d,h
	ld bc,3300
	ldir
	pop de
	ld hl,(timer)
	or a
	sbc hl,de
	;nz=48K, z=128K
	jr nz,main48k

	else

	ld bc,#7ffd
	ld h,c,l,c
	ld de,#1011
	out (c),d
	ld (hl),c ;#fd
	out (c),e
	dec (hl)
	ld a,(hl)
	out (c),d
	cp (hl)
	;z=48K, nz=128K
	jr z,main48k

	endif

	ld hl,295-1
	ld (waits),hl
	ld hl,tmc128
	ld (mkmcdata),hl
	jr main48k
mainpent
	ld hl,434;295-1
	ld (waits),hl
	ld hl,tmcpent;tmc128
	ld (mkmcdata),hl	

main48k

	call mkpusher
	call mkmc
	
	;ld hl,(timer)
	;ld (oldtimer),hl

	ld hl,#5800
	ld de,#5801
	ld bc,#2ff
	ld (hl),l
	ldir

	ld hl,scrdata
	ld de,#4000
	ld b,192
view0	
	push bc
	push de
	ld bc,#20
	ldir
	pop de
	call dde
	pop bc
	djnz view0
	
	halt
	ld bc,1700
	dec bc
	ld a,b
	or c
	jr nz,$-3 ;,        

;  ( )
	ld de,#5800
	ld b,24
viewatr0
	push bc
	ld bc,#20
	ldir
	ld bc,#e0
	add hl,bc
	pop bc
	djnz viewatr0

mainloop
	halt
;48k: 69888 T, 224 T/line, contention from 14335
;128K: 70908 T, 228 T/line, contention from 14361
waits=$+1
	ld hl,294-1
	dec hl
	ld a,h
	or l
	jr nz,$-3

	call mc

	ld a,(hl) ;    

	jp mainloop


mkmc
	ld hl,mcer
	ld (hl),#21 ;ld hl
	inc hl
	ld (hl),brightconst&255
	inc hl
	ld (hl),brightconst&255 ;const
	inc hl
	ld (hl),#31 ;ld sp
	inc hl
	ld (hl),mcstack&255
	inc hl
	ld (hl),mcstack/256 ;const
	inc hl
	ld (hl),0
	inc hl
	ld (hl),0
	inc hl
	ld (hl),0
	inc hl
	ld (hl),0
	inc hl
	ld de,#0000;#5800
	ld b,24
mkmc0
	push bc
mkmcdata=$+2
	ld ix,tmc
mkmc1
	ld a,(ix)
	inc ix
	cp #7f
	jr z,mkmc_end
	ld (hl),a
	inc hl
	cp #01
	jr z,mkmc_ldrp
	cp #11
	jr z,mkmc_ldrp
	cp #21
	jr z,mkmc_ldrp
	cp #31
	jr z,mkmc_ldsp
	cp #22
	jr z,mkmc_ldmem
	jr mkmc_ok
mkmc_ldmem
mkmc_ldsp
	ld c,(ix)
	inc ix
	ld b,(ix)
	inc ix
	push hl
	ld h,d ;de=#0000+
	ld l,e
	add hl,bc ;bc=#5800+
	ld b,h
	ld c,l
	pop hl
mkmc_ldok
	ld (hl),c
	inc hl
	ld (hl),b
	inc hl
	jr mkmc_ok
mkmc_ldrp
	ld c,(ix)
	inc ix
	ld b,(ix)
	inc ix
	ld a,c
	cp brightconst&255 ;const (     LSB )
	jr z,mkmc_ldok
	;c = 32*(LINENUMBER-1) + BYTENUMBER
	ld a,c
	and #e0 ;#00/20/40/80,    2/4/6/10 (  0)
	push hl
	ld l,a
	ld h,0
	add hl,hl
	ld a,c
	and #1f ;bytenumber
	ld c,a
	ld b,0
	add hl,bc
mkmc_linenum=$+2
	ld bc,scrdata+#1840 ; 2 (  0)
	add hl,bc
	ld c,(hl)
	inc hl
	ld b,(hl)
	pop hl
	jr mkmc_ldok
mkmc_ok
	jr mkmc1
mkmc_end
	ld a,e
	add a,32
	ld e,a
	jr nc,$+3
	inc d
	ld a,(mkmc_linenum)
	inc a
	ld (mkmc_linenum),a
	pop bc
	djnz mkmc0
	
	ld (hl),#c3
	inc hl
	ld (hl),mcq&255
	inc hl
	ld (hl),mcq/256

	ld hl,(scrdata+#1840)
	ld (mcattr0100),hl
	ld hl,(scrdata+#1856)
	ld (mcattr1716),hl

	ret


mc
	ld (mcsp),sp
mcattr0100=$+2
	ld ix,#0100
mcattr1716=$+2
	ld iy,#1716
	;ld hl,pusherq
	ld hl,mcer
	jp pusher
pusherq
	ld hl,brightconst ;const
tmc
;14194 (-143)
;15984 (-145)
	ld bc,#0706
	ld de,#0908
	exx
	ld de,#0f0e
	ld hl,#1110
	ld bc,#0b0a
;16038 (133)
	push bc
	pop af
	ex af,af'
	ld bc,#0504
	push bc
	pop af
	ld bc,#0d0c
	exx
	ld sp,#580c
;14328 (-9)
;16118 (-11)
; 
;( 0-1,2-3)
	ld (#5800),hl ;+8,16 (0,1)
;16144 (15)
;(wait 3)
;( 4-5,6-7,8-9)
	ld (#5802),hl ;+32,40 (2,3)
;( 10-11,12-13)
	push hl ;+48,56 (11,10)
;( 14-15,16-17)
	push hl ;+64,72 (9,8)
;( 18-19,20-21)
	push hl ;+80,88 (7,6)
;( 22-23,24-25)
	push hl ;+96,104 (5,4)
;( 26-27)
	ld sp,#5818 ;114
;(wait 6)
	push hl ;131 (23,22)
	push hl ;142 (21,20)
	push hl ;153 (19,18)
	push hl ;164 (17,16)
	push hl ;175 (15,14)
	push hl ;186 (13,12)
	ld sp,#580a ;196
	ld hl,#0302 ;206
	nop ;210
	nop ;214
; 
;(wait 1)
;( 0-1,2-3)
	ld (#5800),ix ;+232,240 (0,1)
;14576 (239)
;(wait 3)
;( 4-5,6-7,8-9)
	ld (#5802),hl ;+256,264 (2,3)
;( 10-11,12-13)
	push de ;+272,280 (9,8)
;( 14-15,16-17)
	push bc ;+288,296 (7,6)
;( 18-19,20-21)
	push af ;+304,312 (5,4)
	ld bc,#1312 ;322
	ld de,#1514 ;332
	ld sp,#5818 ;342
	push iy ;357 (23,22)
	push de ;368 (21,20)
	push bc ;379 (19,18)
	exx ;383
	push hl ;394 (17,16)
	push de ;405 (15,14)
	push bc ;416 (13,12)
	ex af,af' ;420
	push af ;431 (11,10)
	ld hl,brightconst ;441=-7 ;const
; 
;(wait 2)
;( 0-1,2-3)
	ld (#5800),hl ;+8,16 (0,1)
;( 4-5,6-7,8-9)
	ld (#5802),hl ;+32,40 (2,3)
;( 10-11,12-13)
	push hl ;+48,56 (9,8)
;( 14-15,16-17)
	push hl ;+64,72 (7,6)
;( 18-19,20-21)
	push hl ;+80,88 (5,4)
	ld sp,#5818 ;98
	ld de,#3332 ;108
	ld bc,#3130 ;118
;(wait 2)
	push hl ;+128,131 (23,22)
	push hl ;142 (21,20)
	push hl ;153 (19,18)
	push hl ;164 (17,16)
	push hl ;175 (15,14)
	push hl ;186 (13,12)
	push hl ;197 (11,10)
; 
	ld hl,#3534 ;207 (bc,de  )
	exx ;211
	ld hl,#2120 ;221
	ld de,#2928 ;231
	ld bc,#2726 ;241
;(wait 2)
;( 4-5,6-7,8-9)
	ld (#5800),hl ;+256,264 (0,1)
;( 10-11,12-13)
	push de ;+272,280 (9,8)
;( 14-15,16-17)
	push bc ;+288,296 (7,6)
	ld bc,#2524 ;306
	ld de,#2322 ;316
	ld hl,#3736 ;326
;(wait 2)
;( 14-15,16-17)
	push bc ;+336,344 (5,4)
	push de ;+352,355 (3,2)
	ld sp,#5818 ;365
	push hl ;376 (23,22)
	exx ;380
	push hl ;391 (21,20)
	push de ;402 (19,18)
	push bc ;413 (17,16)
	ld bc,#2f2e ;423
	push bc ;434 (15,14)
	ld bc,#2d2c ;444
;(  push  )
	ld hl,#2b2a ;454
;(wait 2)
;( 2-3,4-5)
	push bc ;+464(16),472 (13,12)
;( 6-7,8-9)
	push hl ;+480,488(40) (11,10) -  !!!
; 
	ld bc,#5150 ;50
	ld de,#5352 ;60 ( )
	ld hl,brightconst ;70 ;const
;(wait 2)
;( 18-19,20-21)
	push hl ;+80,88 (9,8)
;( 22-23,24-25)
	push hl ;+96,104 (7,6)
;( 26-27,28-29)
	push hl ;+112,120 (5,4)
	push hl ;131 (3,2)
	push hl ;142 (1,0)
	ld sp,#5818 ;152
	push hl ;163 (23,22)
	push hl ;174 (21,20)
	push hl ;185 (19,18)
	push hl ;196 (17,16)
	push hl ;207 (15,14)
	push hl ;218 (13,12)
;(wait 6)
;( 0-1,2-3)
	push hl ;+232,240 (11,10)
	ld hl,#4140 ;250 (bc,de  )
	exx ;254
	ld hl,#4948 ;264
; 
;( 10-11,12-13)
	push hl ;+272,280 (9,8)
	ld bc,#4746 ;290
	ld de,#4544 ;300
	ld hl,#4342 ;310
;(wait 2)
;( 22-23,24-25)
	push bc ;+320,328 (7,6)
;( 26-27,28-29)
	push de ;+336,344 (5,4)
;( 30-31)
	push hl ;+352,355 (3,2)
	exx ;359
	push hl ;370 (1,0)
	ld sp,#5814 ;380
	push de ;391 (19,18)
	push bc ;402 (17,16)
	ld bc,#4f4e ;412
	push bc ;423 (15,14)
	ld bc,#4d4c ;433
	push bc ;444 (13,12)
	ld bc,#4b4a ;454
;(wait 2)
;( 2-3,4-5)
	push bc ;+16(464),24 (11,10)
;( 6-7,8-9,10-11,12-13)
	ld hl,#5554
	ld (#5814),hl ;+48,56 (20,21)
;( 14-15,16-17,18-19,20-21)
	ld hl,#5756
	ld (#5816),hl ;+80,88 (22,23)
; 
	ld hl,brightconst ;98 ;const
;15778(97)
	ld ix,#8180 ;112 (  !!!)
	ld iy,#9796 ;126 (  !!!)
	push hl ;137 (9,8)
	push hl ;148 (7,6)
	push hl ;159 (5,4)
	push hl ;170 (3,2)
	push hl ;181 (1,0)
	ld sp,#5814 ;191
;15871(190)
	push hl ;202 (19,18)
	push hl ;213 (17,16)
	push hl ;224 (15,14)
;15904(223)
;( 0-1,2-3)
	push hl ;+232,240 (13,12)
;( 4-5,6-7)
	push hl ;+248,256 (11,10)
;( 8-9,10-11,12-13)
	ld (#5814),hl ;+272,280 (20,21)
;( 14-15,16-17,18-19)
	ld (#5816),hl ;+296,304 (22,23)
;15984(303) - #c110
;-145
	ld a,a ;END
mcq
mcsp=$+1
	ld sp,0
	ret


tmcpent
;14194 (-143)
;15984 (-145)
	ld bc,#0706
	ld de,#0908
	exx
	ld de,#0f0e
	ld hl,#1110
	ld bc,#0b0a
;16038 (133)
	push bc
	pop af
	ex af,af'
	ld bc,#0504
	push bc
	pop af
	ld bc,#0d0c
	exx
	ld sp,#580c
;14328 (-9)
;16118 (-11)
; 
;( 0-1,2-3)
	 nop
	 nop
	 nop
	 nop
	 nop
	 nop
	 nop
	 nop
	 nop
	 nop
	ld (#5800),hl ;+8,16 (0,1)
;(5)
;16144 (15)
;(wait 3)
;--delta 0
;( 4-5,6-7,8-9)
	ld (#5802),hl ;+32,40 (2,3)
;(5)
;--delta 1
;( 10-11,12-13)
	push hl ;+48,56 (11,10)
;(5)
;--delta 2
;( 14-15,16-17)
	push hl ;+64,72 (9,8)
;(5)
;--delta 3
;( 18-19,20-21)
	push hl ;+80,88 (7,6)
;(5)
;--delta 0
;( 22-23,24-25)
	push hl ;+96,104 (5,4)
;(5)
;--delta 1
;( 26-27)
	ld sp,#5818 ;114
;(wait 6)
;--delta 7
	push hl ;131 (23,22)
	push hl ;142 (21,20)
	push hl ;153 (19,18)
	push hl ;164 (17,16)
	push hl ;175 (15,14)
	push hl ;186 (13,12)
	ld sp,#580a ;196
	ld hl,#0302 ;206
	nop ;210
	nop ;214
	 ;NOP ;128K
; 
;(wait 1)
;--delta 0
;( 0-1,2-3)
	 nop
	 nop
	 nop
	 nop
	 nop
	 nop
	 nop
	ld (#5800),ix ;+232,240 (0,1)
;(5)
;14576 (239)
;(wait 3)
;--delta 0
;( 4-5,6-7,8-9)
	ld (#5802),hl ;+256,264 (2,3)
;(5)
;--delta 1
;( 10-11,12-13)
	push de ;+272,280 (9,8)
;(5)
;--delta 2
;( 14-15,16-17)
	push bc ;+288,296 (7,6)
;(5)
;--delta 3
;( 18-19,20-21)
	push af ;+304,312 (5,4)
;(5)
;--delta 0
	ld bc,#1312 ;322
	ld de,#1514 ;332
	ld sp,#5818 ;342
	push iy ;357 (23,22)
	push de ;368 (21,20)
	push bc ;379 (19,18)
	exx ;383
	push hl ;394 (17,16)
	push de ;405 (15,14)
	push bc ;416 (13,12)
	ex af,af' ;420
	push af ;431 (11,10)
	ld hl,brightconst ;441=-7 ;const
	 ;NOP ;128K
; 
;(wait 2)
;( 0-1,2-3)
	 nop
	 nop
	 nop
	 nop
	 nop
	 nop
	 nop
	ld (#5800),hl ;+8,16 (0,1)
;(5)
;--delta 3
;( 4-5,6-7,8-9)
	ld (#5802),hl ;+32,40 (2,3)
;(5)
;--delta 0
;( 10-11,12-13)
	push hl ;+48,56 (9,8)
;(5)
;--delta 1
;( 14-15,16-17)
	push hl ;+64,72 (7,6)
;(5)
;--delta 2
;( 18-19,20-21)
	push hl ;+80,88 (5,4)
;(5)
;--delta 3
	ld sp,#5818 ;98
	ld de,#3332 ;108
	ld bc,#3130 ;118
;(wait 2)
;--delta 1
	push hl ;+128,131 (23,22)
	push hl ;142 (21,20)
	push hl ;153 (19,18)
	push hl ;164 (17,16)
	push hl ;175 (15,14)
	push hl ;186 (13,12)
	push hl ;197 (11,10)
; 
	ld hl,#3534 ;207 (bc,de  )
	exx ;211
	ld hl,#2120 ;221
	ld de,#2928 ;231
	ld bc,#2726 ;241
	 ;NOP ;128K
;(wait 2)
;( 4-5,6-7,8-9)
	 nop
	 nop
	 nop
	 nop
	 nop
	ld (#5800),hl ;+256,264 (0,1)
;(5)
;--delta 0
;( 10-11,12-13)
	push de ;+272,280 (9,8)
;(5)
;--delta 1
;( 14-15,16-17)
	push bc ;+288,296 (7,6)
;(5)
;--delta 2
	ld bc,#2524 ;306
	ld de,#2322 ;316
	ld hl,#3736 ;326
;(wait 2)
;--delta 0
;( 14-15,16-17)
	push bc ;+336,344 (5,4)
	push de ;+352,355 (3,2)
	ld sp,#5818 ;365
	push hl ;376 (23,22)
	exx ;380
	push hl ;391 (21,20)
	push de ;402 (19,18)
	push bc ;413 (17,16)
	ld bc,#2f2e ;423
	push bc ;434 (15,14)
	ld bc,#2d2c ;444
;(  push  )
	ld hl,#2b2a ;454
	 ;NOP ;128K
;(wait 2)
;( 2-3,4-5)
	push bc ;+464(16),472 (13,12)
;(5)
;--delta 3
;( 6-7,8-9)
	push hl ;+480,488(40) (11,10) -  !!!
	 nop
	 nop
	 nop
;(5)
;--delta 0
; 
	ld bc,#5150 ;50
	ld de,#5352 ;60 ( )
	ld hl,brightconst ;70 ;const
;(wait 2)
;( 18-19,20-21)
	 nop
	 nop
	 nop
	 nop
	 nop
	push hl ;+80,88 (9,8)
;(5)
;--delta 3
;( 22-23,24-25)
	push hl ;+96,104 (7,6)
;(5)
;--delta 0
;( 26-27,28-29)
	push hl ;+112,120 (5,4)
;(5)
;--delta 1
	push hl ;131 (3,2)
	push hl ;142 (1,0)
	ld sp,#5818 ;152
	push hl ;163 (23,22)
	push hl ;174 (21,20)
	push hl ;185 (19,18)
	push hl ;196 (17,16)
	push hl ;207 (15,14)
	push hl ;218 (13,12)
	 ;NOP ;128K
;(wait 6)
;--delta 3
;( 0-1,2-3)
	push hl ;+232,240 (11,10)
;(5)
	 nop
	 nop
;--delta 0
	ld hl,#4140 ;250 (bc,de  )
	exx ;254
	ld hl,#4948 ;264
; 
;( 10-11,12-13)
	 nop
	 nop
	ld a,(hl) ;?
	push hl ;+272,280 (9,8)
;(5)
;--delta 1
	ld bc,#4746 ;290
	ld de,#4544 ;300
	ld hl,#4342 ;310
;(wait 2)
;--delta 3
;( 22-23,24-25)
	push bc ;+320,328 (7,6)
;(5)
;--delta 0
;( 26-27,28-29)
	push de ;+336,344 (5,4)
;(5)
;--delta 1
;( 30-31)
	push hl ;+352,355 (3,2)
	exx ;359
	push hl ;370 (1,0)
	ld sp,#5814 ;380
	push de ;391 (19,18)
	push bc ;402 (17,16)
	ld bc,#4f4e ;412
	push bc ;423 (15,14)
	ld bc,#4d4c ;433
	push bc ;444 (13,12)
	ld bc,#4b4a ;454
	 ;NOP ;128K
;(wait 2)
;--delta 3
;( 2-3,4-5)
	;ld hl,#5554
	push bc ;+16(464),24 (11,10)
	 nop
	 nop
	 nop
;(5)
;--delta 0
;( 6-7,8-9,10-11,12-13)
	ld hl,#5554
	ld (#5814),hl ;+48,56 (20,21)
;(5)
;--delta 1
;( 14-15,16-17,18-19,20-21)
	ld hl,#5756
	ld (#5816),hl ;+80,88 (22,23)
	 nop
	 nop
	 nop
	 nop ;  ,     US
;(5)
;--delta 2
; 
	ld hl,brightconst ;98 ;const
;15778(97)
	ld ix,#8180 ;112 (  !!!)
	ld iy,#9796 ;126 (  !!!)
	push hl ;137 (9,8)
	push hl ;148 (7,6)
	push hl ;159 (5,4)
	push hl ;170 (3,2)
	push hl ;181 (1,0)
	ld sp,#5814 ;191
;15871(190)
	push hl ;202 (19,18)
	push hl ;213 (17,16)
	push hl ;224 (15,14)
	 ;NOP ;128K
;15904(223)
;( 0-1,2-3)
	push hl ;+232,240 (13,12)
;(5)
;--delta 3
;( 4-5,6-7)
	push hl ;+248,256 (11,10)
;(5)
;--delta 0
;( 8-9,10-11,12-13)
	 nop
	nop ;?
	nop ;?
	ld (#5814),hl ;+272,280 (20,21)
;(5)
;--delta 1
;( 14-15,16-17,18-19)
	ld (#5816),hl ;+296,304 (22,23)
;(5)
	 ;inc bc
	;nop ;?
	 nop
	 nop
	nop ;?
	nop ;?
	nop ;?
;--delta 0
;15984(303) - #c110
	 ;NOP ;128K
;-145
	ld a,a ;END
;;;;;;;;;;;;;;; end of pentagon




tmc128
;14194 (-143)
;15984 (-145)
	ld bc,#0706
	ld de,#0908
	exx
	ld de,#0f0e
	ld hl,#1110
	ld bc,#0b0a
;16038 (133)
	push bc
	pop af
	ex af,af'
	ld bc,#0504
	push bc
	pop af
	ld bc,#0d0c
	exx
	ld sp,#580c
;14328 (-9)
;16118 (-11)
; 
;( 0-1,2-3)
	ld (#5800),hl ;+8,16 (0,1)
;16144 (15)
;(wait 3)
;( 4-5,6-7,8-9)
	ld (#5802),hl ;+32,40 (2,3)
;( 10-11,12-13)
	push hl ;+48,56 (11,10)
;( 14-15,16-17)
	push hl ;+64,72 (9,8)
;( 18-19,20-21)
	push hl ;+80,88 (7,6)
;( 22-23,24-25)
	push hl ;+96,104 (5,4)
;( 26-27)
	ld sp,#5818 ;114
;(wait 6)
	push hl ;131 (23,22)
	push hl ;142 (21,20)
	push hl ;153 (19,18)
	push hl ;164 (17,16)
	push hl ;175 (15,14)
	push hl ;186 (13,12)
	ld sp,#580a ;196
	ld hl,#0302 ;206
	nop ;210
	nop ;214
	 NOP ;128K
; 
;(wait 1)
;( 0-1,2-3)
	ld (#5800),ix ;+232,240 (0,1)
;14576 (239)
;(wait 3)
;( 4-5,6-7,8-9)
	ld (#5802),hl ;+256,264 (2,3)
;( 10-11,12-13)
	push de ;+272,280 (9,8)
;( 14-15,16-17)
	push bc ;+288,296 (7,6)
;( 18-19,20-21)
	push af ;+304,312 (5,4)
	ld bc,#1312 ;322
	ld de,#1514 ;332
	ld sp,#5818 ;342
	push iy ;357 (23,22)
	push de ;368 (21,20)
	push bc ;379 (19,18)
	exx ;383
	push hl ;394 (17,16)
	push de ;405 (15,14)
	push bc ;416 (13,12)
	ex af,af' ;420
	push af ;431 (11,10)
	ld hl,brightconst ;441=-7 ;const
	 NOP ;128K
; 
;(wait 2)
;( 0-1,2-3)
	ld (#5800),hl ;+8,16 (0,1)
;( 4-5,6-7,8-9)
	ld (#5802),hl ;+32,40 (2,3)
;( 10-11,12-13)
	push hl ;+48,56 (9,8)
;( 14-15,16-17)
	push hl ;+64,72 (7,6)
;( 18-19,20-21)
	push hl ;+80,88 (5,4)
	ld sp,#5818 ;98
	ld de,#3332 ;108
	ld bc,#3130 ;118
;(wait 2)
	push hl ;+128,131 (23,22)
	push hl ;142 (21,20)
	push hl ;153 (19,18)
	push hl ;164 (17,16)
	push hl ;175 (15,14)
	push hl ;186 (13,12)
	push hl ;197 (11,10)
; 
	ld hl,#3534 ;207 (bc,de  )
	exx ;211
	ld hl,#2120 ;221
	ld de,#2928 ;231
	ld bc,#2726 ;241
	 NOP ;128K
;(wait 2)
;( 4-5,6-7,8-9)
	ld (#5800),hl ;+256,264 (0,1)
;( 10-11,12-13)
	push de ;+272,280 (9,8)
;( 14-15,16-17)
	push bc ;+288,296 (7,6)
	ld bc,#2524 ;306
	ld de,#2322 ;316
	ld hl,#3736 ;326
;(wait 2)
;( 14-15,16-17)
	push bc ;+336,344 (5,4)
	push de ;+352,355 (3,2)
	ld sp,#5818 ;365
	push hl ;376 (23,22)
	exx ;380
	push hl ;391 (21,20)
	push de ;402 (19,18)
	push bc ;413 (17,16)
	ld bc,#2f2e ;423
	push bc ;434 (15,14)
	ld bc,#2d2c ;444
;(  push  )
	ld hl,#2b2a ;454
	 NOP ;128K
;(wait 2)
;( 2-3,4-5)
	push bc ;+464(16),472 (13,12)
;( 6-7,8-9)
	push hl ;+480,488(40) (11,10) -  !!!
; 
	ld bc,#5150 ;50
	ld de,#5352 ;60 ( )
	ld hl,brightconst ;70 ;const
;(wait 2)
;( 18-19,20-21)
	push hl ;+80,88 (9,8)
;( 22-23,24-25)
	push hl ;+96,104 (7,6)
;( 26-27,28-29)
	push hl ;+112,120 (5,4)
	push hl ;131 (3,2)
	push hl ;142 (1,0)
	ld sp,#5818 ;152
	push hl ;163 (23,22)
	push hl ;174 (21,20)
	push hl ;185 (19,18)
	push hl ;196 (17,16)
	push hl ;207 (15,14)
	push hl ;218 (13,12)
	 NOP ;128K
;(wait 6)
;( 0-1,2-3)
	push hl ;+232,240 (11,10)
	ld hl,#4140 ;250 (bc,de  )
	exx ;254
	ld hl,#4948 ;264
; 
;( 10-11,12-13)
	push hl ;+272,280 (9,8)
	ld bc,#4746 ;290
	ld de,#4544 ;300
	ld hl,#4342 ;310
;(wait 2)
;( 22-23,24-25)
	push bc ;+320,328 (7,6)
;( 26-27,28-29)
	push de ;+336,344 (5,4)
;( 30-31)
	push hl ;+352,355 (3,2)
	exx ;359
	push hl ;370 (1,0)
	ld sp,#5814 ;380
	push de ;391 (19,18)
	push bc ;402 (17,16)
	ld bc,#4f4e ;412
	push bc ;423 (15,14)
	ld bc,#4d4c ;433
	push bc ;444 (13,12)
	ld bc,#4b4a ;454
	 NOP ;128K
;(wait 2)
;( 2-3,4-5)
	push bc ;+16(464),24 (11,10)
;( 6-7,8-9,10-11,12-13)
	ld hl,#5554
	ld (#5814),hl ;+48,56 (20,21)
;( 14-15,16-17,18-19,20-21)
	ld hl,#5756
	ld (#5816),hl ;+80,88 (22,23)
; 
	ld hl,brightconst ;98 ;const
;15778(97)
	ld ix,#8180 ;112 (  !!!)
	ld iy,#9796 ;126 (  !!!)
	push hl ;137 (9,8)
	push hl ;148 (7,6)
	push hl ;159 (5,4)
	push hl ;170 (3,2)
	push hl ;181 (1,0)
	ld sp,#5814 ;191
;15871(190)
	push hl ;202 (19,18)
	push hl ;213 (17,16)
	push hl ;224 (15,14)
	 NOP ;128K
;15904(223)
;( 0-1,2-3)
	push hl ;+232,240 (13,12)
;( 4-5,6-7)
	push hl ;+248,256 (11,10)
;( 8-9,10-11,12-13)
	ld (#5814),hl ;+272,280 (20,21)
;( 14-15,16-17,18-19)
	ld (#5816),hl ;+296,304 (22,23)
;15984(303) - #c110
	 NOP ;128K
;-145
	ld a,a ;END




mkpusher
	ld hl,pusher
	ld de,scrdata+#1800+23
	ld bc,#5818
	ld hx,24
mkpusher0
	ld (hl),#31
	inc hl
	ld (hl),c
	inc hl
	ld (hl),b
	inc hl
	push de
	ld lx,12
mkpusher1
	ld (hl),#11 ;ld de
	inc hl
	dec de
	ld a,(de)
	inc de
	ld (hl),a
	inc hl
	ld a,(de)
	ld (hl),a
	inc hl
	ld (hl),#d5 ;push de
	inc hl
	dec de
	dec de
	dec lx
	jr nz,mkpusher1
	pop de
	ld a,c
	add a,32
	ld c,a
	jr nc,$+3
	inc b
	inc d
	dec hx
	jr nz,mkpusher0
	ld (hl),#e9 ;jp (hl)
	ret


dde
	inc d
	ld a,d
	and 7
	ret nz
	ld a,e
	add a,32
	ld e,a
	ret c
	ld a,d
	sub 8
	ld d,a
	ret

	
	;if IMVEC!=#3bff
ON_INT
	push af,bc,hl
	ld hl,(timer)
	inc hl
	ld (timer),hl
	;push de
	;push ix,iy
	;ld a,(curpg)
	;push af
	;ld a,pgmuz
	;call OUTA
	;;call muz+5
	;pop af
	;call OUTA
	;pop iy,ix
	;pop de
	pop hl,bc,af
	ei
	ret
	;endif
timer
	dw 0

scrdata
	incbin "mctest2.mc"
	if 1==0
	ds #1800,#ff
	ds #20,#0000
	ds #20,#0101
	ds #20,#0202
	ds #20,#0303
	ds #20,#0404
	ds #20,#0505
	ds #20,#0606
	ds #20,#0707
	ds #20,#0000
	ds #20,#0101
	ds #20,#0202
	ds #20,#0303
	ds #20,#0404
	ds #20,#0505
	ds #20,#0606
	ds #20,#0707
	ds #20,#0000
	ds #20,#0101
	ds #20,#0202
	ds #20,#0303
	ds #20,#0404
	ds #20,#0505
	ds #20,#0606
	ds #20,#0707
	endif

end

	display "Size ",/d,end-begin," bytes"
	
	savebin "code.c",begin,end-begin
	
	LABELSLIST "..\us\user.l"
