	device pentagon1024

STACK=#6000;#be00
IMVEC=#be00
IMER=#bfbf

SHIFTS=#6000
PROGS=#c001

BALLS=33;28
COORDS=#5f00-BALLS;#8100-BALLS
SPRHGT=16

const_b=0
const_c=#f8;#fe
const_d=#fe;#e0;#7f
const_e=#e0;#7f
	define _const_d 1
	define _const_e 1
reconst_b=0
reconst_c=const_c;#f8
	
anybg=1 ;1=      ( )  , 0=    
nomove=0
	
	org #6100

begin
	xor a
	out (#fe),a
	ld hl,#5800
	ld de,#5801
	ld bc,#2ff
	ld (hl),7
	ldir

	;ld (#5d10),a
	;ld (iy+1),#cc
	ld sp,STACK

       LD hl,ON_INT
       LD (IMVEC+255),hl
	ld a,IMVEC/256
        LD I,A
        IM 2
        ;EI 

	ld hl,xsin
rexsin0
	ld a,(hl)
	push af
	rra
	rra
	rra
	and 31
	ld (hl),a
	inc h
	pop af
	and 7
	add a,a
	add a,a
	add a,a
	or #c0
	ld (hl),a
	dec h
	inc l
	jr nz,rexsin0

	ld de,ysin
reysin0
	ld a,(de)
	ld c,0
	call 8880
	ld a,l
	ld (de),a
	inc d
	ld a,h
	ld (de),a
	dec d
	inc e
	jr nz,reysin0

	ld hl,ballspr
	ld de,SHIFTS
	ld b,SPRHGT
genshift0
	push bc
;mask1,spr1,mask2,spr2
;to mask1,mask2,0,spr1,spr2,0
	ldi ;mask1
	ld a,(hl) ;spr1
	inc hl
	ex af,af'
	ldi ;mask2
	xor a
	ld (de),a
	inc de
	ex af,af'
	ld (de),a ;spr1
	inc de
	ldi ;spr2
	xor a
	ld (de),a
	inc de
	pop bc
	djnz genshift0

;generate procedures for sprites
	ld hl,PROGS
	ld c,8 ;x's
genprsprs0
	xor a
	ld b,8 ;y's
genprsprs1
	push af
	push bc
	push hl
	exx
	ld hl,SHIFTS
;a=y
;hl=spr
;hl'=code
	call genprspr
	pop hl
	pop bc
	pop af
	push af
	push bc
	push hl
	res 6,h
	push hl
	exx
	ld hl,SHIFTS
;a=y
;hl=spr
;hl'=code
	call genrespr
	pop hl
		if anybg
	ld d,h
	ld e,l
	call genreopt
		endif
	pop hl
	pop bc
	pop af
	inc a
	inc h
	djnz genprsprs1
	push af
	push bc
	push hl
	call shift
	pop hl
	pop bc
	pop af
	dec c
	jr nz,genprsprs0

	;ld hl,0
	;ld de,#4000
	;ld bc,#1800
	;ldir
	call prbg
	
	jp maingo

shift
	ld hl,SHIFTS
	xor a
	ld b,SPRHGT*6
shift0
	rr (hl)
	inc hl
	djnz shift0
	ret




;--------------------------------
;generate sprite print procedure
;zigzag output
;a procedure for each x&7, y&7, total of 64
;longest procedure: #e101,#e9
genprspr
;a=y
;hl=spr
;hl'=code
	exx
	ld d,a ;Y
	ld c,0 ;nothing changed
	ld e,0 ;no lines generated
	ld b,16
	ld (hl),#e1 ;pop hl
	inc hl
	exx
	jp genprspr1go
genprspr1
	inc e
	inc d
	call genprdhl
	exx
	pop hl
	inc hl
genprspr1go
	ld a,(hl)
	inc hl
	ld b,(hl)
	inc hl
	ld d,(hl)
	inc hl
	ld e,(hl)
	inc hl
	ld c,(hl)
	inc hl
	push hl
	ld l,(hl)
;a,b,d=mask(or)
;e,c,l=sprite(xor)
	exx
	bit 0,b
	exx
	jr nz,genprsprdec
genprsprinc
	push bc
	;ld a,a
	ld c,e
	call genprbyte ;a=or,c=xor
	exx
	ld (hl),#2c ;inc l
	inc hl
	call remove3inc
	exx
	pop bc
	ld a,b
	;ld c,c
	call genprbyte ;a=or,c=xor
	exx
	ld (hl),#2c ;inc l
	inc hl
	exx
	ld a,d
	ld c,l
	call genprbyte ;a=or,c=xor
	jr genprspridq
genprsprdec
	push af
	push bc
	ld a,d
	ld c,l
	call genprbyte ;a=or,c=xor
	exx
	ld (hl),#2d ;dec l
	inc hl
	call remove3inc
	exx
	pop bc
	ld a,b
	;ld c,c
	call genprbyte ;a=or,c=xor
	exx
	ld (hl),#2d ;dec l
	inc hl
	exx
	pop af
	;ld a,a
	ld c,e
	call genprbyte ;a=or,c=xor
genprspridq
	exx
	djnz genprspr1
	exx
	pop hl
	inc hl
	exx
	call removeinc
	ld (hl),#c9 ;ret
	inc hl
	exx
	ret

genprdhl
	ld (hl),#24 ;inc h
	inc hl
	ld a,d
	and 7
	ret nz
;ld a,l:sub -32:ld l,a:sbc a,a:and -8:add a,h:ld h,a
	ld (hl),#7d ;ld a,l
	inc hl
	if const_e==#e0
prdhlopt1=1
	ld (hl),#93 ;sub e
	else
prdhlopt1=0
	ld (hl),#d6 ;sub
	inc hl
	ld (hl),-32
	endif
	inc hl
	ld (hl),#6f ;ld l,a
	inc hl
	ld (hl),#9f ;sbc a,a
	inc hl
	if const_c==#f8
prdhlopt2=1
	ld (hl),#a1 ;and c
	else
prdhlopt2=0
	ld (hl),#e6 ;and
	inc hl
	ld (hl),-8
	endif
	;ld (hl),#a3 ;and e
	inc hl
	ld (hl),#84 ;add a,h
	inc hl
	ld (hl),#67 ;ld h,a
	inc hl
	ret
prdhlsize=9-prdhlopt1-prdhlopt2
	
genprbyteorff
	ld a,c
	cpl
	exx
	cp const_b
	ld (hl),#70 ;ld (hl),b
	jr z,genprbyteorff0
	cp const_c
	ld (hl),#71 ;ld (hl),c
	jr z,genprbyteorff0
	ifdef _const_d
	cp const_d
	ld (hl),#72 ;ld (hl),d
	jr z,genprbyteorff0
	endif
	ld (hl),#36 ;ld (hl),
	inc hl
	ld (hl),a
genprbyteorff0
	inc hl
	inc c ;something changed
	exx
	ret
genprbyte
;a=or
;c=xor
	inc a
	jr z,genprbyteorff ;ld
	dec a
	jr nz,genprbyteorn0
	inc c
	dec c
;skip ;or==0,xor==0
	ret z
;genprsprxor
;ld a,(hl):xor N:ld (hl),a ;or==0,xor!=0
	ld a,c
	exx
	ld (hl),#7e ;ld a,(hl)
	inc hl
	ld (hl),#ee ;xor
	inc hl
	ld (hl),a
	inc hl
	ld (hl),#77 ;ld (hl),a
	inc hl
	inc c ;something changed
	exx
	ret
genprbyteorn0
	inc c
	dec c
	jp z,genprspror
	cp c
	jr z,genprsprand
;genprsprorxor
;ld a,(hl):or N:xor N:ld (hl),a ;or!=0,xor!=0,or!=xor
	exx
	ld (hl),#7e ;ld a,(hl)
	inc hl
	cp const_b
	ld (hl),#b0 ;or b
	jr z,genprsprorxorconst_c
	cp const_c
	ld (hl),#b1 ;or c
	jr z,genprsprorxorconst_c
	ifdef _const_d
	cp const_d
	ld (hl),#b2 ;or d
	jr z,genprsprorxorconst_c
	endif
	ld (hl),#f6 ;or
	inc hl
	ld (hl),a
genprsprorxorconst_c
	inc hl
	exx
	ld a,c
	exx
	ld (hl),#2f ;cpl
	cp #ff
	jr z,genprsprorcpl
	cp const_b
	ld (hl),#a8 ;xor b
	jr z,genprsprorxor2const_c
	cp const_c
	ld (hl),#a9 ;xor c
	jr z,genprsprorxor2const_c
	ifdef _const_d
	cp const_d
	ld (hl),#aa ;xor d
	jr z,genprsprorxor2const_c
	endif
	ld (hl),#ee ;xor
	inc hl
	ld (hl),a
genprsprorxor2const_c
genprsprorcpl
	inc hl
	ld (hl),#77 ;ld (hl),a
	inc hl
	inc c ;something changed
	exx
	ret
genprsprand
;ld a,(hl):and N:ld (hl),a ;or!=0,xor!=0,or==xor
	cpl
	exx
	ld c,#86 ;res 0,(hl)
	cp %11111110
	jr z, genprsprres
	ld c,#8e ;res 1,(hl)
	cp %11111101
	jr z, genprsprres
	ld c,#96 ;res 2,(hl)
	cp %11111011
	jr z, genprsprres
	ld c,#9e ;res 3,(hl)
	cp %11110111
	jr z, genprsprres
	ld c,#a6 ;res 4,(hl)
	cp %11101111
	jr z, genprsprres
	ld c,#ae ;res 5,(hl)
	cp %11011111
	jr z, genprsprres
	ld c,#b6 ;res 6,(hl)
	cp %10111111
	jr z, genprsprres
	ld c,#be ;res 7,(hl)
	cp %01111111
	jr z, genprsprres
	ld (hl),#7e ;ld a,(hl)
	inc hl
	ld (hl),#e6 ;and
	inc hl
	ld (hl),a
	inc hl
	ld (hl),#77 ;ld (hl),a
	inc hl
	inc c ;something changed
	exx
	ret
genprsprres
	ld (hl),#cb
	inc hl
	ld (hl),c
	inc hl
	inc c ;something changed
	exx
	ret
genprspror
;ld a,(hl):or N:ld (hl),a ;or!=0,xor==0
;todo set
	exx
	ld c,#c6 ;set 0,(hl)
	cp %00000001
	jr z, genprsprres
	ld c,#ce ;set 1,(hl)
	cp %00000010
	jr z, genprsprres
	ld c,#d6 ;set 2,(hl)
	cp %00000100
	jr z, genprsprres
	ld c,#de ;set 3,(hl)
	cp %00001000
	jr z, genprsprres
	ld c,#e6 ;set 4,(hl)
	cp %00010000
	jr z, genprsprres
	ld c,#ee ;set 5,(hl)
	cp %00100000
	jr z, genprsprres
	ld c,#f6 ;set 6,(hl)
	cp %01000000
	jr z, genprsprres
	ld c,#fe ;set 7,(hl)
	cp %10000000
	jr z, genprsprres
	ld (hl),#7e ;ld a,(hl)
	inc hl
	cp const_b
	ld (hl),#b0 ;or b
	jr z,genprsprorconst_c
	cp const_c
	ld (hl),#b1 ;or c
	jr z,genprsprorconst_c
	ifdef _const_d
	cp const_d
	ld (hl),#b2 ;or d
	jr z,genprsprorconst_c
	endif
	ld (hl),#f6 ;or
	inc hl
	ld (hl),a
genprsprorconst_c
	inc hl
	ld (hl),#77 ;ld (hl),a
	inc hl
	inc c ;something changed
	exx
	ret

;remove inc l:dhl:dec l or dec l:dhl:inc l
;change to dhl
remove3inc
	;ret
	inc e
	dec e
	ret z ;no lines generated
	push hl
	dec hl
	ld a,(hl)
	sub #2c ;inc l
	cp 2
	jr nc,remove3incno
remove3incdel
	dec hl
	ld a,(hl)
	cp #24 ;inc h
	jr z,remove3inch
	cp #67 ;ld h,a (end of dhl)
	jr nz,remove3incno
remove3incdhl
	push bc
	ld bc,-prdhlsize;-9
	add hl,bc
	pop bc
remove3inch
	dec hl
	ld a,(hl)
	sub #2c ;inc l
	cp 2
	jr nc,remove3incno
remove3incyes
	pop af
	jp genprdhl
remove3incno
	pop hl
	ret
	
;remove inc l's or dec l's
removeinc
	inc c
	dec c
	ret z ;nothing changed
removeinc0
	dec hl
	ld a,(hl)
	cp #2c ;inc l
	jr z,removeinc0
	cp #2d ;dec l
	jr z,removeinc0
	inc hl
	ret
	
		if anybg
;--------------------------------
;generate sprite remove procedure
;zigzag output
;a procedure for each x&7, y&7, total of 64
;longest procedure: #a101,#d (optimized to #93)
genrespr
;a=y
;hl=spr
;hl'=code
	exx
	ld d,a ;Y
	ld c,0 ;nothing changed
	ld e,0 ;no lines generated
	ld b,16
	exx
	jp genrespr1go
genrespr1
	inc e
	inc d
	call genredde
	exx
	pop hl
	inc hl
genrespr1go
	ld a,(hl)
	inc hl
	ld b,(hl)
	inc hl
	ld d,(hl)
	inc hl
	inc hl
	inc hl
	push hl
;a,b,d=mask(or)
	exx
	bit 0,b
	exx
	jr nz,genresprdec
genresprinc
	push bc
	;ld a,a
	call genrebyte ;a=mask(or)
	exx
	ld (hl),#2c ;inc l
	inc hl
	ld (hl),#1c ;inc e
	inc hl
	call remove3reinc
	exx
	pop bc
	ld a,b
	call genrebyte ;a=mask(or)
	exx
	ld (hl),#2c ;inc l
	inc hl
	ld (hl),#1c ;inc e
	inc hl
	exx
	ld a,d
	call genrebyte ;a=mask(or)
	jr genrespridq
genresprdec
	push af
	push bc
	ld a,d
	call genrebyte ;a=mask(or)
	exx
	ld (hl),#2d ;dec l
	inc hl
	ld (hl),#1d ;dec e
	inc hl
	call remove3reinc
	exx
	pop bc
	ld a,b
	call genrebyte ;a=mask(or)
	exx
	ld (hl),#2d ;dec l
	inc hl
	ld (hl),#1d ;dec e
	inc hl
	exx
	pop af
	;ld a,a
	call genrebyte ;a=mask(or)
genrespridq
	exx
	djnz genrespr1
	exx
	pop hl
	inc hl
	exx
	call removereinc
	ld (hl),#c9 ;ret
	inc hl
	exx
	ret

genredhl
	ld (hl),#24 ;inc h
	inc hl
	ld a,d
	and 7
	ret nz
;ld a,l:sub -32:ld l,a:sbc a,a:and -8:add a,h:ld h,a
	ld (hl),#7d ;ld a,l
	inc hl
	ld (hl),#d6 ;sub
	inc hl
	ld (hl),-32
	inc hl
	ld (hl),#6f ;ld l,a
	inc hl
	ld (hl),#9f ;sbc a,a
	inc hl
	ld (hl),#e6 ;and
	inc hl
	ld (hl),-8
	inc hl
	ld (hl),#84 ;add a,h
	inc hl
	ld (hl),#67 ;ld h,a
	inc hl
	ret
redhlsize=9
	
genredde
	call genredhl
	ld (hl),#14 ;inc d
	inc hl
	ld a,d
	and 7
	ret nz
;sub #20:ld d,a:ld e,l
	dec hl ;skip inc d
	;ld (hl),#54 ;ld d,h
	;inc hl
	;ld (hl),#cb
	;inc hl
	;ld (hl),#aa ;res 5,d
	;inc hl
	ld (hl),#d6 ;sub
	inc hl
	ld (hl),#20
	inc hl
	ld (hl),#57 ;ld d,a
	inc hl
	ld (hl),#5d ;ld e,l
	inc hl
	ret

genrebyte
;a=mask(or)
	or a
	ret z
;ld a,(hl):ld (de),a ;or!=0
	exx
	ld (hl),#7e ;ld a,(hl)
	inc hl
	ld (hl),#12 ;ld (de),a
	inc hl
	inc c ;something changed
	exx
	ret

genreopt
;ld a,(hl):ld (de),a:inc l:inc e
;to ldi
;ld a,(hl):ld (de),a:dec l:dec e
;to ldd
genreopt0
genreoptldld
	ld a,(hl)
	cp #7e ;ld a,(hl)
	jr nz,genreoptn
genreopty
	ldi
	ldi
	ld a,(hl)
	sub #2c ;inc l
	cp 2
	jr nc,genreoptldld
	add a,a
	add a,a
	add a,a
	add a,#a0 ;ldi
	dec de
	dec de
	ld (hl),#ed
	ldi
	ld (hl),a
	ldi
	jr genreopt0
genreoptn
	ld a,(hl)
	cp #c9 ;ret
	jr z,genreoptq
	cp #7e ;ld a,(hl)
	jr z,genreopty
	ldi
	jr genreoptn
genreoptq
	ldi
	ret

;remove inc l:dhl:dec l or dec l:dhl:inc l
;change to dhl
remove3reinc
	;ret
	inc e
	dec e
	ret z ;no lines generated
	push hl
	dec hl
	ld a,(hl)
	dec hl
	sub #1c ;inc e
	cp 2
	jr nc,remove3reincno
remove3reincdel
	dec hl
	ld a,(hl)
	cp #14 ;inc d
	jr z,remove3reinch
	cp #57 ;ld d,a (end of dde)
	jr nz,remove3reincno
remove3reincdhl
	push bc
	ld bc,-2-redhlsize ;-18
	add hl,bc
	pop bc
remove3reinch
	dec hl
	dec hl
	ld a,(hl)
	dec hl
	sub #1c ;inc e
	cp 2
	jr nc,remove3reincno
remove3reincyes
	pop af
	jp genredde
remove3reincno
	pop hl
	ret
	
;remove inc l's or dec l's
removereinc
	inc c
	dec c
	ret z ;nothing changed
removereinc0
	dec hl
	ld a,(hl)
	cp #2c ;inc l
	jr z,removereinc0
	cp #2d ;dec l
	jr z,removereinc0
	cp #1c ;inc e
	jr z,removereinc0
	cp #1d ;dec e
	jr z,removereinc0
	inc hl
	ret
		endif ;anybg
	
	ALIGN 4
ballspr
;pearl: 60844
;black with white back: 60745
;black w/o white back: 60173
	if 1>0 ;black
	if 1>0 ;black w/o white back
	db %00000111,%00000111,%11100000,%11100000
	db %00011111,%00010101,%11111000,%01111000
	db %00111111,%00101000,%11111100,%10111100
	db %01111111,%01010000,%11111110,%01101110
	db %01111111,%00100000,%11111110,%10111110
	db %11111111,%11000000,%11111111,%01010111
	db %11111111,%10000000,%11111111,%10111111
	db %11111111,%11000001,%11111111,%01010111
	db %11111111,%10101010,%11111111,%11111111
	db %11111111,%11010101,%11111111,%01011111
	db %11111111,%11111111,%11111111,%11111111
	db %01111111,%01110101,%11111110,%01111110
	db %01111111,%01111111,%11111110,%11111110
	db %00111111,%00111111,%11111100,%11111100
	db %00011111,%00011111,%11111000,%11111000
	db %00000111,%00000111,%11100000,%11100000
	else ;black with white back
	db %00000111,%00000111,%11100000,%11100000
	db %00011111,%00010101,%11111000,%01111000
	db %00111111,%00101000,%11111100,%10111100
	db %01111111,%01010000,%11111110,%01101110
	db %01111111,%00100000,%11111110,%10111110
	db %11111111,%11000000,%11111111,%01010111
	db %11111111,%10000000,%11111111,%10111111
	db %11111111,%11000001,%11111111,%01010111
	db %11111111,%10101010,%11111111,%11111111
	db %11111111,%11010101,%11111111,%01011111
	db %11111111,%11111111,%11111111,%11111101
	db %01111111,%01110101,%11111110,%01111110
	db %01111111,%01111111,%11111110,%11111010
	db %00111111,%00111111,%11111100,%11110100
	db %00011111,%00011111,%11111000,%11011000
	db %00000111,%00000111,%11100000,%11100000
	endif
	else ;pearl
	db %00000111,%00000101,%11100000,%11100000
	db %00011111,%00010101,%11111000,%01111000
	db %00111111,%00101000,%11111100,%10111100
	db %01111111,%01000000,%11111110,%01101110
	db %01111111,%00100000,%11111110,%10111110
	db %11111111,%11000000,%11111111,%01010111
	db %11111111,%00000000,%11111111,%10111111
	db %11111111,%11000001,%11111111,%01010111
	db %11111111,%10101000,%11111111,%11111011
	db %11111111,%11010101,%11111111,%01010111
	db %11111111,%11111111,%11111111,%11101011
	db %01111111,%01110101,%11111110,%01000110
	db %01111111,%01111111,%11111110,%10101110
	db %00111111,%00111111,%11111100,%01011100
	db %00011111,%00011111,%11111000,%11111000
	db %00000111,%00000111,%11100000,%11100000
	endif
                          
	include "bg.asm"


;=====================================
	ds #7800-$
	org #7800
maingo
	
	ld hl,#4000
	ld de,#6000
	ld bc,#1800
	ldir

mainloop
	;halt

	ld ix,COORDS;+128
xsinst=$+1
	ld de,xsin
ysinst=$+1
	ld hl,ysin
	;ld ly,BALLS
	;ld bc,const_b*256+const_c
	call mainpr0
	
	halt

	ld ix,COORDS;+128	
	;ld ly,BALLS
	if ((reconst_b*256+reconst_c)!=(const_b*256+const_c))
	ld bc,reconst_b*256+reconst_c
	endif
	call mainre0
	
	ld hl,xsinst
	ld a,(hl)
	add a,1
	if nomove==0
	ld (hl),a
	endif
	ld hl,ysinst
	ld a,(hl)
	add a,2
	if nomove==0
	ld (hl),a
	endif

	jp mainloop



mainpr0
	ld a,(de) ;L(x)
	add a,(hl) ;L(y)
	inc h
	ld b,(hl);ld h,(hl) ;H(y)
	ld c,a;ld l,a
	inc d
	ld a,(de) ;(x&7)*8+#c0
	dec d
	xor b;h ;(h&7)==(y&7)
	;if (const_c==%11111000)
	;and c
	;else
	and %11111000
	;endif
	xor b;h
	ld (ix-(2*BALLS)),c;l
	ld (ix-BALLS),b;h
	ld (ix),a
	;ld (mainprcall+1),a	
;mainprcall=$+1
	;call PROGS
	push bc
	ld b,a
	ld c,PROGS&255
	push bc
	dec h ; ,      
	ld a,l
	add a,8
	ld l,a
	ld a,e
	sub 7
	ld e,a
	inc lx
	;jp p,mainpr0
	jp nz,mainpr0
	ifdef _const_d
	ld de,const_d*256+const_e
	endif
	ld bc,const_b*256+const_c
	ret

;        (ix+),    
; (36+50+18)*BALLS+30+27+27 ~ 3000t ( )
mainre0
	ld l,(ix-(2*BALLS))
	ld h,(ix-BALLS)
	ld a,(ix) ;(x&7)*8+(y&7)+#c0
		if anybg
	ld d,h
	ld e,l
	set 5,h
	sub #40
	ld (mainrecall+1),a
		else ;~anybg
	;a=(y&7)*8+(x&7)+#c0 ;(   )
	xor l
	if (const_c==%11111000)
	and c
	else
	and %11111000
	endif
	xor l
	sub #40
	;hsb=#80+(y&7)*8+((x/8)&7)
	ld (mainrecall+1),a
	ld a,l
	rlca
	and #40
	rlca
	;lsb=(y&8)*#80
	ld (mainrecall),a
		endif ;~anybg
mainrecall=$+1
	call PROGS-#4000
	inc lx
	;jp p,mainre0
	jp nz,mainre0
	ret

ON_INT
	;push af,bc,de,hl
	;push ix,iy
	;ld a,(curpg)
	;push af
	;ld a,pgmuz
	;call OUTA
	;;call muz+5
	;pop af
	;call OUTA
	;pop iy,ix
	;pop hl,de,bc,af
	ei
	ret

	ALIGN 256
xsin
	INCBIN "xsin"
	ds 256
ysin
	INCBIN "ysin"
	ds 256
end

	display "Size ",/d,end-begin," bytes"
	
	savebin "code.c",begin,end-begin
	
	LABELSLIST "us/user.l"