	device pentagon1024

STACK=#5fe0;#be00
IMVEC=#3bff
;IMVEC=#fe00;#be00
IMER=#ffc0;#fdfd;#bfbf

NU1=45;#c9
NU2=54;#33
NU1DOWN=19;#c9
NU2DOWN=25;#9c;#96

scrbufhgt=200
scrbuf=#e000 ;,   200 
attrbuf=scrbuf+(32*scrbufhgt) ;,   25 

;  192*4      192*4  
;192*3 -  
;192*1 - , 
;192*1/2 - 
;192*3 -  
;192*1/2 - 
	
	org #6000
begin
muz
	include "pt3play.asm"
module
	incbin "testmusic.pt3"

	ds #8f00-$
	;org #8f00

	;xor a
	ld a,1
	out (#fe),a
	ld hl,#4000
	ld de,#4001
	ld bc,#17ff
	ld (hl),l
	ldir
	ld hl,#5800
	ld de,#5801
	ld bc,#2ff
	ld (hl),7
	ldir

	;ld (#5d10),a
	;ld (iy+1),#cc
	ld sp,STACK

	ld hl,module
	call pt3player.INIT

	ld hl,ON_INT
	ld de,IMER
	ld bc,szimer
	ldir

	if IMVEC==#3bff
       ;LD hl,#c9fb
       ;LD (#fff4),hl
	   ld a,#c3
	   ld (#fff4),a
       ld hl,IMER;ON_INT
       ld (#fff5),hl
	   ld a,#18
	   ld (#ffff),a
	else
       ld hl,ON_INT
       ld (IMVEC+255),hl
	endif
	ld a,IMVEC/256
    ld i,a
    im 2
    ;ei 

	
	jp maingo



;=====================================
	ds #9000-$
	org #9000
maingo
	
	
	ei
	halt
	;ld hl,(timer)
	;ld (oldtimer),hl

	ld hl,#5800
	ld de,#5801
	ld bc,#2ff
	ld (hl),l
	ldir

	 ;jp night

	ld iy,NU1*256+NU2

	ld hl,pakscr
	ld de,scrbuf+#17e0;#57e0
	ld b,192
depk0
	push bc
	push de
	call depkline
	pop de
	;call ude
	ld a,e
	sub 32
	ld e,a
	jr nc,$+3
	dec d
	pop bc
	djnz depk0

	push hl
	exx
	ld hl,pakattr
	ld de,attrbuf+#2e0;#5ae0
	ld b,24
depkattr0
	push bc
	push de
	ld bc,32
	ldir
	pop de
	ld a,e
	sub 32
	ld e,a
	jr nc,$+3
	dec d
	pop bc
	djnz depkattr0
	ld (curdepkattraddr),hl
	exx
	pop hl

	ld b,192
mainloop
	push bc

	ld a,b
	cp 32
	call z,drawlogo

scrolldownaddr=$+1
	call scrolldown_virtual
	pop bc

	if 1==0
	ld a,b
	sub 32
	jr nz,nlogocycle
	ld (#4887),a
nlogocycle
	endif

	djnz mainloop

	jp $

;;;;;;;;;;;;;;;;;;;;;;;;;;;;NIGHT
night
	ld hl,pakscrdown
	ld de,pakscr
	call #5b00
	ld hl,pakattrdown
	ld de,pakattr
	call #5b00

	ld hl,pakscr
	ld de,#4000;#57e0
	ld b,192
depkdown0
	push bc
	push de
	ld iy,NU1DOWN*256+NU2DOWN
	call depkline
	pop de
	call dde
	pop bc
	djnz depkdown0

	push hl
	exx
	ld hl,pakattrend-1
	ld de,#581f;#5ae0
	ld b,24
depkattrdown0
	push bc
	push de
	ld bc,32
	lddr
	pop de
	ld a,e
	add a,32;sub 32
	ld e,a
	jr nc,$+3
	inc d;dec d
	pop bc
	djnz depkattrdown0
	exx
	pop hl

	ld b,192
mainloopdown
	;halt
	push bc
	push hl
linecountdown=$+1
	ld a,%00000001
	rlca
	ld (linecountdown),a
	jr c,loopdown_scrollattr
	call scrollup
	jr loopdown_scrollok
loopdown_scrollattr
	call scrollupwithattr
	exx
	ld de,#5aff;#5800
	ld bc,32
	lddr
	exx
loopdown_scrollok
	pop hl
	ld de,#57e0;#4000
	ld iy,NU1DOWN*256+NU2DOWN
	call depkline
	pop bc
	djnz mainloopdown
	jp $

depkline
	ld ix,counters
	ld b,32
depk1
	ld a,(ix)
	or a ;counter=0?
	jr nz,depk1counternz
	ld a,(hl)
	inc hl
	cp hy;NU1
	ld c,0
	jr z,depk1counterNU
	cp ly;NU2
	jr nz,depk1counterwr
	dec c ;ld c,255
depk1counterNU
	ld a,(hl)
	inc hl
	ld (ix),a ;counter
	ld (ix+1),c ;curbyte
	ld a,c
	jr depk1counterwr
depk1counternz
	dec (ix) ;counter--
	ld a,(ix+1) ;curbyte
depk1counterwr
	ld (de),a
depk1counterok
	inc e
	inc ix
	inc ix
	djnz depk1
	ld (curdepkaddr),hl
	ret


ldi32attr
	exx
	dup 32
	ldi
	edup
	ex af,af'
	dec a
	jr nz,ldi32attr_nbeg
	ld hl,attrbuf
ldi32attr_nbeg
	ex af,af'
	exx
ldi32frombuf
	pop de
	dup 32
	ldi ; 24    ?
	edup
	
	dec a
	ret nz
	ld hl,scrbuf
	;exx
	;ld hl,attrbuf
	;exx
	ret

; 200 (.  0):
;  0
; 0

; 199 (.  1):
;  0
; 1
; 0    8
;...
; 193 (.  7):
;  0
; 7
; 0    8..14

; 192 (.  8):
;  1
; 8


showbufstack
_line=0
	 dup 24

_to=#4000+((_line&#c0)/#40*#800)+((_line&#38)/#08*#20)+((_line&#07)*#100)
	dw ldi32attr
	dw _to
_line=_line+1

	dup 7
_to=#4000+((_line&#c0)/#40*#800)+((_line&#38)/#08*#20)+((_line&#07)*#100)
	dw ldi32frombuf
	dw _to
_line=_line+1
	edup

	 edup
	dw showbufq
szshowbufstack=$-showbufstack

showbuf
	ld (showbufsp),sp
	;di
	ld hl,showbufstack
	ld de,tempstack-szshowbufstack
_part=470
	ld bc,szshowbufstack-_part
	ldir
	halt
	ld bc,_part
	ldir
;   ,      
	ld sp,tempstack-szshowbufstack
showbufphase=$+1
	ld a,0 ;  0..scrbufhgt-1
	push af
	add a,7 ;   ()
	cp scrbufhgt
	jr c,$+4
	sub scrbufhgt
	;sub 7
	;jr nc,$+4
	;add a,scrbufhgt
	ld l,a
	cpl
	add a,scrbufhgt;+1
	rra
	rra
	rra
	and #1f
	 inc a
	ex af,af'
	pop af
	ld h,0
	res 0,l
	res 1,l
	res 2,l
	add hl,hl
	add hl,hl
	ld de,attrbuf
	add hl,de
	ld de,#5800
	exx
	ld l,a
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	ld de,scrbuf
	add hl,de
	cpl ;a=-1..-scrbufhgt    0..scrbufhgt-1
	add a,scrbufhgt+1
	;a=scrbufhgt..1    0..scrbufhgt-1
	ret
showbufq
showbufsp=$+1
	ld sp,0
	;ei
	ret

scrolldown_virtual
;    showbufphase
;showbufphase=showbufphase-1 (   scrbufhgt-1)
;    showbufphase
; showbufphase mod 7 = 7
;     showbufphase
;
;    showbufphase
	call showbuf
;showbufphase=showbufphase-1 (   scrbufhgt-1)
	ld hl,showbufphase
	ld a,(hl)
	sub 1
	jr nc,$+4
	ld a,scrbufhgt-1
	ld (hl),a
;    showbufphase
	ld l,a
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	ld de,scrbuf
	add hl,de
	ex de,hl
curdepkaddr=$+1
	ld hl,0
	call depkline
; showbufphase mod 7 = 7
	ld a,(showbufphase)
	cpl
	and 7
	ret nz
;     showbufphase
	ld a,(showbufphase)
	ld l,a
	ld h,0
	res 0,l
	res 1,l
	res 2,l
	add hl,hl
	add hl,hl
	ld de,attrbuf
	add hl,de
	ex de,hl
curdepkattraddr=$+1
	ld hl,0
	ld bc,32
	ldir
	ld (curdepkattraddr),hl
	ret


scrolldown
	ld hl,#57e0
	ld b,191
scrolldown0
	push bc
	ld d,h
	ld e,l
	call ude
	ex de,hl
	push hl
	dup 31
	ldi
	edup
	ld a,(hl)
	ld (de),a
	pop hl
	pop bc
	djnz scrolldown0
	ret
	
scrolldown_skiplogo
	ld hl,#57e0
	ld b,191
scrolldown_skiplogo0
	push bc
	ld d,h
	ld e,l
	call ude
	ex de,hl
	push hl
	ld a,b
	sub 56
	cp 41;40
	jr nc,scrolldown_skiplogoldir
	ld bc,6
	ldir
	ld c,20
	add hl,bc
	ex de,hl
	add hl,bc
	ex de,hl
	ld c,6
	ldir
	pop hl
	pop bc
	djnz scrolldown_skiplogo0
	ret
scrolldown_skiplogoldir
	dup 31
	ldi
	edup
	ld a,(hl)
	ld (de),a
	pop hl
	pop bc
	djnz scrolldown_skiplogo0
	ret
	
scrolldownwithattr
	ld hl,#57e0
	ld b,191
scrolldownwithattr0
	push bc
	ld d,h
	ld e,l
	call ude
	ex de,hl
	push hl
	dup 32
	ldi
	edup
	pop hl
	pop bc
	ld a,b
	and 7
	jr nz,scrolldownwithattr_nattr
;hl     "" ( )
;       
	push bc
	push hl
	ld a,h
	rra
	rra
	rra
	and 3
	add a,#58
	ld h,a
	ld d,h
	ld e,l
	ld bc,32
	add hl,bc
	ex de,hl
	dup 32
	ldi
	edup
	pop hl
	pop bc
scrolldownwithattr_nattr
	dec b
	jp nz,scrolldownwithattr0
	ret

scrolldownwithattr_skiplogo
	ld hl,#57e0
	ld b,191
scrolldownwithattr_skiplogo0
	push bc
	ld d,h
	ld e,l
	call ude
	ex de,hl
	push hl
	ld a,b
	sub 56
	cp 41;40
	ld bc,32
	jr nc,scrolldownwithattr_skiplogoldir
	ld c,6
	ldir
	ld c,20
	add hl,bc
	ex de,hl
	add hl,bc
	ex de,hl
	ld c,6
scrolldownwithattr_skiplogoldir
	ldir
	pop hl
	pop bc
	ld a,b
	and 7
	jr nz,scrolldownwithattr_skiplogo_nattr
;hl     "" ( )
;       
	push hl
	ld a,h
	rra
	rra
	rra
	and 3
	add a,#58
	ld h,a
	ld d,h
	ld e,l
	ld a,b
	push bc
	ld bc,32
	add hl,bc
	ex de,hl
	sub 56
	cp 40
	;ld bc,32
	jr nc,scrolldownwithattr_skiplogoattrldir
	ld c,6
	ldir
	ld c,20
	add hl,bc
	ex de,hl
	add hl,bc
	ex de,hl
	ld c,6
scrolldownwithattr_skiplogoattrldir
	ldir
	pop bc
	pop hl
scrolldownwithattr_skiplogo_nattr
	djnz scrolldownwithattr_skiplogo0
	ret


scrollup
	ld hl,#4000;#57e0
	ld b,191
scrollup0
	push bc
	ld d,h
	ld e,l
	call dde
	ex de,hl
	push hl
	dup 32
	ldi
	edup
	pop hl
	pop bc
	djnz scrollup0
	ret

	
scrollupwithattr
	ld hl,#4000;#57e0
	ld b,191
scrollupwithattr0
	push bc
	ld d,h
	ld e,l
	call dde
	ex de,hl
	push hl
	ld a,b
	sub 191-56
	cp -40
	ld bc,32
	jr c,scrollupwithattr_skiplogoldir
	ld c,6
	ldir
	ld c,20
	add hl,bc
	ex de,hl
	add hl,bc
	ex de,hl
	ld c,6
scrollupwithattr_skiplogoldir
	ldir
	pop hl
	pop bc
	ld a,b
	and 7
	jr nz,scrollupwithattr_nattr
;hl     "" ( )
;       
	push bc
	push hl
	ld a,h
	rra
	rra
	rra
	and 3
	add a,#58
	ld h,a
	ld d,h
	ld e,l
	ld bc,-32
	add hl,bc
	ex de,hl
	dup 32
	ldi
	edup
	pop hl
	pop bc
scrollupwithattr_nattr
	djnz scrollupwithattr0
	ret

drawlogo
	ld hl,scrolldown_skiplogo
	ld (scrolldownaddr),hl
	;ld hl,scrolldownwithattr_skiplogo
	;ld (scrolldownwithattraddr),hl
	ld hl,newvlogo
	ld de,#40e6
	ld b,40
drawlogo0
	push bc
	push de
	ld bc,20
	ldir
	pop de
	call dde
	pop bc
	djnz drawlogo0
	ld de,#58e6
	ld b,5
drawlogoattr0
	push bc
	ld bc,20
	ldir
	ld c,32-20
	ex de,hl
	add hl,bc
	ex de,hl
	pop bc
	djnz drawlogoattr0

	ret


ude
	ld a,d
	dec d
	and 7
	ret nz
	ld a,e
	sub 32
	ld e,a
	ret c
	ld a,d
	add a,8
	ld d,a
	ret

dde
	inc d
	ld a,d
	and 7
	ret nz
	ld a,e
	add a,32
	ld e,a
	ret c
	ld a,d
	sub 8
	ld d,a
	ret

	
ON_INT
	disp IMER
	;if IMVEC!=#3bff
	push af,bc,hl
	ld hl,(timer)
	inc hl
	ld (timer),hl
	push de
	push ix
	ex af,af'
	push af
	;push iy ;not used by the replayer
	call pt3player.PLAY
	;pop iy ;not used by the replayer
	pop af
	ex af,af'
	pop ix
	pop de
	pop hl,bc,af
	ei
	ret
	;endif
timer
	dw 0
	ent
szimer=$-ON_INT

counters
	ds 32*2 ;32*(counter,curbyte)
newvlogo
	incbin "NEWVLOGO.$C!"
pakscr
	incbin "mkskyscroll\skyscr.dat"
pakattr
tempstack=pakattr+768 ;grows down for 386+some bytes
	incbin "mkskyscroll\skyattr.dat"
pakattrend
pakscrdown
	incbin "mkskyscroll\skyscrdown.dat.mlz"
pakattrdown
	incbin "mkskyscroll\skyattrdown.dat.mlz"

end

	display "End ",end
	display "Size ",/d,end-begin," bytes"
	
	savebin "code.c",begin,end-begin
	
	LABELSLIST "us/user.l"
