;--------------------------------
;generate sprite remove procedure
;zigzag output
;a procedure for each x&7, y&7, total of 64
;longest procedure: #a101,#d (optimized to #93)
genrespr
;a=y
;hl=spr
;hl'=code
	exx
	ld d,a ;Y
	ld c,0 ;nothing changed
	ld e,0 ;no lines generated
	ld b,16
	ld (hl),#e1 ;pop hl
	inc hl
	ld (hl),#54 ;ld d,h
	inc hl
	ld (hl),#5d ;ld e,l
	inc hl
	ld (hl),#cb
	inc hl
	ld (hl),#ec ;set 5,h
	inc hl
	exx
	jp genrespr1go
genrespr1
	inc e
	inc d
	call genredde
	exx
	pop hl
	inc hl
genrespr1go
	ld a,(hl)
	inc hl
	ld b,(hl)
	inc hl
	ld d,(hl)
	inc hl
	inc hl
	inc hl
	push hl
;a,b,d=mask(or)
	exx
	bit 0,b
	exx
	jr nz,genresprdec
genresprinc
	push bc
	;ld a,a
	call genrebyte ;a=mask(or)
	exx
	ld (hl),#2c ;inc l
	inc hl
	ld (hl),#1c ;inc e
	inc hl
	call remove3reinc
	exx
	pop bc
	ld a,b
	call genrebyte ;a=mask(or)
	exx
	ld (hl),#2c ;inc l
	inc hl
	ld (hl),#1c ;inc e
	inc hl
	exx
	ld a,d
	call genrebyte ;a=mask(or)
	jr genrespridq
genresprdec
	push af
	push bc
	ld a,d
	call genrebyte ;a=mask(or)
	exx
	ld (hl),#2d ;dec l
	inc hl
	ld (hl),#1d ;dec e
	inc hl
	call remove3reinc
	exx
	pop bc
	ld a,b
	call genrebyte ;a=mask(or)
	exx
	ld (hl),#2d ;dec l
	inc hl
	ld (hl),#1d ;dec e
	inc hl
	exx
	pop af
	;ld a,a
	call genrebyte ;a=mask(or)
genrespridq
	exx
	djnz genrespr1
	exx
	pop hl
	inc hl
	exx
	call removereinc
	ld (hl),#c9 ;ret
	inc hl
	exx
	ret

genredhl
	ld (hl),#24 ;inc h
	inc hl
	ld a,d
	and 7
	ret nz
;ld a,l:sub -32:ld l,a:sbc a,a:and -8:add a,h:ld h,a
	ld (hl),#7d ;ld a,l
	inc hl
	ld (hl),#d6 ;sub
	inc hl
	ld (hl),-32
	inc hl
	ld (hl),#6f ;ld l,a
	inc hl
	ld (hl),#9f ;sbc a,a
	inc hl
	ld (hl),#e6 ;and
	inc hl
	ld (hl),-8
	inc hl
	ld (hl),#84 ;add a,h
	inc hl
	ld (hl),#67 ;ld h,a
	inc hl
	ret
redhlsize=9
	
genredde
	call genredhl
	ld (hl),#14 ;inc d
	inc hl
	ld a,d
	and 7
	ret nz
;sub #20:ld d,a:ld e,l
	dec hl ;skip inc d
	;ld (hl),#54 ;ld d,h
	;inc hl
	;ld (hl),#cb
	;inc hl
	;ld (hl),#aa ;res 5,d
	;inc hl
	ld (hl),#d6 ;sub
	inc hl
	ld (hl),#20
	inc hl
	ld (hl),#57 ;ld d,a
	inc hl
	ld (hl),#5d ;ld e,l
	inc hl
	ret

genrebyte
;a=mask(or)
	or a
	ret z
;ld a,(hl):ld (de),a ;or!=0
	exx
	ld (hl),#7e ;ld a,(hl)
	inc hl
	ld (hl),#12 ;ld (de),a
	inc hl
	inc c ;something changed
	exx
	ret

genreopt
;ld a,(hl):ld (de),a:inc l:inc e
;to ldi
;ld a,(hl):ld (de),a:dec l:dec e
;to ldd
genreopt0
genreoptldld
	ld a,(hl)
	cp #7e ;ld a,(hl)
	jr nz,genreoptn
genreopty
	ldi
	ldi
	ld a,(hl)
	sub #2c ;inc l
	cp 2
	jr nc,genreoptldld
	add a,a
	add a,a
	add a,a
	add a,#a0 ;ldi
	dec de
	dec de
	ld (hl),#ed
	ldi
	ld (hl),a
	ldi
	jr genreopt0
genreoptn
	ld a,(hl)
	cp #c9 ;ret
	jr z,genreoptq
	cp #7e ;ld a,(hl)
	jr z,genreopty
	ldi
	jr genreoptn
genreoptq
	ldi
	ret

;remove inc l:dhl:dec l or dec l:dhl:inc l
;change to dhl
remove3reinc
	;ret
	inc e
	dec e
	ret z ;no lines generated
	push hl
	dec hl
	ld a,(hl)
	dec hl
	sub #1c ;inc e
	cp 2
	jr nc,remove3reincno
remove3reincdel
	dec hl
	ld a,(hl)
	cp #14 ;inc d
	jr z,remove3reinch
	cp #57 ;ld d,a (end of dde)
	jr nz,remove3reincno
remove3reincdhl
	push bc
	ld bc,-2-redhlsize ;-18
	add hl,bc
	pop bc
remove3reinch
	dec hl
	dec hl
	ld a,(hl)
	dec hl
	sub #1c ;inc e
	cp 2
	jr nc,remove3reincno
remove3reincyes
	pop af
	jp genredde
remove3reincno
	pop hl
	ret
	
;remove inc l's or dec l's
removereinc
	inc c
	dec c
	ret z ;nothing changed
removereinc0
	dec hl
	ld a,(hl)
	cp #2c ;inc l
	jr z,removereinc0
	cp #2d ;dec l
	jr z,removereinc0
	cp #1c ;inc e
	jr z,removereinc0
	cp #1d ;dec e
	jr z,removereinc0
	inc hl
	ret
